=== modified file 'DBUS-API'
--- DBUS-API	2015-05-23 20:18:34 +0000
+++ DBUS-API	2012-01-15 20:27:28 +0000
@@ -134,10 +134,10 @@
    k) A raw byte array, not hexadecimal digits.
 
 ** Signals
-*** CheckerCompleted(n: Exitcode, x: Signal, s: Command)
+*** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
     A checker (Command) has completed.  Exitcode is either the exit
-    code or -1 for abnormal exit, in which case, the signal number
-    is available.
+    code or -1 for abnormal exit.  In any case, the full Waitstatus
+    (as from wait(2)) is also available.
     
 *** CheckerStarted(s: Command)
     A checker command (Command) has just been started.
@@ -150,13 +150,16 @@
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
     
+*** PropertyChanged(s: Property, v: Value)
+    The Property on this client has changed to Value.
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
 * Copyright
 
-    Copyright © 2010-2015 Teddy Hogeborn
-    Copyright © 2010-2015 Björn Påhlsson
+    Copyright © 2010-2012 Teddy Hogeborn
+    Copyright © 2010-2012 Björn Påhlsson
   
 ** License:
    

=== modified file 'INSTALL'
--- INSTALL	2014-07-25 22:44:20 +0000
+++ INSTALL	2011-03-08 19:09:03 +0000
@@ -4,16 +4,15 @@
   
 ** Operating System
    
-   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat" (or later).
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
-   and that the initial RAM file system image file is automatically
-   made unreadable.  The server and client programs themselves *could*
-   be run in other distributions, but they *are* specific to GNU/Linux
-   systems, and are not written with portabillity to other Unixes in
-   mind.
-   
+   and that the initrd.img file is automatically made unreadable.  The
+   server and client programs themselves *could* be run in other
+   distributions, but they *are* specific to GNU/Linux systems, and
+   are not written with portabillity to other Unixes in mind.
+  
 ** Libraries
    
    The following libraries and packages are needed.  (It is possible
@@ -28,7 +27,7 @@
     + DocBook 4.5         http://www.docbook.org/
       Note: DocBook 5.0 is not compatible.
     + DocBook XSL stylesheets 1.71.0
-                         http://wiki.docbook.org/DocBookXslStylesheets
+                   http://wiki.docbook.org/topic/DocBookXslStylesheets
     
     Package names:
     docbook docbook-xsl
@@ -36,42 +35,34 @@
     To build just the documentation, run the command "make doc".  Then
     the manual page "mandos.8", for example, can be read by running
     "man -l mandos.8".
-    
+   
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnutls.org/
-      Note: GnuTLS 3 will only work with Python-GnuTLS 2
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.7          https://www.python.org/
-    + Python-GnuTLS 1.1.5 https://pypi.python.org/pypi/python-gnutls/
+    + Python 2.6          http://www.python.org/
+    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + PyGObject 2.14.2    https://developer.gnome.org/pygobject/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    + Urwid 1.0.1         http://urwid.org/
-      (Only needed by the "mandos-monitor" tool.)
+    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
-    + fping 2.4b2-to-ipv6      http://www.fping.org/
-    + ssh-keyscan from OpenSSH http://www.openssh.com/
+    + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-gobject python-urwid pkg-config fping ssh-client
-    
+    python-gobject python-urwid
+   
 *** Mandos Client
     + initramfs-tools 0.85i
-                        https://tracker.debian.org/pkg/initramfs-tools
-    + GnuTLS 2.4        http://www.gnutls.org/
-    + Avahi 0.6.16      http://www.avahi.org/
-    + GnuPG 1.4.9       https://www.gnupg.org/
-    + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    
-    Strongly recommended:
-    + OpenSSH           http://www.openssh.com/
+                  http://packages.qa.debian.org/i/initramfs-tools.html
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
+    + Avahi 0.6.16        http://www.avahi.org/
+    + GnuPG 1.4.9         http://www.gnupg.org/
+    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
     
     Package names:
     initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev pkg-config ssh
+    libgpgme11-dev
 
 * Installing the Mandos server
   
@@ -107,11 +98,15 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use any special configuration needed for
-     your local system.  Note: This is not necessary if the server is
-     present on the same wired local network as the client.  If you do
-     make changes to /etc/mandos/plugin-runner.conf, the initrd.img
-     file must be updated, possibly using the following command:
+  4. Configure the client to use the correct network interface.  The
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
@@ -131,14 +126,12 @@
      
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
-     take more than five minutes to reboot.
+     take more than an hour to reboot.
 
 * Further customizations
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used and SSH is not installed, it is suggested that
-  a more cryptographically secure checker program is used and
-  configured, since, without IPsec, ping packets can be faked.
-
-#+STARTUP: showall
+  If IPsec is not used, it is suggested that a more cryptographically
+  secure checker program is used and configured, since without IPsec
+  ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2014-10-05 20:08:58 +0000
+++ Makefile	2012-06-01 18:39:03 +0000
@@ -1,17 +1,14 @@
-WARN=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
-	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
-	-Wunused -Wuninitialized -Wstrict-overflow=5 \
-	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
-	-Wsuggest-attribute=noreturn -Wfloat-equal -Wundef -Wshadow \
+WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs \
+	-Wswitch-default -Wswitch-enum -Wunused-parameter \
+	-Wstrict-aliasing=1 -Wextra -Wfloat-equal -Wundef -Wshadow \
 	-Wunsafe-loop-optimizations -Wpointer-arith \
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
-	-Wconversion -Wlogical-op -Waggregate-return \
-	-Wstrict-prototypes -Wold-style-definition \
-	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
-	-Wredundant-decls -Wnested-externs -Winline -Wvla \
-	-Wvolatile-register-var -Woverlength-strings
+	-Wconversion -Wstrict-prototypes -Wold-style-definition \
+	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
+#	-Wunreachable-code
 #DEBUG=-ggdb3
-# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
+# For info about _FORTIFY_SOURCE, see
+# <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
 # and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 LINK_FORTIFY_LD=-z relro -z now
@@ -23,10 +20,10 @@
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage
-OPTIMIZE=-Os -fno-strict-aliasing
+OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.9
+version=1.5.5
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -39,7 +36,6 @@
 # MANDIR=$(PREFIX)/man
 # INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
 # STATEDIR=$(DESTDIR)/var/lib/mandos
-# LIBDIR=$(PREFIX)/lib
 ##
 
 ## These settings are for a package-type install
@@ -49,19 +45,8 @@
 MANDIR=$(PREFIX)/share/man
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
 STATEDIR=$(DESTDIR)/var/lib/mandos
-LIBDIR=$(shell \
-	for d in \
-	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
-	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
-		if [ -d "$$d" -a "$$d" = "$${d%/}" ]; then \
-			echo "$(DESTDIR)$$d"; \
-			break; \
-		fi; \
-	done)
 ##
 
-SYSTEMD=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
-
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
 GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
 AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
@@ -71,10 +56,10 @@
 	getconf LFS_LDFLAGS)
 
 # Do not change these two
-CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
+CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
 	-DVERSION='"$(version)"'
-LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -83,12 +68,15 @@
 	--param make.single.year.ranges		1 \
 	--param man.output.quietly		1 \
 	--param man.authors.section.enabled	0 \
-	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
+	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
-	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
-	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
-	fi >/dev/null)
+	$(MANPOST) $(notdir $@);\
+	if locale --all | grep --regexp='^en_US\.utf8$$' && type man \
+	2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 man \
+	--warnings --encoding=UTF-8 --local-file $(notdir $@); fi \
+	>/dev/null)
+# DocBook-to-man post-processing to fix a '\n' escape bug
+MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
 DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
@@ -239,11 +227,9 @@
 	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
 		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
-.PHONY : all doc html clean distclean mostlyclean maintainer-clean \
-	check run-client run-server install install-html \
-	install-server install-client-nokey install-client uninstall \
-	uninstall-server uninstall-client purge purge-server \
-	purge-client
+.PHONY : all doc html clean distclean run-client run-server install \
+	install-server install-client uninstall uninstall-server \
+	uninstall-client purge purge-server purge-client
 
 clean:
 	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core
@@ -255,7 +241,6 @@
 
 check:	all
 	./mandos --check
-	./mandos-ctl --check
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
@@ -264,18 +249,15 @@
 	@echo "# ignored.  The messages are caused by not running as root, but   #"
 	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
 	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setgid: Operation not permitted             #"
-	@echo "#                     setuid: Operation not permitted             #"
+	@echo "# From plugin-runner: setuid: Operation not permitted             #"
 	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client:                                             #"
-	@echo "#             Failed to raise privileges: Operation not permitted #"
-	@echo "#             Warning: network hook \"*\" exited with status *      #"
+	@echo "# From mandos-client: setuid: Operation not permitted             #"
+	@echo "#                     seteuid: Operation not permitted            #"
+	@echo "#                     klogctl: Operation not permitted            #"
 	@echo "###################################################################"
-# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
-		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
@@ -296,7 +278,7 @@
 	install --directory confdir
 	install --mode=u=rw $< $@
 # Add a client password
-	./mandos-keygen --dir keydir --password --no-ssh >> $@
+	./mandos-keygen --dir keydir --password >> $@
 statedir:
 	install --directory statedir
 
@@ -309,12 +291,8 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
-	if install --directory --mode=u=rwx --owner=$(USER) \
-		--group=$(GROUP) $(STATEDIR); then \
-		:; \
-	elif install --directory --mode=u=rwx $(STATEDIR); then \
-		chown -- $(USER):$(GROUP) $(STATEDIR) || :; \
-	fi
+	install --directory --mode=u=rwx --owner=$(USER) \
+		--group=$(GROUP) $(STATEDIR)
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl
@@ -328,9 +306,6 @@
 		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 	install --mode=u=rwx,go=rx init.d-mandos \
 		$(DESTDIR)/etc/init.d/mandos
-	if [ "$(SYSTEMD)" != "$(DESTDIR)" -a -d "$(SYSTEMD)" ]; then \
-		install --mode=u=rw,go=r mandos.service $(SYSTEMD); \
-	fi
 	install --mode=u=rw,go=r default-mandos \
 		$(DESTDIR)/etc/default/mandos
 	if [ -z $(DESTDIR) ]; then \
@@ -350,36 +325,36 @@
 		> $(MANDIR)/man8/intro.8mandos.gz
 
 install-client-nokey: all doc
-	install --directory $(LIBDIR)/mandos $(CONFDIR)
+	install --directory $(PREFIX)/lib/mandos $(CONFDIR)
 	install --directory --mode=u=rwx $(KEYDIR) \
-		$(LIBDIR)/mandos/plugins.d
-	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
+		$(PREFIX)/lib/mandos/plugins.d
+	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
 	fi
 	install --mode=u=rwx,go=rx --directory \
 		"$(CONFDIR)/network-hooks.d"
 	install --mode=u=rwx,go=rx \
-		--target-directory=$(LIBDIR)/mandos plugin-runner
+		--target-directory=$(PREFIX)/lib/mandos plugin-runner
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-keygen
 	install --mode=u=rwx,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/password-prompt
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/mandos-client
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/usplash
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/splashy
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/askpass-fifo
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(LIBDIR)/mandos/plugins.d \
+		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
 		plugins.d/plymouth
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
@@ -431,13 +406,13 @@
 	! grep --regexp='^ *[^ #].*keyscript=[^,=]*/mandos/' \
 		$(DESTDIR)/etc/crypttab
 	-rm --force $(PREFIX)/sbin/mandos-keygen \
-		$(LIBDIR)/mandos/plugin-runner \
-		$(LIBDIR)/mandos/plugins.d/password-prompt \
-		$(LIBDIR)/mandos/plugins.d/mandos-client \
-		$(LIBDIR)/mandos/plugins.d/usplash \
-		$(LIBDIR)/mandos/plugins.d/splashy \
-		$(LIBDIR)/mandos/plugins.d/askpass-fifo \
-		$(LIBDIR)/mandos/plugins.d/plymouth \
+		$(PREFIX)/lib/mandos/plugin-runner \
+		$(PREFIX)/lib/mandos/plugins.d/password-prompt \
+		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
+		$(PREFIX)/lib/mandos/plugins.d/usplash \
+		$(PREFIX)/lib/mandos/plugins.d/splashy \
+		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
+		$(PREFIX)/lib/mandos/plugins.d/plymouth \
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
 		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
@@ -449,8 +424,8 @@
 		$(MANDIR)/man8/splashy.8mandos.gz \
 		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
 		$(MANDIR)/man8/plymouth.8mandos.gz \
-	-rmdir $(LIBDIR)/mandos/plugins.d $(CONFDIR)/plugins.d \
-		 $(LIBDIR)/mandos $(CONFDIR) $(KEYDIR)
+	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
+		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
 	update-initramfs -k all -u
 
 purge: purge-server purge-client
@@ -460,8 +435,6 @@
 		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 		$(DESTDIR)/etc/default/mandos \
 		$(DESTDIR)/etc/init.d/mandos \
-		$(SYSTEMD)/mandos.service \
-		$(DESTDIR)/run/mandos.pid \
 		$(DESTDIR)/var/run/mandos.pid
 	-rmdir $(CONFDIR)
 

=== modified file 'NEWS'
--- NEWS	2014-10-05 20:08:58 +0000
+++ NEWS	2012-06-01 18:39:03 +0000
@@ -1,98 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.9 (2014-10-05)
-* Server
-** Changed to emit standard D-Bus signal when D-Bus properties change.
-   (The old signal is still emitted too, but marked as deprecated.)
-
-Version 1.6.8 (2014-08-06)
-* Client
-** Bug fix: mandos-keygen now generates working SSH checker commands.
-* Server
-** Bug fix: "mandos-monitor" now really redraws screen on Ctrl-L.
-** Now requires Python 2.7.
-
-Version 1.6.7 (2014-07-17)
-* Client
-** Bug fix: Now compatible with GPGME 1.5.0.
-** Bug fix: Fixed minor memory leaks.
-* Server
-** "mandos-monitor" now has verbose logging, toggleable with "v".
-
-Version 1.6.6 (2014-07-13)
-* Client
-** If client host has an SSH server, "mandos-keygen --password" now
-   outputs "checker" option which uses "ssh-keyscan"; this is more
-   secure than the default "fping" checker.
-** Bug fix: allow "." in network hook names, to match documentation.
-** Better error messages.
-* Server
-** New --no-zeroconf option.
-** Bug fix: Fix --servicename option, broken since 1.6.4.
-** Bug fix: Fix --socket option work for --socket=0.
-
-Version 1.6.5 (2014-05-11)
-* Client
-** Work around bug in GnuPG <http://bugs.g10code.com/gnupg/issue1622>
-** Give better error messages when run without sufficient privileges
-** Only warn if workaround for Debian bug #633582 was necessary and
-   failed, not if it failed and was unnecessary.
-
-Version 1.6.4 (2014-02-16)
-* Server
-** Very minor fix to self-test code.
-
-Version 1.6.3 (2014-01-21)
-* Server
-** Add systemd support.
-** For PID file, fall back to /var/run if /run does not exist.
-* Client
-** Moved files from /usr/lib/mandos to whatever the architecture
-   specifies, like /usr/lib/x86_64-linux-gnu/mandos or
-   /usr/lib64/mandos.
-
-Version 1.6.2 (2013-10-24)
-* Server
-** PID file moved from /var/run to /run.
-** Bug fix: Handle long secrets when saving client state.
-** Bug fix: Use more magic in the GnuTLS priority string to handle
-   both old DSA/ELG 2048-bit keys and new RSA/RSA 4096-bit keys.
-* Client
-** mandos-keygen: Bug fix: now generate RSA keys which GnuTLS can use.
-   		  Bug fix: Output passphrase prompts even when
-   		  redirecting standard output.
-
-Version 1.6.1 (2013-10-13)
-* Server
-** All client options for time intervals now also take an RFC 3339
-   duration.  The same for all options to mandos-ctl.
-** Bug fix: Handle fast checkers (like ":") correctly.
-** Bug fix: Don't print output from checkers when running in
-   foreground.
-** Bug fix: Do not fail when client is removed from clients.conf but
-   saved settings remain.
-** Bug fix: mandos-monitor now displays standout (reverse video) again
-   using new version of Urwid.
-** Bug fix: Make boolean options work from the config file again.
-** Bug fix: Make --no-ipv6 work again.
-** New default priority string to be slightly more compatible with
-   older versions of GnuTLS.
-* Client
-** Bug fix: Fix bashism in mandos-keygen.
-** Default key and subkey types are now RSA and RSA, respectively.
-   Also, new default key size is 4096 bits.
-
-Version 1.6.0 (2012-06-18)
-* Server
-** Takes new --foreground option
-** Init script supports new "status" action.
-* Client
-** Now uses all interfaces by default; the --interface option can
-   still be used to restrict it, and the argument to --interface (as
-   well as the $DEVICE environment variable for the network hooks) is
-   now a comma-separated list of interfaces to use.
-
 Version 1.5.5 (2012-06-01)
 * Server
 ** Server takes new --socket option

=== modified file 'TODO'
--- TODO	2015-05-22 20:23:46 +0000
+++ TODO	2012-05-26 22:21:17 +0000
@@ -1,31 +1,17 @@
 -*- org -*-
 
-* GIT
-** General: [[https://www.atlassian.com/git/workflows][Git Workflows]], [[http://gitimmersion.com/][Git Immersion]], [[https://news.ycombinator.com/item?id=7036628][Simple git workflow is simple]]
-** Intro: [[http://www.eyrie.org/~eagle/notes/debian/git.html#combine][Using Git for Debian Packaging]]
-** Use: [[https://honk.sigxcpu.org/piki/projects/git-buildpackage/][git-buildpackage]]
-** Migration
-   tailor?
-   Using bzr-fastimport: [[http://www.fusonic.net/en/blog/2013/03/26/migrating-from-bazaar-to-git/][Migrating from Bazaar to Git]]
-** Unresolved: [[http://jameswestby.net/bzr/builddeb/user_manual/split.html][bzr builddeb split mode]]
-   Maybe: [[http://honk.sigxcpu.org/projects/git-buildpackage/manual-html/gbp.import.html#GBP.IMPORT.UPSTREAM.GIT.NOTARBALL][git-buildpackage - No upstream tarballs]]
-   [[http://www.python.org/dev/peps/pep-0374/][PEP 374 - Choosing a distributed VCS for the Python project]]
-   [[http://www.emacswiki.org/emacs/GitForEmacsDevs][Git For Emacs Devs]]
-
 * [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
-* Testing
-** python-nemu
-
 * mandos-applet
 
 * mandos-client
-** TODO [#A] --dh-params=FILE
+** TODO [#A] Wireless network hook
 ** TODO [#B] Use capabilities instead of seteuid().
-   https://forums.grsecurity.net/viewtopic.php?f=7&t=2522
+** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
-** TODO [#C] Make start_mandos_communication() take "struct server".
-** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
+** TODO [#B] Use getnameinfo(serv=NULL, NI_NUMERICHOST) instead of inet_ntop()
+** TODO [#B] Prefer /run/tmp over /tmp, if it exists
+** TODO [#B] Use in_port_t instead of uint16_t for port numbers.
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -33,8 +19,10 @@
 * usplash (Deprecated)
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
+** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
 
 * askpass-fifo
+** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] lock stdin (with flock()?)
@@ -45,30 +33,32 @@
 
 * plugin-runner
 ** TODO handle printing for errors for plugins
-*** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
+*** Hook up stderr of plugins, buffer them, and prepend mandos pluig [plugin name]
+** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
+** TODO [#B] Use openat()
 
 * mandos (server)
-** TODO [#B] Work around Avahi issue
-   Avahi does not announce link-local addresses if any global
-   addresses exist: http://lists.freedesktop.org/archives/avahi/2010-March/001863.html
-** TODO [#B] --notify-command
-   This would allow the mandos.service to use
-   --notify-command="systemd-notify --pid READY=1"
 ** TODO [#B] Log level							  :BUGS:
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
 ** TODO Log level dbus option
    SetLogLevel D-Bus call
+** TODO Implement --foreground						  :BUGS:
+   [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on number of secrets given
+** TODO [#B] Support RFC 3339 time duration syntax
 ** D-Bus Client method NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
+** TODO [#C] systemd/launchd
+   http://0pointer.de/blog/projects/systemd.html
+   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
@@ -76,23 +66,17 @@
 ** TODO Allow %%(checker)s as a runtime expansion
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
-** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
-** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
+** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods.
+** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal
+   TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
+   TODO Can use "invalidates" annotation to also emit on changed secret.
+** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
 ** TODO Save state periodically to recover better from hard shutdowns
 ** TODO CheckerCompleted method, deprecate CheckedOK
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
-** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				     :2:
-** TODO http://0pointer.de/blog/projects/stateless.html
-*** tmpfiles snippet to create /var/lib/mandos with right user+perms
-*** File in /usr/lib/sysusers.d to create user+group "_mandos"
-** TODO Error handling on error parsing config files
-** TODO init.d script error handling
-** TODO D-Bus server properties; address, port, interface, etc.		     :2:
-** TODO [#C] In Python 3.3, use shlex.quote() instead of re.escape()
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -100,7 +84,7 @@
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Remove old string_to_delta format				     :2:
+** TODO Support RFC 3339 time duration syntax
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
@@ -112,7 +96,7 @@
    Better view of client data in the listing
 *** Properties popup
 ** Print a nice "We are sorry" message, save stack trace to log.
-** Rename module "gobject" to "GObject".
+** Show timeout countdown for approval
 
 * mandos-keygen
 ** TODO "--secfile" option
@@ -120,6 +104,10 @@
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
+* Makefile
+** TODO [#C] Implement DEB_BUILD_OPTIONS
+   http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
+
 * Package
 ** /usr/share/initramfs-tools/hooks/mandos
 *** TODO [#C] use same file name rules as run-parts(8)

=== modified file 'clients.conf'
--- clients.conf	2012-06-23 00:58:49 +0000
+++ clients.conf	2011-11-26 23:08:17 +0000
@@ -4,19 +4,19 @@
 
 # How long until a client is disabled and not be allowed to get the
 # data this server holds.
-;timeout = PT5M
+;timeout = 5m
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
 # above "timeout" occurs, at which time the client will be disabled,
 # and any running checker killed.
-;interval = PT2M
+;interval = 2m
 
 # Extended timeout is an added timeout that is given once after a
 # password has been sent sucessfully to a client.  This allows for
 # additional delays caused by file system checks and quota checks.
-;extended_timeout = PT15M
+;extended_timeout = 15m
 
 # What command to run as "the checker".
 ;checker = fping -q -- %%(host)s
@@ -25,10 +25,10 @@
 ;approved_by_default = True
 
 # How long to wait for approval.
-;approval_delay = PT0S
+;approval_delay = 0s
 
 # How long one approval will last.
-;approval_duration = PT1S
+;approval_duration = 1s
 
 # Whether this client is enabled by default
 ;enabled = True
@@ -78,10 +78,10 @@
 ;host = 192.0.2.3
 ;
 ;# Parameters from the [DEFAULT] section can be overridden per client.
-;interval = PT1M
+;interval = 1m
 ;
 ;# This client requires manual approval before it receives its secret.
 ;approved_by_default = False
 ;# Require approval within 30 seconds.
-;approval_delay = PT30S
+;approval_delay = 30s
 ;####

=== modified file 'common.ent'
--- common.ent	2014-10-05 20:08:58 +0000
+++ common.ent	2012-06-01 18:39:03 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.9">
+<!ENTITY version "1.5.5">

=== modified file 'debian/changelog'
--- debian/changelog	2014-10-05 20:08:58 +0000
+++ debian/changelog	2012-06-01 18:39:03 +0000
@@ -1,146 +1,3 @@
-mandos (1.6.9-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Build-Depends): Fix "still uses GnutLS 2.x" by
-    changing from "libgnutls-dev" to "libgnutls28-dev | gnutls-dev"
-    (Closes: #762349)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 05 Oct 2014 22:05:06 +0200
-
-mandos (1.6.8-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Source: mandos/Build-Depends-Indep): Since upstream
-    now requires Python 2.7, depend on exactly the python2.7 package and
-    all the Python 2.7 versions of the python modules.
-    (Package: mandos/Depends): - '' - but still depend on python (>=2.7)
-    and the generic versions of the Python modules; this is for mandos-ctl
-    and mandos-monitor, both of which are compatible with Python 3, and
-    use #!/usr/bin/python.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Wed, 06 Aug 2014 22:55:24 +0200
-
-mandos (1.6.7-1) unstable; urgency=medium
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 17 Jul 2014 05:22:45 +0200
-
-mandos (1.6.6-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/mandos.postinst: Fix typo in comment.
-  * debian/control (mandos/Recommends): Changed to "ssh-client | fping".
-    (mandos-client/Recommends): New; set to "ssh".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Jul 2014 22:49:21 +0200
-
-mandos (1.6.5-3) unstable; urgency=medium
-
-  * debian/control (mandos-client/Depends): Add "dpkg-dev (>=1.16.0)";
-    initramfs-tools-hook runs "dpkg-architecture -qDEB_HOST_MULTIARCH".
-    (Closes: #750221)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Fri, 06 Jun 2014 04:27:15 +0200
-
-mandos (1.6.5-2) unstable; urgency=medium
-
-  * debian/rules (override_dh_auto_test-arch): New; does nothing.  Fixes
-    FTBFS for build-indep.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Tue, 13 May 2014 08:08:31 +0200
-
-mandos (1.6.5-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/copyright: Change year to "2014".
-  * debian/control (Build-Depends, Build-Depends-Indep): Moved build
-    dependencies of "mandos" package to "Build-Depends-Indep".
-  * debian/upstream/signing-key.asc: New; upstream source public key.
-  * debian/control (Standards-Version): Updated to "3.9.5".
-  * debian/control (mandos/Depends): Remove the dependency on
-    "avahi-daemon (>= 0.6.31-3) | systemd-sysv".  It is unnecessary
-    since we have a workaround in debian/mandos.postinst anyway.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 11 May 2014 22:16:33 +0200
-
-mandos (1.6.4-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Build-Depends): Add Python dependencies to
-                                    successfully run self-tests.
-  * debian/copyright: GPLv3 now has its own license file - use it.
-  * debian/watch: Set PGP signature URL.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 16 Feb 2014 14:09:25 +0100
-
-mandos (1.6.3-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (Build-Depends): Added "systemd".
-  * debian/mandos.dirs (lib/systemd/system): New.
-  * debian/mandos-client.README.Debian: Refer to architecture libdir.
-  * debian/control (mandos/Depends): Add "avahi-daemon (>= 0.6.31-3) |
-                                     systemd-sysv".
-  * debian/mandos.postinst: If avahi-daemon is version 0.6.31-2 or older,
-                            edit /etc/init.d script headers Required-Start
-                            and Required-Stop to have "avahi" instead of
-                            "avahi-daemon", before insserv(8) sees it.
-  * debian/mandos-client.lintian-overrides: Libdir changes.
-  * debian/rules (override_dh_fixperms): - '' -
-
- -- Teddy Hogeborn <teddy@recompile.se>  Tue, 21 Jan 2014 22:01:30 +0100
-
-mandos (1.6.2-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/compat: Changed to "9".
-  * debian/control (Build-Depends): Changed debhelper version to (>= 9).
-    (Standards-Version): Updated to "3.9.4".
-    (DM-Upload-Allowed): Removed.
-    (mandos/Depends): Add "initscripts (>= 2.88dsf-13.3)" to be able to
-                      use the "/run" directory (for mandos.pid).
-  * debian/copyright (Copyright): Update year.
-  * Fix "Mandos/gnutls fails to establish connection, "an algorithm that
-    is not enabled was negotiated"" fixed by upstream. (Closes: #702120)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 24 Oct 2013 22:33:40 +0200
-
-mandos (1.6.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (mandos/Depends): No longer depends on
-                                     python-gnupginterface, but does
-                                     depend on gnupg (<< 2).
-    (Build-Depends): Depend on debhelper 8.9.7 for using "override-*-arch"
-                     and "override-*-indep" targets in debian/rules.
-  * debian/mandos-client.README: Update Linux documentation link.
-  * debian/rules: Completely rewritten to use debhelper v7.
-  * initramfs-tools-hook: Bug fix: Make sure the right version of GnuPG is
-    copied into the initramfs image.  Always assume that GPGME is used to
-    avoid searching for it since the path might not be /usr/lib.  Thanks
-    to Félix Sipma <felix+debian@gueux.org> for the initial bug report,
-    and also thanks to Dick Middleton <dick@lingbrae.com> for some more
-    debugging. (Closes:  #721903)
-  * Fix "bashism in /bin/sh script" fixed by upstream. (Closes: #690639)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Oct 2013 19:03:23 +0200
-
-mandos (1.6.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/copyright (Copyright): Join the two lines to a single line.
-  * debian/mandos-client.README.Debian: Update to refer to the new
-    location of the example network hooks, and the new feature of using
-    all network interfaces.
-  * debian/mandos-client.docs (network-hooks.d): Removed.
-  * debian/mandos-client.examples (network-hooks.d): New.
-  * debian/rules (binary-common): Added "dh_installexamples".
-    (binary-common/dh_fixperms): Exclude new location of
-    "network-hooks.d".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Mon, 18 Jun 2012 00:15:23 +0200
-
 mandos (1.5.5-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/compat'
--- debian/compat	2013-10-20 15:25:09 +0000
+++ debian/compat	2008-09-17 00:34:09 +0000
@@ -1,1 +1,1 @@
-9
+7

=== modified file 'debian/control'
--- debian/control	2014-10-08 21:03:05 +0000
+++ debian/control	2012-05-24 18:10:10 +0000
@@ -4,24 +4,22 @@
 Maintainer: Mandos Maintainers <mandos@recompile.se>
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
-Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
-	| gnutls-dev, xsltproc, pkg-config
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
+	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
+	pkg-config
+Standards-Version: 3.9.3
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
+DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2), initscripts (>= 2.88dsf-13.3)
-Recommends: ssh-client | fping
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
+	python-avahi, python-gobject, avahi-daemon, adduser,
+	python-urwid, python (>=2.7) | python-argparse,
+	python-gnupginterface
+Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -40,8 +38,7 @@
 Package: mandos-client
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
-Recommends: ssh
+	gnupg (<< 2), initramfs-tools
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'debian/copyright'
--- debian/copyright	2014-03-01 09:39:25 +0000
+++ debian/copyright	2012-06-01 21:48:12 +0000
@@ -4,8 +4,8 @@
 Source: <http://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2014 Teddy Hogeborn
-	   Copyright © 2008-2014 Björn Påhlsson
+Copyright: Copyright © 2008-2012 Teddy Hogeborn
+	   Copyright © 2008-2012 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as
@@ -22,4 +22,4 @@
     <http://www.gnu.org/licenses/>.
     .
     On Debian systems, the complete text of the GNU General Public
-    License can be found in "/usr/share/common-licenses/GPL-3".
+    License can be found in "/usr/share/common-licenses/GPL".

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2013-10-28 10:04:05 +0000
+++ debian/mandos-client.README.Debian	2012-06-01 21:48:12 +0000
@@ -16,8 +16,7 @@
   is possible to verify that the correct password will be received by
   this client by running the command, on the client:
   
-	/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH \
-	)/mandos/plugins.d/mandos-client \
+	/usr/lib/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
 		--seckey=/etc/keys/mandos/seckey.txt; echo
   
@@ -33,9 +32,9 @@
 
 * Specifying a Client Network Interface
   
-  At boot time the network interfaces to use will by default be
-  automatically detected.  If this should result in incorrect
-  interfaces, edit the DEVICE setting in the
+  At boot time the network interface to use will by default be
+  automatically detected.  If this should result in an incorrect
+  interface, edit the DEVICE setting in the
   "/etc/initramfs-tools/initramfs.conf" file.  (The default setting is
   empty, meaning it will autodetect the interface.)  *If* the DEVICE
   setting is changed, it will be necessary to update the initrd image
@@ -43,18 +42,18 @@
   
 	update-initramfs -k all -u
   
-  The device can also be overridden at boot time on the Linux kernel
+  The device can be overridden at boot time on the Linux kernel
   command line using the sixth colon-separated field of the "ip="
   option; for exact syntax, read the documentation in the file
-  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfs/nfsroot.txt",
+  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
   available in the "linux-doc-*" package.
   
-  Note that since the network interfaces are used in the initial RAM
-  disk environment, the network interfaces *must* exist at that stage.
-  Thus, an interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, only real interfaces (such as "eth0") can be used.
+  Note that since this network interface is used in the initial RAM
+  disk environment, the network interface *must* exist at that stage.
+  Thus, the interface can *not* be a pseudo-interface such as "br0" or
+  "tun0"; instead, only real interface (such as "eth0") can be used.
   This can be overcome by writing a "network hook" program to create
-  an interface (see mandos-client(8mandos)) and placing it in
+  the interface (see mandos-client(8mandos)) and placing it in
   "/etc/mandos/network-hooks.d", from where it will be copied into the
   initial RAM disk.  Example network hook scripts can be found in
   "/usr/share/doc/mandos-client/examples/network-hooks.d".
@@ -91,4 +90,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Oct 2013 11:02:26 +0100
+ -- Teddy Hogeborn <teddy@recompile.se>, Fri,  1 Jun 2012 23:46:13 +0200

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2014-01-20 21:50:11 +0000
+++ debian/mandos-client.lintian-overrides	2010-10-13 06:12:52 +0000
@@ -2,12 +2,12 @@
 #
 mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
 
-# The directory /usr/lib/<arch>/mandos/plugins.d contains setuid
-# binaries which are not meant to be run outside an initial RAM disk
+# The directory /usr/lib/mandos/plugins.d contains setuid binaries
+# which are not meant to be run outside an initial RAM disk
 # environment (except for test purposes).  It would be insecure to
 # allow anyone to run them.
 #
-mandos-client binary: non-standard-dir-perm usr/lib/*/mandos/plugins.d/ 0700 != 0755
+mandos-client binary: non-standard-dir-perm usr/lib/mandos/plugins.d/ 0700 != 0755
 
 # These binaries must be setuid root, since they need root powers, but
 # are started by plugin-runner(8mandos), which runs all plugins as
@@ -15,14 +15,14 @@
 # system, but in an initial RAM disk environment.  Here they are
 # protected from non-root access by the directory permissions, above.
 #
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/mandos-client 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/askpass-fifo 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/splashy 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/usplash 4755 root/root
-mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/plymouth 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/mandos-client 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
+mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/plymouth 4755 root/root
 
 # The directory /etc/mandos/plugins.d can be used by local system
 # administrators to place plugins in, overriding and complementing
-# /usr/lib/<arch>/mandos/plugins.d, and must be likewise protected.
+# /usr/lib/mandos/plugins.d, and must be likewise protected.
 #
 mandos-client binary: non-standard-dir-perm etc/mandos/plugins.d/ 0700 != 0755

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2013-10-27 17:42:23 +0000
+++ debian/mandos.dirs	2011-11-26 22:22:20 +0000
@@ -5,4 +5,3 @@
 etc/dbus-1/system.d
 usr/sbin
 var/lib/mandos
-lib/systemd/system

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2014-06-07 20:29:36 +0000
+++ debian/mandos.postinst	2011-11-26 22:22:20 +0000
@@ -47,16 +47,6 @@
 	;;
 esac
 
-# Avahi version 0.6.31-2 and older provides "avahi" (instead of
-# "avahi-daemon") in its /etc/init.d script header.  To make
-# insserv(8) happy, we edit our /etc/init.d script header to contain
-# the correct string before the code added by dh_installinit calls
-# update.rc-d, which calls insserv.
-avahi_version="`dpkg-query --showformat='${Version}' --show avahi-daemon`"
-if dpkg --compare-versions "$avahi_version" le 0.6.31-2; then
-    sed --in-place --expression='/^### BEGIN INIT INFO$/,/^### END INIT INFO$/s/^\(# Required-\(Stop\|Start\):.*avahi\)-daemon\>/\1/g' /etc/init.d/mandos
-fi
-
 #DEBHELPER#
 
 exit 0

=== modified file 'debian/rules'
--- debian/rules	2014-05-12 21:02:38 +0000
+++ debian/rules	2012-06-01 21:48:12 +0000
@@ -1,31 +1,108 @@
 #!/usr/bin/make -f
-%:
-	dh $@
-
-override_dh_auto_build-arch:
+# Sample debian/rules that uses debhelper.
+#
+# This file was originally written by Joey Hess and Craig Small.
+# As a special exception, when this file is copied by dh-make into a
+# dh-make output file, you may use that output file without restriction.
+# This special exception was added by Craig Small in version 0.37 of dh-make.
+#
+# Modified to make a template file for a multi-binary package with separated
+# build-arch and build-indep targets  by Bill Allombert 2001
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+
+# This has to be exported to make some magic below work.
+export DH_OPTIONS
+
+# -pie was broken briefly on the mips and mipsel architectures, see
+# <http://bugs.debian.org/526961>
+BINUTILS_V := $(shell dpkg-query --showformat='$${Version}' \
+			--show binutils)
+ifeq (yes,$(shell dpkg --compare-versions $(BINUTILS_V) lt 2.20-3 \
+		&& dpkg --compare-versions $(BINUTILS_V) ge 2.19.1-1 \
+		&& echo yes))
+  ifneq (,$(strip $(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:) \
+		$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:)))
+    BROKEN_PIE := yes
+    export BROKEN_PIE
+  endif
+endif
+
+configure: configure-stamp
+configure-stamp:
+	dh_testdir
+	touch configure-stamp
+
+build: build-arch build-indep
+
+build-arch: build-arch-stamp
+build-arch-stamp: configure-stamp
 	LC_ALL=en_US.utf8 dh_auto_build -- all doc
-
-override_dh_auto_build-indep:
-	LC_ALL=en_US.utf8 dh_auto_build -- doc
-
-override_dh_installinit-indep:
+	touch $@
+
+build-indep: build-indep-stamp
+build-indep-stamp: configure-stamp
+	LC_ALL=en_US.UTF-8 dh_auto_build -- doc
+	touch $@
+
+clean:
+	dh_testdir
+	dh_testroot
+	rm -f build-arch-stamp build-indep-stamp configure-stamp
+	dh_auto_clean
+	dh_clean
+
+install: install-indep install-arch
+install-indep:
+	dh_testdir
+	dh_testroot
+	dh_prep
+	dh_installdirs --indep
+	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
+	dh_lintian
 	dh_installinit --onlyscripts \
 		--update-rcd-params="defaults 25 15"
-
-override_dh_auto_install-indep:
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
-
-override_dh_auto_install-arch:
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client \
-		install-client-nokey
-
-override_dh_fixperms:
+	dh_install --indep
+
+install-arch:
+	dh_testdir
+	dh_testroot
+	dh_prep
+	dh_installdirs --same-arch
+	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client install-client-nokey
+	dh_lintian
+	dh_install --same-arch
+
+binary-common:
+	dh_testdir
+	dh_testroot
+	dh_installchangelogs
+	dh_installdocs
+	dh_installexamples
+	dh_link
+	dh_strip
+	dh_compress
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
-		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
+		--exclude usr/lib/mandos/plugins.d \
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
-	chmod --recursive g-w -- \
-	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"
-
-override_dh_auto_test-arch: ;
+	dh_installdeb
+	dh_shlibdeps
+	dh_gencontrol
+	dh_md5sums
+	dh_builddeb
+
+# Build architecture independant packages using the common target.
+binary-indep: build-indep install-indep
+	$(MAKE) -f debian/rules DH_OPTIONS=--indep binary-common
+
+# Build architecture dependant packages using the common target.
+binary-arch: build-arch install-arch
+	$(MAKE) -f debian/rules DH_OPTIONS=--same-arch binary-common
+
+binary: binary-arch binary-indep
+
+.PHONY: build clean binary-indep binary-arch binary install \
+		install-indep install-arch configure

=== removed directory 'debian/upstream'
=== removed file 'debian/upstream/signing-key.asc'
--- debian/upstream/signing-key.asc	2014-03-28 22:32:21 +0000
+++ debian/upstream/signing-key.asc	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
------BEGIN PGP PUBLIC KEY BLOCK-----
-Version: GnuPG v1.4.12 (GNU/Linux)
-
-mQINBFJQOFYBEACoWsEGlOxVWFUAxOxdd3GDLaqEKkKihJwLp102Ks7JKMd9friR
-7+OZuo3U0gdqLU9q1jPJn36J1QbaUTOvcaKtZp+QpUoYJ2OaGtlOY5ML8LSoC0rZ
-MIzGYTtvriwpU/YplLNGPl/90KsB2VqjrY1l1he5M8zziWDlPdJxwg8GFvmPWoif
-6oo+1iCswL5IdQ6c5MVO53zYu0cgyUSazLsVD5Xzy59lefgtaDydahJpPycf5aEQ
-DAoC9fZt2mgG3FLIUCZdXIhZdOJGCMdjLThBnJXYgGbG4rbGLNlI4W/uA5aqa4ME
-WYSAcCyX3ucKY/LkXRtC+z5s05e7tZ3Z+uAJy1eDsbhDXgZERye7a/zPWx1tAlzQ
-E80Oltjh1uXWjQORyx99a0jK87zjm49YjhYw1ZN6Z0HfSaws4Yj2QOzp9t4B3l7f
-DIUYoWBfHW7mseQeQ+t3TwQU5gjFCNu7oDeATqi5A5MksXN0+BcksterbGRBhEyp
-CybIEyrZE033jIs407Ool4Kv10cnjc8oy609BXex/dxwcvVr2vQHle4NPUZd+Xhg
-zC+9Z4jFwE0M/EPvtyieA/DWQse+TZ5itDGMYDub/GJfv1U61ANOgPIbTEF7iSa9
-5nWmq7zyUy/txmABka842Kt0Vp6ayoKcF8EIXCaDrVfPnXj+JlKf3c2u6wARAQAB
-tCxNYW5kb3MgTWFpbnRhaW5lciBUZWFtIDxtYW5kb3NAcmVjb21waWxlLnNlPokC
-PQQTAQgAJwUCUlA4VgIbAwUJCWYBgAULCQgHAwUVCgkICwUWAgMBAAIeAQIXgAAK
-CRByIylzyjTCxETXEACi56jCV9lJNSBbTp0Iet4X/i7Mx0Z8UkFFa3l7o0i4jFQj
-CIBrWECDlcxqZziii2dgh7L0ma93vB3rfjfCWeYLcEQw43MFBsd4dHuobrLXTcqU
-7n0Zmc8BsXwk5B25CnEYgvlbWX9BCYtxHGRcZzQrqOFjCMKatq0EIIVuWaz5yuCU
-V2rEgnr+veTd/rBOE9ez6Ju6xH11Teob5G7pMM0YPKHtZG/J3rvWPw4BDM6Tc60B
-G0sTDZNgkrGWxuB8YaLIwVWzliQK/17Jv/0alajyA3cWLWMkcK9Yhi/einzdMRoD
-IjnbtoHcSC9g6i0VGelwnMpHlFTwXriXEBSttULarK3iKE4tOv9nxMAEwicqlw14
-X96PPgz6ogtJG7FiwZfy1CQ81Uby+YuIhHZx3ZEyR1TFq70e98EgCuvjMZWMIhSy
-gB5Vssfq7c2lXQjltV3ujhK1PD+7/iHlL7t4QRxPDN8fbMS2VPfAdtnWS1K48d5J
-D/jP1LrGWS81HIaX8GFVLVw+jSQEu9cn3TFiZxK/4MMsITmlouJdtZWmQ/otMSMl
-wiCCZp3dGpRXMmaqR1N8V0nMKshM8mci7bD92ubd/t6cR/G6l+VIp45WyFONvtde
-F3ccfmfrKJuroMDfHxPxMf58EroAuWwzJKCPRH4JmwDvSSQoIIAGNL1lOKp6wrkC
-DQRSUDhWARAAzN7pbpAu7XLNPODotV/N+JaCFvNAIqTcr9PrbhxiKFCDs9/IExwP
-sGENL9GZd1DfoGEgxQ8j3l8VGw9VSeUoN7uMY2NwwbXTilAFkn/S8xnr2zQDRZ+n
-EeFSq9MMFxj4Kt1TqVYDbO8vmFfOT3gRCRHeJ+pn4yJeSPau/ndNrmbQ1/Z6vaUG
-yfo931ottx7SXZwkHA6jJVFT9rbHTyx9tzOqMKDJiMrx8qKaHpE9B45oHNR0WJJJ
-75zoDVuOZ6wAxXZuqBFu2lKPqDTZeawfzcu5qplrm1RPgSOjz6w1A41HBLqGe+v9
-7Twx5wfNMgnKC0V2wUe0xR6hQHQlyZoCwcGyrasiu+v/joZ1p66SSWKjs+LGjoe4
-Lwh6VjZU2x+irVBjcgIoRWf3k4JAef0nGYsm0cFjAnwXac+/CYxVt+7Y4+HG8wPB
-oUNZkW+bvdHQouxEClxnccIEgX/AkriJTYDQ4q3tkl2HVE/51R4pdQVLer2a5ov+
-Jwk44DdqzYstMsvqu+iD48hXzADg6HFvofkpct15h463pMaJf99uVVM9ZDNQ6B34
-l3tPX9ZDkIDl6n9dE2Jkaxx1yNVhPXpeMf4EzL+CEdUErVStB66lUkw+tNkuZyVT
-ZTQel9h0196+CNSiqAaL8+ZZdbjKKfzlcB4Qnd897XzMfsFQ7mzJ9QsAEQEAAYkC
-JQQYAQgADwUCUlA4VgIbDAUJCWYBgAAKCRByIylzyjTCxFmlEACBTOg5NqX63d8D
-mwk4smlFPppQBIduxZaMG9HsLcPi3VKTG9Zg6WI6rEdr/4MnoINsudLsEbrQLgRH
-2q1Zs+HqIIP5H2/sYHmswyokYB10zKB6gNUUg/GSlcAcrelsHVKx5B8kccWGT5gk
-Wo/X0BGMUTOvQ6lJ6YNo1idcQ2ZjsyfZoz3G8JS7/EXN//jAZf+017yj8WsAS7hw
-JRFMy7VET4g00JcBoNOAMP7PkozimZ2OwwsggJSYWkR1RaU2tKR1VmDF8R6UxuEd
-BJzwFmz+wNC1Kq+FoSaRNsrKEmzLnfV9unDnF2z7Lc4LqOysXdzOk9zTBPur0gd2
-Lh5H/g5rTAMQBARqXfvIwiTtrBGgil8JW8e4Bc0LQUuHAE7x9gMRil+OtkQrCRk9
-0LWXVS+K0tvvruE4EDtCGiS5046+BEI3aYsp4hNzjHADq0TJeCYjNg9kY0CjxcEq
-cfuMoUbQ0MkARGuBbykCdlylfTrkxrj/dPhr49lctY3H+Pj6F4fMDM4TP6UTGA8k
-993RRNYhkDWSxIp6G7RJpBZobHN+eHQ3r8A4tWdYb4Fvd2lvwEDjUFT9uD6WAff4
-8A1hM2uSy91UYBOPrIjqYdRFKJc9rThYdXH2T6SiRMYtZMrEKhqPffB/i9mqVBlD
-6vKRsaQikZujRdP9Dkf0mLmJ7LANWw==
-=9Noe
------END PGP PUBLIC KEY BLOCK-----

=== modified file 'debian/watch'
--- debian/watch	2014-02-16 02:42:42 +0000
+++ debian/watch	2011-10-05 16:00:56 +0000
@@ -1,3 +1,2 @@
 version=3
-opts=pgpsigurlmangle=s/$/.asc/ \
- ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)
+ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

=== modified file 'init.d-mandos'
--- init.d-mandos	2014-01-06 15:56:54 +0000
+++ init.d-mandos	2012-06-01 21:48:12 +0000
@@ -1,12 +1,12 @@
 #! /bin/sh
 ### BEGIN INIT INFO
 # Provides:          mandos
-# Required-Start:    $remote_fs $syslog avahi-daemon
-# Required-Stop:     $remote_fs $syslog avahi-daemon
+# Required-Start:    $remote_fs $syslog avahi
+# Required-Stop:     $remote_fs $syslog avahi
 # Default-Start:     2 3 4 5
 # Default-Stop:      0 1 6
 # Short-Description: Mandos server
-# Description:       Server of encrypted passwords to Mandos clients
+# Description:       Gives encrypted passwords to Mandos clients
 ### END INIT INFO
 
 # Author: Teddy Hogeborn <teddy@recompile.se>
@@ -23,11 +23,7 @@
 NAME=mandos
 DAEMON=/usr/sbin/$NAME
 DAEMON_ARGS=""
-if [ -d /run/. ]; then
-    PIDFILE=/run/$NAME.pid
-else
-    PIDFILE=/var/run/$NAME.pid
-fi
+PIDFILE=/var/run/$NAME.pid
 SCRIPTNAME=/etc/init.d/$NAME
 
 # Exit if the package is not installed
@@ -44,8 +40,7 @@
 . /lib/init/vars.sh
 
 # Define LSB log_* functions.
-# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
-# and status_of_proc is working.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
 . /lib/lsb/init-functions
 
 #
@@ -123,9 +118,6 @@
 		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
 	esac
 	;;
-  status)
-	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE" && exit 0 || exit $?
-	;;
   #reload|force-reload)
 	#
 	# If do_reload() is not implemented then leave this commented out
@@ -152,14 +144,17 @@
 		esac
 		;;
 	  *)
-		# Failed to stop
+	  	# Failed to stop
 		log_end_msg 1
 		;;
 	esac
 	;;
+  status)
+	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE"
+	;;
   *)
 	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
 	exit 3
 	;;
 esac

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2014-07-16 23:44:54 +0000
+++ initramfs-tools-hook	2011-11-29 18:19:31 +0000
@@ -3,7 +3,7 @@
 # This script will be run by 'mkinitramfs' when it creates the image.
 # Its job is to decide which files to install, then install them into
 # the staging area, where the initramfs is being created.  This
-# happens when a new 'linux-image' package is installed, or when an
+# happens when a new 'linux-image' package is installed, or when the
 # administrator runs 'update-initramfs' by hand to update an initramfs
 # image.
 
@@ -29,15 +29,13 @@
 
 . /usr/share/initramfs-tools/hook-functions
 
-for d in /usr/lib \
-    "/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
-    "`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/local/lib; do
-    if [ -d "$d"/mandos ]; then
-	libdir="$d"
+for d in /usr /usr/local; do
+    if [ -d "$d"/lib/mandos ]; then
+	prefix="$d"
 	break
     fi
 done
-if [ -z "$libdir" ]; then
+if [ -z "$prefix" ]; then
     # Mandos not found
     exit 1
 fi
@@ -79,12 +77,12 @@
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
 # Copy the Mandos plugin runner
-copy_exec "$libdir"/mandos/plugin-runner "${MANDOSDIR}"
+copy_exec "$prefix"/lib/mandos/plugin-runner "${MANDOSDIR}"
 
 # Copy the plugins
 
 # Copy the packaged plugins
-for file in "$libdir"/mandos/plugins.d/*; do
+for file in "$prefix"/lib/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
     # Is this plugin overridden?
     if [ -e "/etc/mandos/plugins.d/$base" ]; then
@@ -149,24 +147,12 @@
     fi
 done
 
-# GPGME needs GnuPG
-gpg=/usr/bin/gpg
-libgpgme11_version="`dpkg-query --showformat='${Version}' --show libgpgme11`"
-if dpkg --compare-versions "$libgpgme11_version" ge 1.5.0-0.1; then
-    if [ -e /usr/bin/gpgconf ]; then
-	if [ ! -e "${DESTDIR}/usr/bin/gpgconf" ]; then
-	    copy_exec /usr/bin/gpgconf
-	fi
-	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
-    fi
-elif dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
-    gpg=/usr/bin/gpg2
-fi
-if [ ! -e "${DESTDIR}$gpg" ]; then
-    copy_exec "$gpg"
-fi
-unset gpg
-unset libgpgme11_version
+# GPGME needs /usr/bin/gpg
+if [ ! -e "${DESTDIR}/usr/bin/gpg" \
+    -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \
+		2>/dev/null`" ]; then
+    copy_exec /usr/bin/gpg
+fi
 
 # Config files
 for file in /etc/mandos/plugin-runner.conf; do

=== removed file 'initramfs-unpack'
--- initramfs-unpack	2013-10-13 15:43:42 +0000
+++ initramfs-unpack	1970-01-01 00:00:00 +0000
@@ -1,67 +0,0 @@
-#!/bin/bash
-# 
-# Initramfs unpacker - unpacks initramfs images into /tmp
-# 
-# Copyright © 2013 Teddy Hogeborn
-# Copyright © 2013 Björn Påhlsson
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see
-# <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@recompile.se>.
-
-cpio="cpio --extract --make-directories --unconditional --preserve-modification-time"
-
-if [ -z "$*" ]; then
-    set -- /boot/initrd.img-*
-fi
-
-for imgfile in "$@"; do
-    if ! [ -f "$imgfile" ]; then
-	echo "Error: Not an existing file: $imgfile" >&2
-	continue
-    fi
-    imgdir="${TMPDIR:-/tmp}/${imgfile##*/}"
-    if [ -d "$imgdir" ]; then
-	rm --recursive -- "$imgdir"
-    fi
-    mkdir --parents "$imgdir"
-    # Does this image contain microcode?
-    if $cpio --quiet --list --file="$imgfile" >/dev/null 2>&1; then
-	# Number of bytes to skip to get to the compressed archive
-	skip=$(($(LANG=C $cpio --io-size=1 --list --file="$imgfile" 2>&1 \
-	    | sed --quiet --expression='s/^\([0-9]\+\) blocks$/\1/p')+8))
-	catimg="dd if=$imgfile bs=$skip skip=1 status=noxfer"
-    else
-	catimg="cat -- $imgfile"
-    fi
-    # Determine the compression method
-    if { $catimg 2>/dev/null | zcat --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="zcat"
-    elif { $catimg 2>/dev/null | bzip2 --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="bzip2 --stdout --decompress"
-    elif { $catimg 2>/dev/null | lzop --test >/dev/null 2>&1;
-	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
-	decomp="lzop --stdout --decompress"
-    else
-	echo "Error: Could not determine type of $imgfile" >&2
-	continue
-    fi
-    $catimg 2>/dev/null | $decomp | ( cd -- "$imgdir" && $cpio --quiet )
-    if [ ${PIPESTATUS[-1]} -eq 0 ]; then
-	echo "$imgfile unpacked into $imgdir"
-    fi
-done

=== modified file 'intro.xml'
--- intro.xml	2015-03-10 18:03:38 +0000
+++ intro.xml	2011-12-31 23:05:34 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2015-03-08">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -197,16 +197,6 @@
       </para>
     </refsect2>
     
-    <refsect2 id="sniff">
-      <title>How about sniffing the network traffic and decrypting it
-      later by physically grabbing the Mandos client and using its
-      key?</title>
-      <para>
-	We only use <acronym>PFS</acronym> (Perfect Forward Security)
-	key exchange algorithms in TLS, which protects against this.
-      </para>
-    </refsect2>
-    
     <refsect2 id="physgrab">
       <title>Physically grabbing the Mandos server computer?</title>
       <para>
@@ -225,22 +215,17 @@
       </para>
     </refsect2>
     
-    <refsect2 id="fakecheck">
-      <title>Faking checker results?</title>
+    <refsect2 id="fakeping">
+      <title>Faking ping replies?</title>
       <para>
-	If the Mandos client does not have an SSH server, the default
-	is for the Mandos server to use
+	The default for the server is to use
 	<quote><literal>fping</literal></quote>, the replies to which
 	could be faked to eliminate the timeout.  But this could
 	easily be changed to any shell command, with any security
-	measures you like.  If the Mandos client
-	<emphasis>has</emphasis> an SSH server, the default
-	configuration (as generated by
-	<command>mandos-keygen</command> with the
-	<option>--password</option> option) is for the Mandos server
-	to use an <command>ssh-keyscan</command> command with strict
-	keychecking, which can not be faked.  Alternatively, IPsec
-	could be used for the ping packets, making them secure.
+	measures you like.  It could, for instance, be changed to an
+	SSH command with strict keychecking, which could not be faked.
+	Or IPsec could be used for the ping packets, making them
+	secure.
       </para>
     </refsect2>
   </refsect1>

=== modified file 'mandos'
--- mandos	2015-05-23 20:18:34 +0000
+++ mandos	2012-06-01 18:39:03 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python2.7
+#!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 # 
 # Mandos server - give out binary blobs to connecting clients.
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2015 Teddy Hogeborn
-# Copyright © 2008-2015 Björn Påhlsson
+# Copyright © 2008-2012 Teddy Hogeborn
+# Copyright © 2008-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,10 +36,7 @@
 
 from future_builtins import *
 
-try:
-    import SocketServer as socketserver
-except ImportError:
-    import socketserver
+import SocketServer as socketserver
 import socket
 import argparse
 import datetime
@@ -50,10 +47,7 @@
 import gnutls.library.functions
 import gnutls.library.constants
 import gnutls.library.types
-try:
-    import ConfigParser as configparser
-except ImportError:
-    import configparser
+import ConfigParser as configparser
 import sys
 import re
 import os
@@ -68,29 +62,23 @@
 import struct
 import fcntl
 import functools
-try:
-    import cPickle as pickle
-except ImportError:
-    import pickle
+import cPickle as pickle
 import multiprocessing
 import types
 import binascii
 import tempfile
 import itertools
-import collections
 
 import dbus
 import dbus.service
-try:
-    import gobject
-except ImportError:
-    from gi.repository import GObject as gobject
+import gobject
 import avahi
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 import ctypes.util
 import xml.dom.minidom
 import inspect
+import GnuPGInterface
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -100,37 +88,34 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-if sys.version_info.major == 2:
-    str = unicode
-
-version = "1.6.9"
+version = "1.5.5"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
-syslogger = None
+syslogger = (logging.handlers.SysLogHandler
+             (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
+              address = str("/dev/log")))
 
 try:
-    if_nametoindex = ctypes.cdll.LoadLibrary(
-        ctypes.util.find_library("c")).if_nametoindex
+    if_nametoindex = (ctypes.cdll.LoadLibrary
+                      (ctypes.util.find_library("c"))
+                      .if_nametoindex)
 except (OSError, AttributeError):
-    
     def if_nametoindex(interface):
         "Get an interface index the hard way, i.e. using fcntl()"
         SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
         with contextlib.closing(socket.socket()) as s:
             ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(b"16s16x", interface))
-        interface_index = struct.unpack("I", ifreq[16:20])[0]
+                                struct.pack(str("16s16x"),
+                                            interface))
+        interface_index = struct.unpack(str("I"),
+                                        ifreq[16:20])[0]
         return interface_index
 
 
 def initlogger(debug, level=logging.WARNING):
     """init logger and add loglevel"""
     
-    global syslogger
-    syslogger = (logging.handlers.SysLogHandler(
-        facility = logging.handlers.SysLogHandler.LOG_DAEMON,
-        address = "/dev/log"))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -153,14 +138,15 @@
 
 class PGPEngine(object):
     """A simple class for OpenPGP symmetric encryption & decryption"""
-    
     def __init__(self):
+        self.gnupg = GnuPGInterface.GnuPG()
         self.tempdir = tempfile.mkdtemp(prefix="mandos-")
-        self.gnupgargs = ['--batch',
-                          '--home', self.tempdir,
-                          '--force-mdc',
-                          '--quiet',
-                          '--no-use-agent']
+        self.gnupg = GnuPGInterface.GnuPG()
+        self.gnupg.options.meta_interactive = False
+        self.gnupg.options.homedir = self.tempdir
+        self.gnupg.options.extra_args.extend(['--force-mdc',
+                                              '--quiet',
+                                              '--no-use-agent'])
     
     def __enter__(self):
         return self
@@ -188,62 +174,53 @@
     def password_encode(self, password):
         # Passphrase can not be empty and can not contain newlines or
         # NUL bytes.  So we prefix it and hex encode it.
-        encoded = b"mandos" + binascii.hexlify(password)
-        if len(encoded) > 2048:
-            # GnuPG can't handle long passwords, so encode differently
-            encoded = (b"mandos" + password.replace(b"\\", b"\\\\")
-                       .replace(b"\n", b"\\n")
-                       .replace(b"\0", b"\\x00"))
-        return encoded
+        return b"mandos" + binascii.hexlify(password)
     
     def encrypt(self, data, password):
-        passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(
-                dir=self.tempdir) as passfile:
-            passfile.write(passphrase)
-            passfile.flush()
-            proc = subprocess.Popen(['gpg', '--symmetric',
-                                     '--passphrase-file',
-                                     passfile.name]
-                                    + self.gnupgargs,
-                                    stdin = subprocess.PIPE,
-                                    stdout = subprocess.PIPE,
-                                    stderr = subprocess.PIPE)
-            ciphertext, err = proc.communicate(input = data)
-        if proc.returncode != 0:
-            raise PGPError(err)
+        self.gnupg.passphrase = self.password_encode(password)
+        with open(os.devnull, "w") as devnull:
+            try:
+                proc = self.gnupg.run(['--symmetric'],
+                                      create_fhs=['stdin', 'stdout'],
+                                      attach_fhs={'stderr': devnull})
+                with contextlib.closing(proc.handles['stdin']) as f:
+                    f.write(data)
+                with contextlib.closing(proc.handles['stdout']) as f:
+                    ciphertext = f.read()
+                proc.wait()
+            except IOError as e:
+                raise PGPError(e)
+        self.gnupg.passphrase = None
         return ciphertext
     
     def decrypt(self, data, password):
-        passphrase = self.password_encode(password)
-        with tempfile.NamedTemporaryFile(
-                dir = self.tempdir) as passfile:
-            passfile.write(passphrase)
-            passfile.flush()
-            proc = subprocess.Popen(['gpg', '--decrypt',
-                                     '--passphrase-file',
-                                     passfile.name]
-                                    + self.gnupgargs,
-                                    stdin = subprocess.PIPE,
-                                    stdout = subprocess.PIPE,
-                                    stderr = subprocess.PIPE)
-            decrypted_plaintext, err = proc.communicate(input = data)
-        if proc.returncode != 0:
-            raise PGPError(err)
+        self.gnupg.passphrase = self.password_encode(password)
+        with open(os.devnull, "w") as devnull:
+            try:
+                proc = self.gnupg.run(['--decrypt'],
+                                      create_fhs=['stdin', 'stdout'],
+                                      attach_fhs={'stderr': devnull})
+                with contextlib.closing(proc.handles['stdin']) as f:
+                    f.write(data)
+                with contextlib.closing(proc.handles['stdout']) as f:
+                    decrypted_plaintext = f.read()
+                proc.wait()
+            except IOError as e:
+                raise PGPError(e)
+        self.gnupg.passphrase = None
         return decrypted_plaintext
 
 
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
-        return super(AvahiError, self).__init__(value, *args,
-                                                **kwargs)
-
+        super(AvahiError, self).__init__(value, *args, **kwargs)
+    def __unicode__(self):
+        return unicode(repr(self.value))
 
 class AvahiServiceError(AvahiError):
     pass
 
-
 class AvahiGroupError(AvahiError):
     pass
 
@@ -256,7 +233,7 @@
                Used to optionally bind to the specified interface.
     name: string; Example: 'Mandos'
     type: string; Example: '_mandos._tcp'.
-     See <https://www.iana.org/assignments/service-names-port-numbers>
+                  See <http://www.dns-sd.org/ServiceTypes.html>
     port: integer; what port to announce
     TXT: list of strings; TXT record for the service
     domain: string; Domain to publish on, default to .local if empty.
@@ -269,17 +246,10 @@
     bus: dbus.SystemBus()
     """
     
-    def __init__(self,
-                 interface = avahi.IF_UNSPEC,
-                 name = None,
-                 servicetype = None,
-                 port = None,
-                 TXT = None,
-                 domain = "",
-                 host = "",
-                 max_renames = 32768,
-                 protocol = avahi.PROTO_UNSPEC,
-                 bus = None):
+    def __init__(self, interface = avahi.IF_UNSPEC, name = None,
+                 servicetype = None, port = None, TXT = None,
+                 domain = "", host = "", max_renames = 32768,
+                 protocol = avahi.PROTO_UNSPEC, bus = None):
         self.interface = interface
         self.name = name
         self.type = servicetype
@@ -295,31 +265,25 @@
         self.bus = bus
         self.entry_group_state_changed_match = None
     
-    def rename(self, remove=True):
+    def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
             logger.critical("No suitable Zeroconf service name found"
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = str(
-            self.server.GetAlternativeServiceName(self.name))
-        self.rename_count += 1
+        self.name = unicode(self.server
+                            .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        if remove:
-            self.remove()
+        self.remove()
         try:
             self.add()
         except dbus.exceptions.DBusException as error:
-            if (error.get_dbus_name()
-                == "org.freedesktop.Avahi.CollisionError"):
-                logger.info("Local Zeroconf service name collision.")
-                return self.rename(remove=False)
-            else:
-                logger.critical("D-Bus Exception", exc_info=error)
-                self.cleanup()
-                os._exit(1)
+            logger.critical("D-Bus Exception", exc_info=error)
+            self.cleanup()
+            os._exit(1)
+        self.rename_count += 1
     
     def remove(self):
         """Derived from the Avahi example code"""
@@ -363,8 +327,9 @@
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
-                            str(error))
-            raise AvahiGroupError("State changed: {!s}".format(error))
+                            unicode(error))
+            raise AvahiGroupError("State changed: {0!s}"
+                                  .format(error))
     
     def cleanup(self):
         """Derived from the Avahi example code"""
@@ -380,12 +345,13 @@
     def server_state_changed(self, state, error=None):
         """Derived from the Avahi example code"""
         logger.debug("Avahi server state change: %i", state)
-        bad_states = {
-            avahi.SERVER_INVALID: "Zeroconf server invalid",
-            avahi.SERVER_REGISTERING: None,
-            avahi.SERVER_COLLISION: "Zeroconf server name collision",
-            avahi.SERVER_FAILURE: "Zeroconf server failure",
-        }
+        bad_states = { avahi.SERVER_INVALID:
+                           "Zeroconf server invalid",
+                       avahi.SERVER_REGISTERING: None,
+                       avahi.SERVER_COLLISION:
+                           "Zeroconf server name collision",
+                       avahi.SERVER_FAILURE:
+                           "Zeroconf server failure" }
         if state in bad_states:
             if bad_states[state] is not None:
                 if error is None:
@@ -410,28 +376,27 @@
                                     follow_name_owner_changes=True),
                 avahi.DBUS_INTERFACE_SERVER)
         self.server.connect_to_signal("StateChanged",
-                                      self.server_state_changed)
+                                 self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
 
 class AvahiServiceToSyslog(AvahiService):
-    def rename(self, *args, **kwargs):
+    def rename(self):
         """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self, *args, **kwargs)
-        syslogger.setFormatter(logging.Formatter(
-            'Mandos ({}) [%(process)d]: %(levelname)s: %(message)s'
-            .format(self.name)))
+        ret = AvahiService.rename(self)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos ({0}) [%(process)d]:'
+                                ' %(levelname)s: %(message)s'
+                                .format(self.name)))
         return ret
 
-def subprocess_call_pipe(connection, # : multiprocessing.Connection
-                         *args, **kwargs):
-    """This function is meant to be called by multiprocessing.Process
-    
-    This function runs a synchronous subprocess.call(), and writes the
-    resulting return code on the provided multiprocessing.Connection.
-    """
-    connection.send(subprocess.call(*args, **kwargs))
-    connection.close()
+
+def timedelta_to_milliseconds(td):
+    "Convert a datetime.timedelta() to milliseconds"
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
+
 
 class Client(object):
     """A representation of a client host served by this server.
@@ -464,8 +429,6 @@
     last_checker_status: integer between 0 and 255 reflecting exit
                          status of last checker. -1 reflects crashed
                          checker, -2 means no checker completed yet.
-    last_checker_signal: The signal which killed the last checker, if
-                         last_checker_status is -1
     last_enabled: datetime.datetime(); (UTC) or None
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
@@ -476,7 +439,6 @@
     runtime_expansions: Allowed attributes for runtime expansion.
     expires:    datetime.datetime(); time (UTC) when a client will be
                 disabled, or None
-    server_settings: The server_settings dict from main()
     """
     
     runtime_expansions = ("approval_delay", "approval_duration",
@@ -484,17 +446,31 @@
                           "fingerprint", "host", "interval",
                           "last_approval_request", "last_checked_ok",
                           "last_enabled", "name", "timeout")
-    client_defaults = {
-        "timeout": "PT5M",
-        "extended_timeout": "PT15M",
-        "interval": "PT2M",
-        "checker": "fping -q -- %%(host)s",
-        "host": "",
-        "approval_delay": "PT0S",
-        "approval_duration": "PT1S",
-        "approved_by_default": "True",
-        "enabled": "True",
-    }
+    client_defaults = { "timeout": "5m",
+                        "extended_timeout": "15m",
+                        "interval": "2m",
+                        "checker": "fping -q -- %%(host)s",
+                        "host": "",
+                        "approval_delay": "0s",
+                        "approval_duration": "1s",
+                        "approved_by_default": "True",
+                        "enabled": "True",
+                        }
+    
+    def timeout_milliseconds(self):
+        "Return the 'timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.timeout)
+    
+    def extended_timeout_milliseconds(self):
+        "Return the 'extended_timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.extended_timeout)
+    
+    def interval_milliseconds(self):
+        "Return the 'interval' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.interval)
+    
+    def approval_delay_milliseconds(self):
+        return timedelta_to_milliseconds(self.approval_delay)
     
     @staticmethod
     def config_parser(config):
@@ -516,9 +492,6 @@
             client["enabled"] = config.getboolean(client_name,
                                                   "enabled")
             
-            # Uppercase and remove spaces from fingerprint for later
-            # comparison purposes with return value from the
-            # fingerprint() function
             client["fingerprint"] = (section["fingerprint"].upper()
                                      .replace(" ", ""))
             if "secret" in section:
@@ -529,7 +502,7 @@
                           "rb") as secfile:
                     client["secret"] = secfile.read()
             else:
-                raise TypeError("No secret or secfile for section {}"
+                raise TypeError("No secret or secfile for section {0}"
                                 .format(section))
             client["timeout"] = string_to_delta(section["timeout"])
             client["extended_timeout"] = string_to_delta(
@@ -546,13 +519,10 @@
         
         return settings
     
-    def __init__(self, settings, name = None, server_settings=None):
+    def __init__(self, settings, name = None):
         self.name = name
-        if server_settings is None:
-            server_settings = {}
-        self.server_settings = server_settings
         # adding all client settings
-        for setting, value in settings.items():
+        for setting, value in settings.iteritems():
             setattr(self, setting, value)
         
         if self.enabled:
@@ -566,6 +536,9 @@
             self.expires = None
         
         logger.debug("Creating client %r", self.name)
+        # Uppercase and remove spaces from fingerprint for later
+        # comparison purposes with return value from the fingerprint()
+        # function
         logger.debug("  Fingerprint: %s", self.fingerprint)
         self.created = settings.get("created",
                                     datetime.datetime.utcnow())
@@ -578,15 +551,18 @@
         self.current_checker_command = None
         self.approved = None
         self.approvals_pending = 0
-        self.changedstate = multiprocessing_manager.Condition(
-            multiprocessing_manager.Lock())
-        self.client_structure = [attr
-                                 for attr in self.__dict__.iterkeys()
+        self.changedstate = (multiprocessing_manager
+                             .Condition(multiprocessing_manager
+                                        .Lock()))
+        self.client_structure = [attr for attr in
+                                 self.__dict__.iterkeys()
                                  if not attr.startswith("_")]
         self.client_structure.append("client_structure")
         
-        for name, t in inspect.getmembers(
-                type(self), lambda obj: isinstance(obj, property)):
+        for name, t in inspect.getmembers(type(self),
+                                          lambda obj:
+                                              isinstance(obj,
+                                                         property)):
             if not name.startswith("_"):
                 self.client_structure.append(name)
     
@@ -634,47 +610,40 @@
         # and every interval from then on.
         if self.checker_initiator_tag is not None:
             gobject.source_remove(self.checker_initiator_tag)
-        self.checker_initiator_tag = gobject.timeout_add(
-            int(self.interval.total_seconds() * 1000),
-            self.start_checker)
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (self.interval_milliseconds(),
+                                       self.start_checker))
         # Schedule a disable() when 'timeout' has passed
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
-        self.disable_initiator_tag = gobject.timeout_add(
-            int(self.timeout.total_seconds() * 1000), self.disable)
+        self.disable_initiator_tag = (gobject.timeout_add
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         # Also start a new checker *right now*.
         self.start_checker()
     
-    def checker_callback(self, source, condition,
-                         (connection, command)):
+    def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
-        # Read return code from connection (see subprocess_call_pipe)
-        returncode = connection.recv()
-        connection.close()
-        
-        if returncode >= 0:
-            self.last_checker_status = returncode
-            self.last_checker_signal = None
+        if os.WIFEXITED(condition):
+            self.last_checker_status = os.WEXITSTATUS(condition)
             if self.last_checker_status == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
             else:
-                logger.info("Checker for %(name)s failed", vars(self))
+                logger.info("Checker for %(name)s failed",
+                            vars(self))
         else:
             self.last_checker_status = -1
-            self.last_checker_signal = -returncode
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
-        return False
     
     def checked_ok(self):
         """Assert that the client has been seen, alive and well."""
         self.last_checked_ok = datetime.datetime.utcnow()
         self.last_checker_status = 0
-        self.last_checker_signal = None
         self.bump_timeout()
     
     def bump_timeout(self, timeout=None):
@@ -685,8 +654,9 @@
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
         if getattr(self, "enabled", False):
-            self.disable_initiator_tag = gobject.timeout_add(
-                int(timeout.total_seconds() * 1000), self.disable)
+            self.disable_initiator_tag = (gobject.timeout_add
+                                          (timedelta_to_milliseconds
+                                           (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
@@ -706,48 +676,56 @@
         # than 'timeout' for the client to be disabled, which is as it
         # should be.
         
-        if self.checker is not None and not self.checker.is_alive():
-            logger.warning("Checker was not alive; joining")
-            self.checker.join()
-            self.checker = None
+        # If a checker exists, make sure it is not a zombie
+        try:
+            pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
+        except (AttributeError, OSError) as error:
+            if (isinstance(error, OSError)
+                and error.errno != errno.ECHILD):
+                raise error
+        else:
+            if pid:
+                logger.warning("Checker was a zombie")
+                gobject.source_remove(self.checker_callback_tag)
+                self.checker_callback(pid, status,
+                                      self.current_checker_command)
         # Start a new checker if needed
         if self.checker is None:
             # Escape attributes for the shell
-            escaped_attrs = {
-                attr: re.escape(str(getattr(self, attr)))
-                for attr in self.runtime_expansions }
+            escaped_attrs = dict(
+                (attr, re.escape(unicode(getattr(self, attr))))
+                for attr in
+                self.runtime_expansions)
             try:
                 command = self.checker_command % escaped_attrs
             except TypeError as error:
                 logger.error('Could not format string "%s"',
-                             self.checker_command,
+                             self.checker_command, exc_info=error)
+                return True # Try again later
+            self.current_checker_command = command
+            try:
+                logger.info("Starting checker %r for %s",
+                            command, self.name)
+                # We don't need to redirect stdout and stderr, since
+                # in normal mode, that is already done by daemon(),
+                # and in debug mode we don't want to.  (Stdin is
+                # always replaced by /dev/null.)
+                self.checker = subprocess.Popen(command,
+                                                close_fds=True,
+                                                shell=True, cwd="/")
+            except OSError as error:
+                logger.error("Failed to start subprocess",
                              exc_info=error)
-                return True     # Try again later
-            self.current_checker_command = command
-            logger.info("Starting checker %r for %s", command,
-                        self.name)
-            # We don't need to redirect stdout and stderr, since
-            # in normal mode, that is already done by daemon(),
-            # and in debug mode we don't want to.  (Stdin is
-            # always replaced by /dev/null.)
-            # The exception is when not debugging but nevertheless
-            # running in the foreground; use the previously
-            # created wnull.
-            popen_args = { "close_fds": True,
-                           "shell": True,
-                           "cwd": "/" }
-            if (not self.server_settings["debug"]
-                and self.server_settings["foreground"]):
-                popen_args.update({"stdout": wnull,
-                                   "stderr": wnull })
-            pipe = multiprocessing.Pipe(duplex=False)
-            self.checker = multiprocessing.Process(
-                target=subprocess_call_pipe, args=(pipe[1], command),
-                kwargs=popen_args)
-            self.checker.start()
-            self.checker_callback_tag = gobject.io_add_watch(
-                pipe[0].fileno(), gobject.IO_IN,
-                self.checker_callback, (pipe[0], command))
+            self.checker_callback_tag = (gobject.child_watch_add
+                                         (self.checker.pid,
+                                          self.checker_callback,
+                                          data=command))
+            # The checker may have completed before the gobject
+            # watch was added.  Check for this.
+            pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
+            if pid:
+                gobject.source_remove(self.checker_callback_tag)
+                self.checker_callback(pid, status, command)
         # Re-run this periodically if run by gobject.timeout_add
         return True
     
@@ -759,14 +737,19 @@
         if getattr(self, "checker", None) is None:
             return
         logger.debug("Stopping checker for %(name)s", vars(self))
-        self.checker.terminate()
+        try:
+            self.checker.terminate()
+            #time.sleep(0.5)
+            #if self.checker.poll() is None:
+            #    self.checker.kill()
+        except OSError as error:
+            if error.errno != errno.ESRCH: # No such process
+                raise
         self.checker = None
 
 
-def dbus_service_property(dbus_interface,
-                          signature="v",
-                          access="readwrite",
-                          byte_arrays=False):
+def dbus_service_property(dbus_interface, signature="v",
+                          access="readwrite", byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
     become properties on the D-Bus.
     
@@ -781,8 +764,7 @@
     # "Set" method, so we fail early here:
     if byte_arrays and signature != "ay":
         raise ValueError("Byte arrays not supported for non-'ay'"
-                         " signature {!r}".format(signature))
-    
+                         " signature {0!r}".format(signature))
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -793,7 +775,6 @@
             func._dbus_name = func._dbus_name[:-14]
         func._dbus_get_args_options = {'byte_arrays': byte_arrays }
         return func
-    
     return decorator
 
 
@@ -808,13 +789,11 @@
                 "org.freedesktop.DBus.Property.EmitsChangedSignal":
                     "false"}
     """
-    
     def decorator(func):
         func._dbus_is_interface = True
         func._dbus_interface = dbus_interface
         func._dbus_name = dbus_interface
         return func
-    
     return decorator
 
 
@@ -822,26 +801,25 @@
     """Decorator to annotate D-Bus methods, signals or properties
     Usage:
     
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true",
-                       "org.freedesktop.DBus.Property."
-                       "EmitsChangedSignal": "false"})
     @dbus_service_property("org.example.Interface", signature="b",
                            access="r")
+    @dbus_annotations({{"org.freedesktop.DBus.Deprecated": "true",
+                        "org.freedesktop.DBus.Property."
+                        "EmitsChangedSignal": "false"})
     def Property_dbus_property(self):
         return dbus.Boolean(False)
     """
-    
     def decorator(func):
         func._dbus_annotations = annotations
         return func
-    
     return decorator
 
 
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
-    pass
+    def __unicode__(self):
+        return unicode(str(self))
 
 
 class DBusPropertyAccessException(DBusPropertyException):
@@ -871,35 +849,38 @@
         If called like _is_dbus_thing("method") it returns a function
         suitable for use as predicate to inspect.getmembers().
         """
-        return lambda obj: getattr(obj, "_dbus_is_{}".format(thing),
+        return lambda obj: getattr(obj, "_dbus_is_{0}".format(thing),
                                    False)
     
     def _get_all_dbus_things(self, thing):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((getattr(athing.__get__(self), "_dbus_name", name),
+        return ((getattr(athing.__get__(self), "_dbus_name",
+                         name),
                  athing.__get__(self))
                 for cls in self.__class__.__mro__
                 for name, athing in
-                inspect.getmembers(cls, self._is_dbus_thing(thing)))
+                inspect.getmembers(cls,
+                                   self._is_dbus_thing(thing)))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
-        for cls in self.__class__.__mro__:
-            for name, value in inspect.getmembers(
-                    cls, self._is_dbus_thing("property")):
+        for cls in  self.__class__.__mro__:
+            for name, value in (inspect.getmembers
+                                (cls,
+                                 self._is_dbus_thing("property"))):
                 if (value._dbus_name == property_name
                     and value._dbus_interface == interface_name):
                     return value.__get__(self)
         
         # No such property
-        raise DBusPropertyNotFound("{}:{}.{}".format(
-            self.dbus_object_path, interface_name, property_name))
+        raise DBusPropertyNotFound(self.dbus_object_path + ":"
+                                   + interface_name + "."
+                                   + property_name)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE,
-                         in_signature="ss",
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ss",
                          out_signature="v")
     def Get(self, interface_name, property_name):
         """Standard D-Bus property Get() method, see D-Bus standard.
@@ -923,15 +904,12 @@
             # The byte_arrays option is not supported yet on
             # signatures other than "ay".
             if prop._dbus_signature != "ay":
-                raise ValueError("Byte arrays not supported for non-"
-                                 "'ay' signature {!r}"
-                                 .format(prop._dbus_signature))
+                raise ValueError
             value = dbus.ByteArray(b''.join(chr(byte)
                                             for byte in value))
         prop(value)
     
-    @dbus.service.method(dbus.PROPERTIES_IFACE,
-                         in_signature="s",
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="s",
                          out_signature="a{sv}")
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
@@ -952,18 +930,10 @@
             if not hasattr(value, "variant_level"):
                 properties[name] = value
                 continue
-            properties[name] = type(value)(
-                value, variant_level = value.variant_level + 1)
+            properties[name] = type(value)(value, variant_level=
+                                           value.variant_level+1)
         return dbus.Dictionary(properties, signature="sv")
     
-    @dbus.service.signal(dbus.PROPERTIES_IFACE, signature="sa{sv}as")
-    def PropertiesChanged(self, interface_name, changed_properties,
-                          invalidated_properties):
-        """Standard D-Bus PropertiesChanged() signal, see D-Bus
-        standard.
-        """
-        pass
-    
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
                          path_keyword='object_path',
@@ -977,14 +947,12 @@
                                                    connection)
         try:
             document = xml.dom.minidom.parseString(xmlstring)
-            
             def make_tag(document, name, prop):
                 e = document.createElement("property")
                 e.setAttribute("name", name)
                 e.setAttribute("type", prop._dbus_signature)
                 e.setAttribute("access", prop._dbus_access)
                 return e
-            
             for if_tag in document.getElementsByTagName("interface"):
                 # Add property tags
                 for tag in (make_tag(document, name, prop)
@@ -1002,9 +970,11 @@
                             if (name == tag.getAttribute("name")
                                 and prop._dbus_interface
                                 == if_tag.getAttribute("name")):
-                                annots.update(getattr(
-                                    prop, "_dbus_annotations", {}))
-                        for name, value in annots.items():
+                                annots.update(getattr
+                                              (prop,
+                                               "_dbus_annotations",
+                                               {}))
+                        for name, value in annots.iteritems():
                             ann_tag = document.createElement(
                                 "annotation")
                             ann_tag.setAttribute("name", name)
@@ -1013,11 +983,11 @@
                 # Add interface annotation tags
                 for annotation, value in dict(
                     itertools.chain.from_iterable(
-                        annotations().items()
-                        for name, annotations
-                        in self._get_all_dbus_things("interface")
+                        annotations().iteritems()
+                        for name, annotations in
+                        self._get_all_dbus_things("interface")
                         if name == if_tag.getAttribute("name")
-                        )).items():
+                        )).iteritems():
                     ann_tag = document.createElement("annotation")
                     ann_tag.setAttribute("name", annotation)
                     ann_tag.setAttribute("value", value)
@@ -1050,7 +1020,8 @@
     """Convert a UTC datetime.datetime() to a D-Bus type."""
     if dt is None:
         return dbus.String("", variant_level = variant_level)
-    return dbus.String(dt.isoformat(), variant_level=variant_level)
+    return dbus.String(dt.isoformat(),
+                       variant_level=variant_level)
 
 
 def alternate_dbus_interfaces(alt_interface_names, deprecate=True):
@@ -1076,10 +1047,9 @@
     (from DBusObjectWithProperties) and interfaces (from the
     dbus_interface_annotations decorator).
     """
-    
     def wrapper(cls):
         for orig_interface_name, alt_interface_name in (
-                alt_interface_names.items()):
+            alt_interface_names.iteritems()):
             attr = {}
             interface_names = set()
             # Go though all attributes of the class
@@ -1087,37 +1057,39 @@
                 # Ignore non-D-Bus attributes, and D-Bus attributes
                 # with the wrong interface name
                 if (not hasattr(attribute, "_dbus_interface")
-                    or not attribute._dbus_interface.startswith(
-                        orig_interface_name)):
+                    or not attribute._dbus_interface
+                    .startswith(orig_interface_name)):
                     continue
                 # Create an alternate D-Bus interface name based on
                 # the current name
-                alt_interface = attribute._dbus_interface.replace(
-                    orig_interface_name, alt_interface_name)
+                alt_interface = (attribute._dbus_interface
+                                 .replace(orig_interface_name,
+                                          alt_interface_name))
                 interface_names.add(alt_interface)
                 # Is this a D-Bus signal?
                 if getattr(attribute, "_dbus_is_signal", False):
-                    # Extract the original non-method undecorated
-                    # function by black magic
+                    # Extract the original non-method function by
+                    # black magic
                     nonmethod_func = (dict(
-                        zip(attribute.func_code.co_freevars,
-                            attribute.__closure__))
-                                      ["func"].cell_contents)
+                            zip(attribute.func_code.co_freevars,
+                                attribute.__closure__))["func"]
+                                      .cell_contents)
                     # Create a new, but exactly alike, function
                     # object, and decorate it to be a new D-Bus signal
                     # with the alternate D-Bus interface name
-                    new_function = (dbus.service.signal(
-                        alt_interface, attribute._dbus_signature)
+                    new_function = (dbus.service.signal
+                                    (alt_interface,
+                                     attribute._dbus_signature)
                                     (types.FunctionType(
-                                        nonmethod_func.func_code,
-                                        nonmethod_func.func_globals,
-                                        nonmethod_func.func_name,
-                                        nonmethod_func.func_defaults,
-                                        nonmethod_func.func_closure)))
+                                nonmethod_func.func_code,
+                                nonmethod_func.func_globals,
+                                nonmethod_func.func_name,
+                                nonmethod_func.func_defaults,
+                                nonmethod_func.func_closure)))
                     # Copy annotations, if any
                     try:
-                        new_function._dbus_annotations = dict(
-                            attribute._dbus_annotations)
+                        new_function._dbus_annotations = (
+                            dict(attribute._dbus_annotations))
                     except AttributeError:
                         pass
                     # Define a creator of a function to call both the
@@ -1128,13 +1100,11 @@
                         """This function is a scope container to pass
                         func1 and func2 to the "call_both" function
                         outside of its arguments"""
-                        
                         def call_both(*args, **kwargs):
                             """This function will emit two D-Bus
                             signals by calling func1 and func2"""
                             func1(*args, **kwargs)
                             func2(*args, **kwargs)
-                        
                         return call_both
                     # Create the "call_both" function and add it to
                     # the class
@@ -1145,20 +1115,20 @@
                     # object.  Decorate it to be a new D-Bus method
                     # with the alternate D-Bus interface name.  Add it
                     # to the class.
-                    attr[attrname] = (
-                        dbus.service.method(
-                            alt_interface,
-                            attribute._dbus_in_signature,
-                            attribute._dbus_out_signature)
-                        (types.FunctionType(attribute.func_code,
-                                            attribute.func_globals,
-                                            attribute.func_name,
-                                            attribute.func_defaults,
-                                            attribute.func_closure)))
+                    attr[attrname] = (dbus.service.method
+                                      (alt_interface,
+                                       attribute._dbus_in_signature,
+                                       attribute._dbus_out_signature)
+                                      (types.FunctionType
+                                       (attribute.func_code,
+                                        attribute.func_globals,
+                                        attribute.func_name,
+                                        attribute.func_defaults,
+                                        attribute.func_closure)))
                     # Copy annotations, if any
                     try:
-                        attr[attrname]._dbus_annotations = dict(
-                            attribute._dbus_annotations)
+                        attr[attrname]._dbus_annotations = (
+                            dict(attribute._dbus_annotations))
                     except AttributeError:
                         pass
                 # Is this a D-Bus property?
@@ -1167,21 +1137,23 @@
                     # object, and decorate it to be a new D-Bus
                     # property with the alternate D-Bus interface
                     # name.  Add it to the class.
-                    attr[attrname] = (dbus_service_property(
-                        alt_interface, attribute._dbus_signature,
-                        attribute._dbus_access,
-                        attribute._dbus_get_args_options
-                        ["byte_arrays"])
-                                      (types.FunctionType(
-                                          attribute.func_code,
-                                          attribute.func_globals,
-                                          attribute.func_name,
-                                          attribute.func_defaults,
-                                          attribute.func_closure)))
+                    attr[attrname] = (dbus_service_property
+                                      (alt_interface,
+                                       attribute._dbus_signature,
+                                       attribute._dbus_access,
+                                       attribute
+                                       ._dbus_get_args_options
+                                       ["byte_arrays"])
+                                      (types.FunctionType
+                                       (attribute.func_code,
+                                        attribute.func_globals,
+                                        attribute.func_name,
+                                        attribute.func_defaults,
+                                        attribute.func_closure)))
                     # Copy annotations, if any
                     try:
-                        attr[attrname]._dbus_annotations = dict(
-                            attribute._dbus_annotations)
+                        attr[attrname]._dbus_annotations = (
+                            dict(attribute._dbus_annotations))
                     except AttributeError:
                         pass
                 # Is this a D-Bus interface?
@@ -1190,22 +1162,22 @@
                     # object.  Decorate it to be a new D-Bus interface
                     # with the alternate D-Bus interface name.  Add it
                     # to the class.
-                    attr[attrname] = (
-                        dbus_interface_annotations(alt_interface)
-                        (types.FunctionType(attribute.func_code,
-                                            attribute.func_globals,
-                                            attribute.func_name,
-                                            attribute.func_defaults,
-                                            attribute.func_closure)))
+                    attr[attrname] = (dbus_interface_annotations
+                                      (alt_interface)
+                                      (types.FunctionType
+                                       (attribute.func_code,
+                                        attribute.func_globals,
+                                        attribute.func_name,
+                                        attribute.func_defaults,
+                                        attribute.func_closure)))
             if deprecate:
                 # Deprecate all alternate interfaces
-                iname="_AlternateDBusNames_interface_annotation{}"
+                iname="_AlternateDBusNames_interface_annotation{0}"
                 for interface_name in interface_names:
-                    
                     @dbus_interface_annotations(interface_name)
                     def func(self):
                         return { "org.freedesktop.DBus.Deprecated":
-                                 "true" }
+                                     "true" }
                     # Find an unused name
                     for aname in (iname.format(i)
                                   for i in itertools.count()):
@@ -1215,15 +1187,14 @@
             if interface_names:
                 # Replace the class with a new subclass of it with
                 # methods, signals, etc. as created above.
-                cls = type(b"{}Alternate".format(cls.__name__),
-                           (cls, ), attr)
+                cls = type(b"{0}Alternate".format(cls.__name__),
+                           (cls,), attr)
         return cls
-    
     return wrapper
 
 
 @alternate_dbus_interfaces({"se.recompile.Mandos":
-                            "se.bsnet.fukt.Mandos"})
+                                "se.bsnet.fukt.Mandos"})
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -1233,9 +1204,7 @@
     """
     
     runtime_expansions = (Client.runtime_expansions
-                          + ("dbus_object_path", ))
-    
-    _interface = "se.recompile.Mandos.Client"
+                          + ("dbus_object_path",))
     
     # dbus.service.Object doesn't use super(), so we can't either.
     
@@ -1244,19 +1213,17 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = str(self.name).translate(
+        client_object_name = unicode(self.name).translate(
             {ord("."): ord("_"),
              ord("-"): ord("_")})
-        self.dbus_object_path = dbus.ObjectPath(
-            "/clients/" + client_object_name)
+        self.dbus_object_path = (dbus.ObjectPath
+                                 ("/clients/" + client_object_name))
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
     
-    def notifychangeproperty(transform_func, dbus_name,
-                             type_func=lambda x: x,
-                             variant_level=1,
-                             invalidate_only=False,
-                             _interface=_interface):
+    def notifychangeproperty(transform_func,
+                             dbus_name, type_func=lambda x: x,
+                             variant_level=1):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
         
@@ -1267,28 +1234,17 @@
                    to the D-Bus.  Default: no transform
         variant_level: D-Bus variant level.  Default: 1
         """
-        attrname = "_{}".format(dbus_name)
-        
+        attrname = "_{0}".format(dbus_name)
         def setter(self, value):
             if hasattr(self, "dbus_object_path"):
                 if (not hasattr(self, attrname) or
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
-                    if invalidate_only:
-                        self.PropertiesChanged(
-                            _interface, dbus.Dictionary(),
-                            dbus.Array((dbus_name, )))
-                    else:
-                        dbus_value = transform_func(
-                            type_func(value),
-                            variant_level = variant_level)
-                        self.PropertyChanged(dbus.String(dbus_name),
-                                             dbus_value)
-                        self.PropertiesChanged(
-                            _interface,
-                            dbus.Dictionary({ dbus.String(dbus_name):
-                                              dbus_value }),
-                            dbus.Array())
+                    dbus_value = transform_func(type_func(value),
+                                                variant_level
+                                                =variant_level)
+                    self.PropertyChanged(dbus.String(dbus_name),
+                                         dbus_value)
             setattr(self, attrname, value)
         
         return property(lambda self: getattr(self, attrname), setter)
@@ -1300,9 +1256,9 @@
     enabled = notifychangeproperty(dbus.Boolean, "Enabled")
     last_enabled = notifychangeproperty(datetime_to_dbus,
                                         "LastEnabled")
-    checker = notifychangeproperty(
-        dbus.Boolean, "CheckerRunning",
-        type_func = lambda checker: checker is not None)
+    checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
+                                   type_func = lambda checker:
+                                       checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
     last_checker_status = notifychangeproperty(dbus.Int16,
@@ -1311,25 +1267,25 @@
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(
-        dbus.UInt64, "ApprovalDelay",
-        type_func = lambda td: td.total_seconds() * 1000)
+    approval_delay = notifychangeproperty(dbus.UInt64,
+                                          "ApprovalDelay",
+                                          type_func =
+                                          timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
         dbus.UInt64, "ApprovalDuration",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
-    timeout = notifychangeproperty(
-        dbus.UInt64, "Timeout",
-        type_func = lambda td: td.total_seconds() * 1000)
+    timeout = notifychangeproperty(dbus.UInt64, "Timeout",
+                                   type_func =
+                                   timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
         dbus.UInt64, "ExtendedTimeout",
-        type_func = lambda td: td.total_seconds() * 1000)
-    interval = notifychangeproperty(
-        dbus.UInt64, "Interval",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt64,
+                                    "Interval",
+                                    type_func =
+                                    timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
-    secret = notifychangeproperty(dbus.ByteArray, "Secret",
-                                  invalidate_only=True)
     
     del notifychangeproperty
     
@@ -1342,27 +1298,31 @@
             DBusObjectWithProperties.__del__(self, *args, **kwargs)
         Client.__del__(self, *args, **kwargs)
     
-    def checker_callback(self, source, condition,
-                         (connection, command), *args, **kwargs):
-        ret = Client.checker_callback(self, source, condition,
-                                      (connection, command), *args,
-                                      **kwargs)
-        exitstatus = self.last_checker_status
-        if exitstatus >= 0:
+    def checker_callback(self, pid, condition, command,
+                         *args, **kwargs):
+        self.checker_callback_tag = None
+        self.checker = None
+        if os.WIFEXITED(condition):
+            exitstatus = os.WEXITSTATUS(condition)
             # Emit D-Bus signal
             self.CheckerCompleted(dbus.Int16(exitstatus),
-                                  dbus.Int64(0),
+                                  dbus.Int64(condition),
                                   dbus.String(command))
         else:
             # Emit D-Bus signal
             self.CheckerCompleted(dbus.Int16(-1),
-                                  dbus.Int64(
-                                      self.last_checker_signal),
+                                  dbus.Int64(condition),
                                   dbus.String(command))
-        return ret
+        
+        return Client.checker_callback(self, pid, condition, command,
+                                       *args, **kwargs)
     
     def start_checker(self, *args, **kwargs):
-        old_checker_pid = getattr(self.checker, "pid", None)
+        old_checker = self.checker
+        if self.checker is not None:
+            old_checker_pid = self.checker.pid
+        else:
+            old_checker_pid = None
         r = Client.start_checker(self, *args, **kwargs)
         # Only if new checker process was started
         if (self.checker is not None
@@ -1377,14 +1337,21 @@
     
     def approve(self, value=True):
         self.approved = value
-        gobject.timeout_add(int(self.approval_duration.total_seconds()
-                                * 1000), self._reset_approved)
+        gobject.timeout_add(timedelta_to_milliseconds
+                            (self.approval_duration),
+                            self._reset_approved)
         self.send_changedstate()
     
     ## D-Bus methods, signals & properties
+    _interface = "se.recompile.Mandos.Client"
     
     ## Interfaces
     
+    @dbus_interface_annotations(_interface)
+    def _foo(self):
+        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
+                     "false"}
+    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1400,7 +1367,6 @@
         pass
     
     # PropertyChanged - signal
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.signal(_interface, signature="sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
@@ -1470,8 +1436,7 @@
         return dbus.Boolean(bool(self.approvals_pending))
     
     # ApprovedByDefault - property
-    @dbus_service_property(_interface,
-                           signature="b",
+    @dbus_service_property(_interface, signature="b",
                            access="readwrite")
     def ApprovedByDefault_dbus_property(self, value=None):
         if value is None:       # get
@@ -1479,23 +1444,20 @@
         self.approved_by_default = bool(value)
     
     # ApprovalDelay - property
-    @dbus_service_property(_interface,
-                           signature="t",
+    @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_delay.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.approval_delay_milliseconds())
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
     
     # ApprovalDuration - property
-    @dbus_service_property(_interface,
-                           signature="t",
+    @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_duration.total_seconds()
-                               * 1000)
+            return dbus.UInt64(timedelta_to_milliseconds(
+                    self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
     # Name - property
@@ -1509,13 +1471,12 @@
         return dbus.String(self.fingerprint)
     
     # Host - property
-    @dbus_service_property(_interface,
-                           signature="s",
+    @dbus_service_property(_interface, signature="s",
                            access="readwrite")
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = str(value)
+        self.host = unicode(value)
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1528,8 +1489,7 @@
         return datetime_to_dbus(self.last_enabled)
     
     # Enabled - property
-    @dbus_service_property(_interface,
-                           signature="b",
+    @dbus_service_property(_interface, signature="b",
                            access="readwrite")
     def Enabled_dbus_property(self, value=None):
         if value is None:       # get
@@ -1540,8 +1500,7 @@
             self.disable()
     
     # LastCheckedOK - property
-    @dbus_service_property(_interface,
-                           signature="s",
+    @dbus_service_property(_interface, signature="s",
                            access="readwrite")
     def LastCheckedOK_dbus_property(self, value=None):
         if value is not None:
@@ -1550,7 +1509,8 @@
         return datetime_to_dbus(self.last_checked_ok)
     
     # LastCheckerStatus - property
-    @dbus_service_property(_interface, signature="n", access="read")
+    @dbus_service_property(_interface, signature="n",
+                           access="read")
     def LastCheckerStatus_dbus_property(self):
         return dbus.Int16(self.last_checker_status)
     
@@ -1565,12 +1525,11 @@
         return datetime_to_dbus(self.last_approval_request)
     
     # Timeout - property
-    @dbus_service_property(_interface,
-                           signature="t",
+    @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.timeout.total_seconds() * 1000)
+            return dbus.UInt64(self.timeout_milliseconds())
         old_timeout = self.timeout
         self.timeout = datetime.timedelta(0, 0, 0, value)
         # Reschedule disabling
@@ -1585,49 +1544,45 @@
                     is None):
                     return
                 gobject.source_remove(self.disable_initiator_tag)
-                self.disable_initiator_tag = gobject.timeout_add(
-                    int((self.expires - now).total_seconds() * 1000),
-                    self.disable)
+                self.disable_initiator_tag = (
+                    gobject.timeout_add(
+                        timedelta_to_milliseconds(self.expires - now),
+                        self.disable))
     
     # ExtendedTimeout - property
-    @dbus_service_property(_interface,
-                           signature="t",
+    @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ExtendedTimeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.extended_timeout.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.extended_timeout_milliseconds())
         self.extended_timeout = datetime.timedelta(0, 0, 0, value)
     
     # Interval - property
-    @dbus_service_property(_interface,
-                           signature="t",
+    @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.interval.total_seconds() * 1000)
+            return dbus.UInt64(self.interval_milliseconds())
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
         if self.enabled:
             # Reschedule checker run
             gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = gobject.timeout_add(
-                value, self.start_checker)
-            self.start_checker() # Start one now, too
+            self.checker_initiator_tag = (gobject.timeout_add
+                                          (value, self.start_checker))
+            self.start_checker()    # Start one now, too
     
     # Checker - property
-    @dbus_service_property(_interface,
-                           signature="s",
+    @dbus_service_property(_interface, signature="s",
                            access="readwrite")
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = str(value)
+        self.checker_command = unicode(value)
     
     # CheckerRunning - property
-    @dbus_service_property(_interface,
-                           signature="b",
+    @dbus_service_property(_interface, signature="b",
                            access="readwrite")
     def CheckerRunning_dbus_property(self, value=None):
         if value is None:       # get
@@ -1643,12 +1598,10 @@
         return self.dbus_object_path # is already a dbus.ObjectPath
     
     # Secret = property
-    @dbus_service_property(_interface,
-                           signature="ay",
-                           access="write",
-                           byte_arrays=True)
+    @dbus_service_property(_interface, signature="ay",
+                           access="write", byte_arrays=True)
     def Secret_dbus_property(self, value):
-        self.secret = bytes(value)
+        self.secret = str(value)
     
     del _interface
 
@@ -1668,11 +1621,9 @@
         if data[0] == 'data':
             return data[1]
         if data[0] == 'function':
-            
             def func(*args, **kwargs):
                 self._pipe.send(('funcall', name, args, kwargs))
                 return self._pipe.recv()[1]
-            
             return func
     
     def __setattr__(self, name, value):
@@ -1690,12 +1641,14 @@
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
             logger.info("TCP connection from: %s",
-                        str(self.client_address))
+                        unicode(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
-            session = gnutls.connection.ClientSession(
-                self.request, gnutls.connection .X509Credentials())
+            session = (gnutls.connection
+                       .ClientSession(self.request,
+                                      gnutls.connection
+                                      .X509Credentials()))
             
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
@@ -1710,8 +1663,9 @@
             priority = self.server.gnutls_priority
             if priority is None:
                 priority = "NORMAL"
-            gnutls.library.functions.gnutls_priority_set_direct(
-                session._c_object, priority, None)
+            (gnutls.library.functions
+             .gnutls_priority_set_direct(session._c_object,
+                                         priority, None))
             
             # Start communication using the Mandos protocol
             # Get protocol number
@@ -1719,7 +1673,7 @@
             logger.debug("Protocol version: %r", line)
             try:
                 if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError(line)
+                    raise RuntimeError
             except (ValueError, IndexError, RuntimeError) as error:
                 logger.error("Unknown protocol version: %s", error)
                 return
@@ -1737,8 +1691,8 @@
             approval_required = False
             try:
                 try:
-                    fpr = self.fingerprint(
-                        self.peer_certificate(session))
+                    fpr = self.fingerprint(self.peer_certificate
+                                           (session))
                 except (TypeError,
                         gnutls.errors.GNUTLSError) as error:
                     logger.warning("Bad certificate: %s", error)
@@ -1759,7 +1713,7 @@
                 while True:
                     if not client.enabled:
                         logger.info("Client %s is disabled",
-                                    client.name)
+                                       client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.Rejected("Disabled")
@@ -1774,8 +1728,8 @@
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.NeedApproval(
-                                client.approval_delay.total_seconds()
-                                * 1000, client.approved_by_default)
+                                client.approval_delay_milliseconds(),
+                                client.approved_by_default)
                     else:
                         logger.warning("Client %s was not approved",
                                        client.name)
@@ -1787,7 +1741,9 @@
                     #wait until timeout or approved
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(delay.total_seconds())
+                    client.changedstate.wait(
+                        float(timedelta_to_milliseconds(delay)
+                              / 1000))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1812,9 +1768,9 @@
                         logger.warning("gnutls send failed",
                                        exc_info=error)
                         return
-                    logger.debug("Sent: %d, remaining: %d", sent,
-                                 len(client.secret) - (sent_size
-                                                       + sent))
+                    logger.debug("Sent: %d, remaining: %d",
+                                 sent, len(client.secret)
+                                 - (sent_size + sent))
                     sent_size += sent
                 
                 logger.info("Sending secret to %s", client.name)
@@ -1837,8 +1793,8 @@
     def peer_certificate(session):
         "Return the peer's OpenPGP certificate as a bytestring"
         # If not an OpenPGP certificate...
-        if (gnutls.library.functions.gnutls_certificate_type_get(
-                session._c_object)
+        if (gnutls.library.functions
+            .gnutls_certificate_type_get(session._c_object)
             != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
             # ...do the normal thing
             return session.peer_certificate
@@ -1858,32 +1814,36 @@
     def fingerprint(openpgp):
         "Convert an OpenPGP bytestring to a hexdigit fingerprint"
         # New GnuTLS "datum" with the OpenPGP public key
-        datum = gnutls.library.types.gnutls_datum_t(
-            ctypes.cast(ctypes.c_char_p(openpgp),
-                        ctypes.POINTER(ctypes.c_ubyte)),
-            ctypes.c_uint(len(openpgp)))
+        datum = (gnutls.library.types
+                 .gnutls_datum_t(ctypes.cast(ctypes.c_char_p(openpgp),
+                                             ctypes.POINTER
+                                             (ctypes.c_ubyte)),
+                                 ctypes.c_uint(len(openpgp))))
         # New empty GnuTLS certificate
         crt = gnutls.library.types.gnutls_openpgp_crt_t()
-        gnutls.library.functions.gnutls_openpgp_crt_init(
-            ctypes.byref(crt))
+        (gnutls.library.functions
+         .gnutls_openpgp_crt_init(ctypes.byref(crt)))
         # Import the OpenPGP public key into the certificate
-        gnutls.library.functions.gnutls_openpgp_crt_import(
-            crt, ctypes.byref(datum),
-            gnutls.library.constants.GNUTLS_OPENPGP_FMT_RAW)
+        (gnutls.library.functions
+         .gnutls_openpgp_crt_import(crt, ctypes.byref(datum),
+                                    gnutls.library.constants
+                                    .GNUTLS_OPENPGP_FMT_RAW))
         # Verify the self signature in the key
         crtverify = ctypes.c_uint()
-        gnutls.library.functions.gnutls_openpgp_crt_verify_self(
-            crt, 0, ctypes.byref(crtverify))
+        (gnutls.library.functions
+         .gnutls_openpgp_crt_verify_self(crt, 0,
+                                         ctypes.byref(crtverify)))
         if crtverify.value != 0:
             gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
-            raise gnutls.errors.CertificateSecurityError(
-                "Verify failed")
+            raise (gnutls.errors.CertificateSecurityError
+                   ("Verify failed"))
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
         # Get the fingerprint from the certificate into the buffer
-        gnutls.library.functions.gnutls_openpgp_crt_get_fingerprint(
-            crt, ctypes.byref(buf), ctypes.byref(buf_len))
+        (gnutls.library.functions
+         .gnutls_openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
+                                             ctypes.byref(buf_len)))
         # Deinit the certificate
         gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
         # Convert the buffer to a Python bytestring
@@ -1895,7 +1855,6 @@
 
 class MultiprocessingMixIn(object):
     """Like socketserver.ThreadingMixIn, but with multiprocessing"""
-    
     def sub_process_main(self, request, address):
         try:
             self.finish_request(request, address)
@@ -1913,7 +1872,6 @@
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
     """ adds a pipe to the MixIn """
-    
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
         
@@ -1928,7 +1886,7 @@
     
     def add_pipe(self, parent_pipe, proc):
         """Dummy function; override as necessary"""
-        raise NotImplementedError()
+        raise NotImplementedError
 
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
@@ -1940,11 +1898,8 @@
         interface:      None or a network interface name (string)
         use_ipv6:       Boolean; to use IPv6 or not
     """
-    
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None,
-                 use_ipv6=True,
-                 socketfd=None):
+                 interface=None, use_ipv6=True, socketfd=None):
         """If socketfd is set, use that file descriptor instead of
         creating a new one with socket.socket().
         """
@@ -1991,20 +1946,23 @@
                              self.interface)
             else:
                 try:
-                    self.socket.setsockopt(
-                        socket.SOL_SOCKET, SO_BINDTODEVICE,
-                        (self.interface + "\0").encode("utf-8"))
+                    self.socket.setsockopt(socket.SOL_SOCKET,
+                                           SO_BINDTODEVICE,
+                                           str(self.interface
+                                               + '\0'))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
-                        logger.error("No permission to bind to"
-                                     " interface %s", self.interface)
+                        logger.error("No permission to"
+                                     " bind to interface %s",
+                                     self.interface)
                     elif error.errno == errno.ENOPROTOOPT:
                         logger.error("SO_BINDTODEVICE not available;"
                                      " cannot bind to interface %s",
                                      self.interface)
                     elif error.errno == errno.ENODEV:
-                        logger.error("Interface %s does not exist,"
-                                     " cannot bind", self.interface)
+                        logger.error("Interface %s does not"
+                                     " exist, cannot bind",
+                                     self.interface)
                     else:
                         raise
         # Only bind(2) the socket if we really need to.
@@ -2013,11 +1971,12 @@
                 if self.address_family == socket.AF_INET6:
                     any_address = "::" # in6addr_any
                 else:
-                    any_address = "0.0.0.0" # INADDR_ANY
+                    any_address = socket.INADDR_ANY
                 self.server_address = (any_address,
                                        self.server_address[1])
             elif not self.server_address[1]:
-                self.server_address = (self.server_address[0], 0)
+                self.server_address = (self.server_address[0],
+                                       0)
 #                 if self.interface:
 #                     self.server_address = (self.server_address[0],
 #                                            0, # port
@@ -2037,14 +1996,9 @@
     
     Assumes a gobject.MainLoop event loop.
     """
-    
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None,
-                 use_ipv6=True,
-                 clients=None,
-                 gnutls_priority=None,
-                 use_dbus=True,
-                 socketfd=None):
+                 interface=None, use_ipv6=True, clients=None,
+                 gnutls_priority=None, use_dbus=True, socketfd=None):
         self.enabled = False
         self.clients = clients
         if self.clients is None:
@@ -2056,7 +2010,6 @@
                                 interface = interface,
                                 use_ipv6 = use_ipv6,
                                 socketfd = socketfd)
-    
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
@@ -2066,17 +2019,15 @@
     
     def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(
-            parent_pipe.fileno(),
-            gobject.IO_IN | gobject.IO_HUP,
-            functools.partial(self.handle_ipc,
-                              parent_pipe = parent_pipe,
-                              proc = proc))
+        gobject.io_add_watch(parent_pipe.fileno(),
+                             gobject.IO_IN | gobject.IO_HUP,
+                             functools.partial(self.handle_ipc,
+                                               parent_pipe =
+                                               parent_pipe,
+                                               proc = proc))
     
-    def handle_ipc(self, source, condition,
-                   parent_pipe=None,
-                   proc = None,
-                   client_object=None):
+    def handle_ipc(self, source, condition, parent_pipe=None,
+                   proc = None, client_object=None):
         # error, or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | gobject.IO_HUP):
             # Wait for other process to exit
@@ -2105,13 +2056,14 @@
                 parent_pipe.send(False)
                 return False
             
-            gobject.io_add_watch(
-                parent_pipe.fileno(),
-                gobject.IO_IN | gobject.IO_HUP,
-                functools.partial(self.handle_ipc,
-                                  parent_pipe = parent_pipe,
-                                  proc = proc,
-                                  client_object = client))
+            gobject.io_add_watch(parent_pipe.fileno(),
+                                 gobject.IO_IN | gobject.IO_HUP,
+                                 functools.partial(self.handle_ipc,
+                                                   parent_pipe =
+                                                   parent_pipe,
+                                                   proc = proc,
+                                                   client_object =
+                                                   client))
             parent_pipe.send(True)
             # remove the old hook in favor of the new above hook on
             # same fileno
@@ -2123,15 +2075,15 @@
             
             parent_pipe.send(('data', getattr(client_object,
                                               funcname)(*args,
-                                                        **kwargs)))
+                                                         **kwargs)))
         
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
-                parent_pipe.send(('function', ))
+                parent_pipe.send(('function',))
             else:
-                parent_pipe.send((
-                    'data', client_object.__getattribute__(attrname)))
+                parent_pipe.send(('data', client_object
+                                  .__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
@@ -2141,110 +2093,6 @@
         return True
 
 
-def rfc3339_duration_to_delta(duration):
-    """Parse an RFC 3339 "duration" and return a datetime.timedelta
-    
-    >>> rfc3339_duration_to_delta("P7D")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT60S")
-    datetime.timedelta(0, 60)
-    >>> rfc3339_duration_to_delta("PT60M")
-    datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("PT24H")
-    datetime.timedelta(1)
-    >>> rfc3339_duration_to_delta("P1W")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT5M30S")
-    datetime.timedelta(0, 330)
-    >>> rfc3339_duration_to_delta("P1DT3M20S")
-    datetime.timedelta(1, 200)
-    """
-    
-    # Parsing an RFC 3339 duration with regular expressions is not
-    # possible - there would have to be multiple places for the same
-    # values, like seconds.  The current code, while more esoteric, is
-    # cleaner without depending on a parsing library.  If Python had a
-    # built-in library for parsing we would use it, but we'd like to
-    # avoid excessive use of external libraries.
-    
-    # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
-    Token = collections.namedtuple("Token", (
-        "regexp",  # To match token; if "value" is not None, must have
-                   # a "group" containing digits
-        "value",   # datetime.timedelta or None
-        "followers"))           # Tokens valid after this token
-    # RFC 3339 "duration" tokens, syntax, and semantics; taken from
-    # the "duration" ABNF definition in RFC 3339, Appendix A.
-    token_end = Token(re.compile(r"$"), None, frozenset())
-    token_second = Token(re.compile(r"(\d+)S"),
-                         datetime.timedelta(seconds=1),
-                         frozenset((token_end, )))
-    token_minute = Token(re.compile(r"(\d+)M"),
-                         datetime.timedelta(minutes=1),
-                         frozenset((token_second, token_end)))
-    token_hour = Token(re.compile(r"(\d+)H"),
-                       datetime.timedelta(hours=1),
-                       frozenset((token_minute, token_end)))
-    token_time = Token(re.compile(r"T"),
-                       None,
-                       frozenset((token_hour, token_minute,
-                                  token_second)))
-    token_day = Token(re.compile(r"(\d+)D"),
-                      datetime.timedelta(days=1),
-                      frozenset((token_time, token_end)))
-    token_month = Token(re.compile(r"(\d+)M"),
-                        datetime.timedelta(weeks=4),
-                        frozenset((token_day, token_end)))
-    token_year = Token(re.compile(r"(\d+)Y"),
-                       datetime.timedelta(weeks=52),
-                       frozenset((token_month, token_end)))
-    token_week = Token(re.compile(r"(\d+)W"),
-                       datetime.timedelta(weeks=1),
-                       frozenset((token_end, )))
-    token_duration = Token(re.compile(r"P"), None,
-                           frozenset((token_year, token_month,
-                                      token_day, token_time,
-                                      token_week)))
-    # Define starting values
-    value = datetime.timedelta() # Value so far
-    found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
-    s = duration                # String left to parse
-    # Loop until end token is found
-    while found_token is not token_end:
-        # Search for any currently valid tokens
-        for token in followers:
-            match = token.regexp.match(s)
-            if match is not None:
-                # Token found
-                if token.value is not None:
-                    # Value found, parse digits
-                    factor = int(match.group(1), 10)
-                    # Add to value so far
-                    value += factor * token.value
-                # Strip token from string
-                s = token.regexp.sub("", s, 1)
-                # Go to found token
-                found_token = token
-                # Set valid next tokens
-                followers = found_token.followers
-                break
-        else:
-            # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
-    # End token found
-    return value
-
-
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
     
@@ -2261,16 +2109,10 @@
     >>> string_to_delta('5m 30s')
     datetime.timedelta(0, 330)
     """
-    
-    try:
-        return rfc3339_duration_to_delta(interval)
-    except ValueError:
-        pass
-    
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = s[-1]
+            suffix = unicode(s[-1])
             value = int(s[:-1])
             if suffix == "d":
                 delta = datetime.timedelta(value)
@@ -2283,8 +2125,9 @@
             elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix {!r}".format(suffix))
-        except IndexError as e:
+                raise ValueError("Unknown suffix {0!r}"
+                                 .format(suffix))
+        except (ValueError, IndexError) as e:
             raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
@@ -2306,7 +2149,7 @@
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
-                          "{} not a character device"
+                          "{0} not a character device"
                           .format(os.devnull))
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -2322,7 +2165,7 @@
     
     parser = argparse.ArgumentParser()
     parser.add_argument("-v", "--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-i", "--interface", metavar="IF",
                         help="Bind to interface IF")
@@ -2334,7 +2177,7 @@
                         help="Run self-test")
     parser.add_argument("--debug", action="store_true",
                         help="Debug mode; run in foreground and log"
-                        " to terminal", default=None)
+                        " to terminal")
     parser.add_argument("--debuglevel", metavar="LEVEL",
                         help="Debug level for stdout output")
     parser.add_argument("--priority", help="GnuTLS"
@@ -2347,30 +2190,24 @@
                         " files")
     parser.add_argument("--no-dbus", action="store_false",
                         dest="use_dbus", help="Do not provide D-Bus"
-                        " system bus interface", default=None)
+                        " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
-                        dest="use_ipv6", help="Do not use IPv6",
-                        default=None)
+                        dest="use_ipv6", help="Do not use IPv6")
     parser.add_argument("--no-restore", action="store_false",
                         dest="restore", help="Do not restore stored"
-                        " state", default=None)
+                        " state")
     parser.add_argument("--socket", type=int,
                         help="Specify a file descriptor to a network"
                         " socket to use instead of creating one")
     parser.add_argument("--statedir", metavar="DIR",
                         help="Directory to save/restore state in")
-    parser.add_argument("--foreground", action="store_true",
-                        help="Run in foreground", default=None)
-    parser.add_argument("--no-zeroconf", action="store_false",
-                        dest="zeroconf", help="Do not use Zeroconf",
-                        default=None)
     
     options = parser.parse_args()
     
     if options.check:
         import doctest
-        fail_count, test_count = doctest.testmod()
-        sys.exit(os.EX_OK if fail_count == 0 else 1)
+        doctest.testmod()
+        sys.exit()
     
     # Default values for config file for server-global settings
     server_defaults = { "interface": "",
@@ -2378,27 +2215,25 @@
                         "port": "",
                         "debug": "False",
                         "priority":
-                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA"
-                        ":+SIGN-RSA-SHA224:+SIGN-RSA-RMD160",
+                        "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
                         "servicename": "Mandos",
                         "use_dbus": "True",
                         "use_ipv6": "True",
                         "debuglevel": "",
                         "restore": "True",
                         "socket": "",
-                        "statedir": "/var/lib/mandos",
-                        "foreground": "False",
-                        "zeroconf": "True",
-                    }
+                        "statedir": "/var/lib/mandos"
+                        }
     
     # Parse config file for server-global settings
     server_config = configparser.SafeConfigParser(server_defaults)
     del server_defaults
-    server_config.read(os.path.join(options.configdir, "mandos.conf"))
+    server_config.read(os.path.join(options.configdir,
+                                    "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
-    for option in ("debug", "use_dbus", "use_ipv6", "foreground"):
+    for option in ("debug", "use_dbus", "use_ipv6"):
         server_settings[option] = server_config.getboolean("DEFAULT",
                                                            option)
     if server_settings["port"]:
@@ -2418,34 +2253,21 @@
     # Override the settings from the config file with command line
     # options, if set.
     for option in ("interface", "address", "port", "debug",
-                   "priority", "servicename", "configdir", "use_dbus",
-                   "use_ipv6", "debuglevel", "restore", "statedir",
-                   "socket", "foreground", "zeroconf"):
+                   "priority", "servicename", "configdir",
+                   "use_dbus", "use_ipv6", "debuglevel", "restore",
+                   "statedir", "socket"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
     del options
     # Force all strings to be unicode
     for option in server_settings.keys():
-        if isinstance(server_settings[option], bytes):
-            server_settings[option] = (server_settings[option]
-                                       .decode("utf-8"))
-    # Force all boolean options to be boolean
-    for option in ("debug", "use_dbus", "use_ipv6", "restore",
-                   "foreground", "zeroconf"):
-        server_settings[option] = bool(server_settings[option])
-    # Debug implies foreground
-    if server_settings["debug"]:
-        server_settings["foreground"] = True
+        if type(server_settings[option]) is str:
+            server_settings[option] = unicode(server_settings[option])
     # Now we have our good server settings in "server_settings"
     
     ##################################################################
     
-    if (not server_settings["zeroconf"]
-        and not (server_settings["port"]
-                 or server_settings["socket"] != "")):
-        parser.error("Needs port or socket to work without Zeroconf")
-    
     # For convenience
     debug = server_settings["debug"]
     debuglevel = server_settings["debuglevel"]
@@ -2453,8 +2275,6 @@
     use_ipv6 = server_settings["use_ipv6"]
     stored_state_path = os.path.join(server_settings["statedir"],
                                      stored_state_file)
-    foreground = server_settings["foreground"]
-    zeroconf = server_settings["zeroconf"]
     
     if debug:
         initlogger(debug, logging.DEBUG)
@@ -2466,10 +2286,11 @@
             initlogger(debug, level)
     
     if server_settings["servicename"] != "Mandos":
-        syslogger.setFormatter(
-            logging.Formatter('Mandos ({}) [%(process)d]:'
-                              ' %(levelname)s: %(message)s'.format(
-                                  server_settings["servicename"])))
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos ({0}) [%(process)d]:'
+                                ' %(levelname)s: %(message)s'
+                                .format(server_settings
+                                        ["servicename"])))
     
     # Parse config file with clients
     client_config = configparser.SafeConfigParser(Client
@@ -2480,22 +2301,19 @@
     global mandos_dbus_service
     mandos_dbus_service = None
     
-    socketfd = None
-    if server_settings["socket"] != "":
-        socketfd = server_settings["socket"]
-    tcp_server = MandosServer(
-        (server_settings["address"], server_settings["port"]),
-        ClientHandler,
-        interface=(server_settings["interface"] or None),
-        use_ipv6=use_ipv6,
-        gnutls_priority=server_settings["priority"],
-        use_dbus=use_dbus,
-        socketfd=socketfd)
-    if not foreground:
-        pidfilename = "/run/mandos.pid"
-        if not os.path.isdir("/run/."):
-            pidfilename = "/var/run/mandos.pid"
-        pidfile = None
+    tcp_server = MandosServer((server_settings["address"],
+                               server_settings["port"]),
+                              ClientHandler,
+                              interface=(server_settings["interface"]
+                                         or None),
+                              use_ipv6=use_ipv6,
+                              gnutls_priority=
+                              server_settings["priority"],
+                              use_dbus=use_dbus,
+                              socketfd=(server_settings["socket"]
+                                        or None))
+    if not debug:
+        pidfilename = "/var/run/mandos.pid"
         try:
             pidfile = open(pidfilename, "w")
         except IOError as e:
@@ -2517,7 +2335,7 @@
         os.setuid(uid)
     except OSError as error:
         if error.errno != errno.EPERM:
-            raise
+            raise error
     
     if debug:
         # Enable all possible GnuTLS debugging
@@ -2530,8 +2348,8 @@
         def debug_gnutls(level, string):
             logger.debug("GnuTLS: %s", string[:-1])
         
-        gnutls.library.functions.gnutls_global_set_log_function(
-            debug_gnutls)
+        (gnutls.library.functions
+         .gnutls_global_set_log_function(debug_gnutls))
         
         # Redirect stdin so all checkers get /dev/null
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
@@ -2540,7 +2358,7 @@
             os.close(null)
     
     # Need to fork before connecting to D-Bus
-    if not foreground:
+    if not debug:
         # Close all input and output, do double fork, etc.
         daemon()
     
@@ -2557,26 +2375,23 @@
     if use_dbus:
         try:
             bus_name = dbus.service.BusName("se.recompile.Mandos",
-                                            bus,
-                                            do_not_queue=True)
-            old_bus_name = dbus.service.BusName(
-                "se.bsnet.fukt.Mandos", bus,
-                do_not_queue=True)
+                                            bus, do_not_queue=True)
+            old_bus_name = (dbus.service.BusName
+                            ("se.bsnet.fukt.Mandos", bus,
+                             do_not_queue=True))
         except dbus.exceptions.NameExistsException as e:
             logger.error("Disabling D-Bus:", exc_info=e)
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
-    if zeroconf:
-        protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-        service = AvahiServiceToSyslog(
-            name = server_settings["servicename"],
-            servicetype = "_mandos._tcp",
-            protocol = protocol,
-            bus = bus)
-        if server_settings["interface"]:
-            service.interface = if_nametoindex(
-                server_settings["interface"].encode("utf-8"))
+    protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
+    service = AvahiServiceToSyslog(name =
+                                   server_settings["servicename"],
+                                   servicetype = "_mandos._tcp",
+                                   protocol = protocol, bus = bus)
+    if server_settings["interface"]:
+        service.interface = (if_nametoindex
+                             (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2589,40 +2404,27 @@
     old_client_settings = {}
     clients_data = {}
     
-    # This is used to redirect stdout and stderr for checker processes
-    global wnull
-    wnull = open(os.devnull, "w") # A writable /dev/null
-    # Only used if server is running in foreground but not in debug
-    # mode
-    if debug or not foreground:
-        wnull.close()
-    
     # Get client data and settings from last running state.
     if server_settings["restore"]:
         try:
             with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = pickle.load(
-                    stored_state)
+                clients_data, old_client_settings = (pickle.load
+                                                     (stored_state))
             os.remove(stored_state_path)
         except IOError as e:
             if e.errno == errno.ENOENT:
-                logger.warning("Could not load persistent state:"
-                               " {}".format(os.strerror(e.errno)))
+                logger.warning("Could not load persistent state: {0}"
+                                .format(os.strerror(e.errno)))
             else:
                 logger.critical("Could not load persistent state:",
                                 exc_info=e)
                 raise
         except EOFError as e:
             logger.warning("Could not load persistent state: "
-                           "EOFError:",
-                           exc_info=e)
+                           "EOFError:", exc_info=e)
     
     with PGPEngine() as pgp:
-        for client_name, client in clients_data.items():
-            # Skip removed clients
-            if client_name not in client_settings:
-                continue
-            
+        for client_name, client in clients_data.iteritems():
             # Decide which value to use after restoring saved state.
             # We have three different values: Old config file,
             # new config file, and saved state.
@@ -2633,15 +2435,15 @@
                     # For each value in new config, check if it
                     # differs from the old config value (Except for
                     # the "secret" attribute)
-                    if (name != "secret"
-                        and (value !=
-                             old_client_settings[client_name][name])):
+                    if (name != "secret" and
+                        value != old_client_settings[client_name]
+                        [name]):
                         client[name] = value
                 except KeyError:
                     pass
             
             # Clients who has passed its expire date can still be
-            # enabled if its last checker was successful.  A Client
+            # enabled if its last checker was successful.  Clients
             # whose checker succeeded before we stored its state is
             # assumed to have successfully run all checkers during
             # downtime.
@@ -2649,35 +2451,35 @@
                 if datetime.datetime.utcnow() >= client["expires"]:
                     if not client["last_checked_ok"]:
                         logger.warning(
-                            "disabling client {} - Client never "
-                            "performed a successful checker".format(
-                                client_name))
+                            "disabling client {0} - Client never "
+                            "performed a successful checker"
+                            .format(client_name))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
-                            "disabling client {} - Client last"
-                            " checker failed with error code"
-                            " {}".format(
-                                client_name,
-                                client["last_checker_status"]))
+                            "disabling client {0} - Client "
+                            "last checker failed with error code {1}"
+                            .format(client_name,
+                                    client["last_checker_status"]))
                         client["enabled"] = False
                     else:
-                        client["expires"] = (
-                            datetime.datetime.utcnow()
-                            + client["timeout"])
+                        client["expires"] = (datetime.datetime
+                                             .utcnow()
+                                             + client["timeout"])
                         logger.debug("Last checker succeeded,"
-                                     " keeping {} enabled".format(
-                                         client_name))
+                                     " keeping {0} enabled"
+                                     .format(client_name))
             try:
-                client["secret"] = pgp.decrypt(
-                    client["encrypted_secret"],
-                    client_settings[client_name]["secret"])
+                client["secret"] = (
+                    pgp.decrypt(client["encrypted_secret"],
+                                client_settings[client_name]
+                                ["secret"]))
             except PGPError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {} old secret".format(
-                    client_name))
-                client["secret"] = (client_settings[client_name]
-                                    ["secret"])
+                logger.debug("Failed to decrypt {0} old secret"
+                             .format(client_name))
+                client["secret"] = (
+                    client_settings[client_name]["secret"])
     
     # Add/remove clients based on new changes made to config
     for client_name in (set(old_client_settings)
@@ -2688,47 +2490,44 @@
         clients_data[client_name] = client_settings[client_name]
     
     # Create all client objects
-    for client_name, client in clients_data.items():
+    for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
-            name = client_name,
-            settings = client,
-            server_settings = server_settings)
+            name = client_name, settings = client)
     
     if not tcp_server.clients:
         logger.warning("No clients defined")
     
-    if not foreground:
-        if pidfile is not None:
-            try:
-                with pidfile:
-                    pid = os.getpid()
-                    pidfile.write("{}\n".format(pid).encode("utf-8"))
-            except IOError:
-                logger.error("Could not write to file %r with PID %d",
-                             pidfilename, pid)
-        del pidfile
+    if not debug:
+        try:
+            with pidfile:
+                pid = os.getpid()
+                pidfile.write(str(pid) + "\n".encode("utf-8"))
+            del pidfile
+        except IOError:
+            logger.error("Could not write to file %r with PID %d",
+                         pidfilename, pid)
+        except NameError:
+            # "pidfile" was never created
+            pass
         del pidfilename
     
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
     if use_dbus:
-        
-        @alternate_dbus_interfaces(
-            { "se.recompile.Mandos": "se.bsnet.fukt.Mandos" })
+        @alternate_dbus_interfaces({"se.recompile.Mandos":
+                                        "se.bsnet.fukt.Mandos"})
         class MandosDBusService(DBusObjectWithProperties):
             """A D-Bus proxy object"""
-            
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
-            
             _interface = "se.recompile.Mandos"
             
             @dbus_interface_annotations(_interface)
             def _foo(self):
-                return {
-                    "org.freedesktop.DBus.Property.EmitsChangedSignal":
-                    "false" }
+                return { "org.freedesktop.DBus.Property"
+                         ".EmitsChangedSignal":
+                             "false"}
             
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
@@ -2748,7 +2547,8 @@
             @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
                 "D-Bus method"
-                return dbus.Array(c.dbus_object_path for c in
+                return dbus.Array(c.dbus_object_path
+                                  for c in
                                   tcp_server.clients.itervalues())
             
             @dbus.service.method(_interface,
@@ -2756,8 +2556,8 @@
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    { c.dbus_object_path: c.GetAll("")
-                      for c in tcp_server.clients.itervalues() },
+                    ((c.dbus_object_path, c.GetAll(""))
+                     for c in tcp_server.clients.itervalues()),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
@@ -2780,11 +2580,9 @@
     
     def cleanup():
         "Cleanup function; run on exit"
-        if zeroconf:
-            service.cleanup()
+        service.cleanup()
         
         multiprocessing.active_children()
-        wnull.close()
         if not (tcp_server.clients or client_settings):
             return
         
@@ -2801,10 +2599,10 @@
                 
                 # A list of attributes that can not be pickled
                 # + secret.
-                exclude = { "bus", "changedstate", "secret",
-                            "checker", "server_settings" }
-                for name, typ in inspect.getmembers(dbus.service
-                                                    .Object):
+                exclude = set(("bus", "changedstate", "secret",
+                               "checker"))
+                for name, typ in (inspect.getmembers
+                                  (dbus.service.Object)):
                     exclude.add(name)
                 
                 client_dict["encrypted_secret"] = (client
@@ -2817,14 +2615,12 @@
                 del client_settings[client.name]["secret"]
         
         try:
-            with tempfile.NamedTemporaryFile(
-                    mode='wb',
-                    suffix=".pickle",
-                    prefix='clients-',
-                    dir=os.path.dirname(stored_state_path),
-                    delete=False) as stored_state:
+            with (tempfile.NamedTemporaryFile
+                  (mode='wb', suffix=".pickle", prefix='clients-',
+                   dir=os.path.dirname(stored_state_path),
+                   delete=False)) as stored_state:
                 pickle.dump((clients, client_settings), stored_state)
-                tempname = stored_state.name
+                tempname=stored_state.name
             os.rename(tempname, stored_state_path)
         except (IOError, OSError) as e:
             if not debug:
@@ -2833,12 +2629,12 @@
                 except NameError:
                     pass
             if e.errno in (errno.ENOENT, errno.EACCES, errno.EEXIST):
-                logger.warning("Could not save persistent state: {}"
+                logger.warning("Could not save persistent state: {0}"
                                .format(os.strerror(e.errno)))
             else:
                 logger.warning("Could not save persistent state:",
                                exc_info=e)
-                raise
+                raise e
         
         # Delete all clients, and settings from config
         while tcp_server.clients:
@@ -2849,8 +2645,9 @@
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(
-                    client.dbus_object_path, client.name)
+                mandos_dbus_service.ClientRemoved(client
+                                                  .dbus_object_path,
+                                                  client.name)
         client_settings.clear()
     
     atexit.register(cleanup)
@@ -2867,8 +2664,7 @@
     tcp_server.server_activate()
     
     # Find out what port we got
-    if zeroconf:
-        service.port = tcp_server.socket.getsockname()[1]
+    service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
         logger.info("Now listening on address %r, port %d,"
                     " flowinfo %d, scope_id %d",
@@ -2880,15 +2676,14 @@
     #service.interface = tcp_server.socket.getsockname()[3]
     
     try:
-        if zeroconf:
-            # From the Avahi example code
-            try:
-                service.activate()
-            except dbus.exceptions.DBusException as error:
-                logger.critical("D-Bus Exception", exc_info=error)
-                cleanup()
-                sys.exit(1)
-            # End of Avahi example code
+        # From the Avahi example code
+        try:
+            service.activate()
+        except dbus.exceptions.DBusException as error:
+            logger.critical("D-Bus Exception", exc_info=error)
+            cleanup()
+            sys.exit(1)
+        # End of Avahi example code
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:
@@ -2909,6 +2704,5 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
-
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2014-06-22 02:19:30 +0000
+++ mandos-clients.conf.xml	2012-05-26 22:48:45 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-05-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -117,7 +117,7 @@
 	  <para>
 	    How long to wait for external approval before resorting to
 	    use the <option>approved_by_default</option> value.  The
-	    default is <quote>PT0S</quote>, i.e. not to wait.
+	    default is <quote>0s</quote>, i.e. not to wait.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same
@@ -177,13 +177,7 @@
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
 	    ><command>fping</command> <option>-q</option> <option
-	    >--</option> %%(host)s</literal></quote>.  Note that
-	    <command>mandos-keygen</command>, when generating output
-	    to be inserted into this file, normally looks for an SSH
-	    server on the Mandos client, and, if it find one, outputs
-	    a <option>checker</option> option to check for the
-	    client’s key fingerprint – this is more secure against
-	    spoofing.
+	    >--</option> %%(host)s</literal></quote>.
 	  </para>
 	  <para>
 	    In addition to normal start time expansion, this option
@@ -341,12 +335,17 @@
 	    <option>extended_timeout</option> option.
 	  </para>
 	  <para>
-	    The <replaceable>TIME</replaceable> is specified as an RFC
-	    3339 duration; for example
-	    <quote><literal>P1Y2M3DT4H5M6S</literal></quote> meaning
-	    one year, two months, three days, four hours, five
-	    minutes, and six seconds.  Some values can be omitted, see
-	    RFC 3339 Appendix A for details.
+	    The <replaceable>TIME</replaceable> is specified as a
+	    space-separated number of values, each of which is a
+	    number and a one-character suffix.  The suffix must be one
+	    of <quote>d</quote>, <quote>s</quote>, <quote>m</quote>,
+	    <quote>h</quote>, and <quote>w</quote> for days, seconds,
+	    minutes, hours, and weeks, respectively.  The values are
+	    added together to give the total time value, so all of
+	    <quote><literal>330s</literal></quote>,
+	    <quote><literal>110s 110s 110s</literal></quote>, and
+	    <quote><literal>5m 30s</literal></quote> will give a value
+	    of five minutes and thirty seconds.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -466,8 +465,8 @@
     <informalexample>
       <programlisting>
 [DEFAULT]
-timeout = PT5M
-interval = PT2M
+timeout = 5m
+interval = 2m
 checker = fping -q -- %%(host)s
 
 # Client "foo"
@@ -490,15 +489,15 @@
         4T2zw4dxS5NswXWU0sVEXxjs6PYxuIiCTL7vdpx8QjBkrPWDrAbcMyBr2O
         QlnHIvPzEArRQLo=
 host = foo.example.org
-interval = PT1M
+interval = 1m
 
 # Client "bar"
 [bar]
 fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
 secfile = /etc/mandos/bar-secret
-timeout = PT15M
+timeout = 15m
 approved_by_default = False
-approval_delay = PT30S
+approval_delay = 30s
       </programlisting>
     </informalexample>
   </refsect1>
@@ -517,20 +516,6 @@
       <citerefentry><refentrytitle>fping</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>
     </para>
-    <variablelist>
-      <varlistentry>
-	<term>
-	  RFC 3339: <citetitle>Date and Time on the Internet:
-	  Timestamps</citetitle>
-	</term>
-      <listitem>
-	<para>
-	  The time intervals are in the "duration" format, as
-	  specified in ABNF in Appendix A of RFC 3339.
-	</para>
-      </listitem>
-      </varlistentry>
-    </variablelist>
   </refsect1>
 </refentry>
 <!-- Local Variables: -->

=== modified file 'mandos-ctl'
--- mandos-ctl	2015-04-02 21:56:15 +0000
+++ mandos-ctl	2012-06-01 18:39:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2015 Teddy Hogeborn
-# Copyright © 2008-2015 Björn Påhlsson
+# Copyright © 2008-2012 Teddy Hogeborn
+# Copyright © 2008-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,24 +26,15 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+from future_builtins import *
 
 import sys
+import dbus
 import argparse
 import locale
 import datetime
 import re
 import os
-import collections
-import doctest
-
-import dbus
-
-if sys.version_info.major == 2:
-    str = unicode
 
 locale.setlocale(locale.LC_ALL, "")
 
@@ -64,124 +55,30 @@
     "ApprovalDelay": "Approval Delay",
     "ApprovalDuration": "Approval Duration",
     "Checker": "Checker",
-    "ExtendedTimeout": "Extended Timeout"
-}
+    "ExtendedTimeout" : "Extended Timeout"
+    }
 defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
 domain = "se.recompile"
 busname = domain + ".Mandos"
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.9"
+version = "1.5.5"
 
+def timedelta_to_milliseconds(td):
+    """Convert a datetime.timedelta object to milliseconds"""
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return ("{days}{hours:02}:{minutes:02}:{seconds:02}".format(
-        days = "{}T".format(td.days) if td.days else "",
-        hours = td.seconds // 3600,
-        minutes = (td.seconds % 3600) // 60,
-        seconds = td.seconds % 60))
-
-
-def rfc3339_duration_to_delta(duration):
-    """Parse an RFC 3339 "duration" and return a datetime.timedelta
-    
-    >>> rfc3339_duration_to_delta("P7D")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT60S")
-    datetime.timedelta(0, 60)
-    >>> rfc3339_duration_to_delta("PT60M")
-    datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("PT24H")
-    datetime.timedelta(1)
-    >>> rfc3339_duration_to_delta("P1W")
-    datetime.timedelta(7)
-    >>> rfc3339_duration_to_delta("PT5M30S")
-    datetime.timedelta(0, 330)
-    >>> rfc3339_duration_to_delta("P1DT3M20S")
-    datetime.timedelta(1, 200)
-    """
-    
-    # Parsing an RFC 3339 duration with regular expressions is not
-    # possible - there would have to be multiple places for the same
-    # values, like seconds.  The current code, while more esoteric, is
-    # cleaner without depending on a parsing library.  If Python had a
-    # built-in library for parsing we would use it, but we'd like to
-    # avoid excessive use of external libraries.
-    
-    # New type for defining tokens, syntax, and semantics all-in-one
-    Token = collections.namedtuple("Token",
-                                   ("regexp", # To match token; if
-                                              # "value" is not None,
-                                              # must have a "group"
-                                              # containing digits
-                                    "value",  # datetime.timedelta or
-                                              # None
-                                    "followers")) # Tokens valid after
-                                                  # this token
-    # RFC 3339 "duration" tokens, syntax, and semantics; taken from
-    # the "duration" ABNF definition in RFC 3339, Appendix A.
-    token_end = Token(re.compile(r"$"), None, frozenset())
-    token_second = Token(re.compile(r"(\d+)S"),
-                         datetime.timedelta(seconds=1),
-                         frozenset((token_end, )))
-    token_minute = Token(re.compile(r"(\d+)M"),
-                         datetime.timedelta(minutes=1),
-                         frozenset((token_second, token_end)))
-    token_hour = Token(re.compile(r"(\d+)H"),
-                       datetime.timedelta(hours=1),
-                       frozenset((token_minute, token_end)))
-    token_time = Token(re.compile(r"T"),
-                       None,
-                       frozenset((token_hour, token_minute,
-                                  token_second)))
-    token_day = Token(re.compile(r"(\d+)D"),
-                      datetime.timedelta(days=1),
-                      frozenset((token_time, token_end)))
-    token_month = Token(re.compile(r"(\d+)M"),
-                        datetime.timedelta(weeks=4),
-                        frozenset((token_day, token_end)))
-    token_year = Token(re.compile(r"(\d+)Y"),
-                       datetime.timedelta(weeks=52),
-                       frozenset((token_month, token_end)))
-    token_week = Token(re.compile(r"(\d+)W"),
-                       datetime.timedelta(weeks=1),
-                       frozenset((token_end, )))
-    token_duration = Token(re.compile(r"P"), None,
-                           frozenset((token_year, token_month,
-                                      token_day, token_time,
-                                      token_week)))
-    # Define starting values
-    value = datetime.timedelta() # Value so far
-    found_token = None
-    followers = frozenset((token_duration, )) # Following valid tokens
-    s = duration                # String left to parse
-    # Loop until end token is found
-    while found_token is not token_end:
-        # Search for any currently valid tokens
-        for token in followers:
-            match = token.regexp.match(s)
-            if match is not None:
-                # Token found
-                if token.value is not None:
-                    # Value found, parse digits
-                    factor = int(match.group(1), 10)
-                    # Add to value so far
-                    value += factor * token.value
-                # Strip token from string
-                s = token.regexp.sub("", s, 1)
-                # Go to found token
-                found_token = token
-                # Set valid next tokens
-                followers = found_token.followers
-                break
-        else:
-            # No currently valid tokens were found
-            raise ValueError("Invalid RFC 3339 duration")
-    # End token found
-    return value
-
+    return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
+            .format(days = "{0}T".format(td.days) if td.days else "",
+                    hours = td.seconds // 3600,
+                    minutes = (td.seconds % 3600) // 60,
+                    seconds = td.seconds % 60,
+                    ))
 
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
@@ -199,14 +96,8 @@
     >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
-    
-    try:
-        return rfc3339_duration_to_delta(interval)
-    except ValueError:
-        pass
-    
     value = datetime.timedelta(0)
-    regexp = re.compile(r"(\d+)([dsmhw]?)")
+    regexp = re.compile("(\d+)([dsmhw]?)")
     
     for num, suffix in regexp.findall(interval):
         if suffix == "d":
@@ -223,7 +114,6 @@
             value += datetime.timedelta(0, 0, 0, int(num))
     return value
 
-
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
@@ -231,22 +121,23 @@
         if keyword in ("Timeout", "Interval", "ApprovalDelay",
                        "ApprovalDuration", "ExtendedTimeout"):
             return milliseconds_to_string(value)
-        return str(value)
+        return unicode(value)
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
-        width = max(len(tablewords[key]),
-                    max(len(valuetostring(client[key], key))
-                        for client in clients)),
-        key = key)
-                             for key in keywords)
+            width = max(len(tablewords[key]),
+                        max(len(valuetostring(client[key],
+                                              key))
+                            for client in
+                            clients)),
+            key = key) for key in keywords)
     # Print header line
     print(format_string.format(**tablewords))
     for client in clients:
-        print(format_string.format(**{
-            key: valuetostring(client[key], key)
-            for key in keywords }))
-
+        print(format_string.format(**dict((key,
+                                           valuetostring(client[key],
+                                                         key))
+                                          for key in keywords)))
 
 def has_actions(options):
     return any((options.enable,
@@ -268,11 +159,10 @@
                 options.approve,
                 options.deny))
 
-
 def main():
     parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-a", "--all", action="store_true",
                         help="Select all clients")
@@ -311,15 +201,12 @@
     parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
-    parser.add_argument("-s", "--secret",
-                        type=argparse.FileType(mode="rb"),
+    parser.add_argument("-s", "--secret", type=file,
                         help="Set password blob (file) for client")
     parser.add_argument("-A", "--approve", action="store_true",
                         help="Approve any current client request")
     parser.add_argument("-D", "--deny", action="store_true",
                         help="Deny any current client request")
-    parser.add_argument("--check", action="store_true",
-                        help="Run self-test")
     parser.add_argument("client", nargs="*", help="Client name")
     options = parser.parse_args()
     
@@ -330,16 +217,13 @@
                      " --all.")
     if options.all and not has_actions(options):
         parser.error("--all requires an action.")
-
-    if options.check:
-        fail_count, test_count = doctest.testmod()
-        sys.exit(os.EX_OK if fail_count == 0 else 1)
     
     try:
         bus = dbus.SystemBus()
         mandos_dbus_objc = bus.get_object(busname, server_path)
     except dbus.exceptions.DBusException:
-        print("Could not connect to Mandos server", file=sys.stderr)
+        print("Could not connect to Mandos server",
+              file=sys.stderr)
         sys.exit(1)
     
     mandos_serv = dbus.Interface(mandos_dbus_objc,
@@ -366,26 +250,28 @@
     clients={}
     
     if options.all or not options.client:
-        clients = { bus.get_object(busname, path): properties
-                    for path, properties in mandos_clients.items() }
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.iteritems())
     else:
         for name in options.client:
-            for path, client in mandos_clients.items():
+            for path, client in mandos_clients.iteritems():
                 if client["Name"] == name:
                     client_objc = bus.get_object(busname, path)
                     clients[client_objc] = client
                     break
             else:
-                print("Client not found on server: {!r}"
+                print("Client not found on server: {0!r}"
                       .format(name), file=sys.stderr)
                 sys.exit(1)
     
     if not has_actions(options) and clients:
         if options.verbose:
-            keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
-                        "Created", "Interval", "Host", "Fingerprint",
-                        "CheckerRunning", "LastEnabled",
-                        "ApprovalPending", "ApprovedByDefault",
+            keywords = ("Name", "Enabled", "Timeout",
+                        "LastCheckedOK", "Created", "Interval",
+                        "Host", "Fingerprint", "CheckerRunning",
+                        "LastEnabled", "ApprovalPending",
+                        "ApprovedByDefault",
                         "LastApprovalRequest", "ApprovalDelay",
                         "ApprovalDuration", "Checker",
                         "ExtendedTimeout")
@@ -396,19 +282,16 @@
     else:
         # Process each client in the list by all selected options
         for client in clients:
-            
             def set_client_prop(prop, value):
                 """Set a Client D-Bus property"""
                 client.Set(client_interface, prop, value,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            
             def set_client_prop_ms(prop, value):
                 """Set a Client D-Bus property, converted
                 from a string to milliseconds."""
                 set_client_prop(prop,
-                                string_to_delta(value).total_seconds()
-                                * 1000)
-            
+                                timedelta_to_milliseconds
+                                (string_to_delta(value)))
             if options.remove:
                 mandos_serv.RemoveClient(client.__dbus_object_path__)
             if options.enable:
@@ -458,6 +341,5 @@
                 client.Approve(dbus.Boolean(False),
                                dbus_interface=client_interface)
 
-
 if __name__ == "__main__":
     main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2012-06-22 23:33:56 +0000
+++ mandos-ctl.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2012-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -195,10 +195,6 @@
 	<arg choice="plain"><option>-v</option></arg>
       </group>
     </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
-      <arg choice="plain"><option>--check</option></arg>
-    </cmdsynopsis>
   </refsynopsisdiv>
   
   <refsect1 id="description">
@@ -480,15 +476,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>--check</option></term>
-	<listitem>
-	  <para>
-	    Run self-tests.  This includes any unit tests, etc.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos-keygen'
--- mandos-keygen	2015-05-23 10:41:35 +0000
+++ mandos-keygen	2012-06-01 18:39:03 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2015 Teddy Hogeborn
-# Copyright © 2008-2015 Björn Påhlsson
+# Copyright © 2008-2012 Teddy Hogeborn
+# Copyright © 2008-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,19 +21,18 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.9"
+VERSION="1.5.5"
 
 KEYDIR="/etc/keys/mandos"
-KEYTYPE=RSA
-KEYLENGTH=4096
-SUBKEYTYPE=RSA
-SUBKEYLENGTH=4096
+KEYTYPE=DSA
+KEYLENGTH=2048
+SUBKEYTYPE=ELG-E
+SUBKEYLENGTH=2048
 KEYNAME="`hostname --fqdn 2>/dev/null || hostname`"
 KEYEMAIL=""
-KEYCOMMENT=""
+KEYCOMMENT="Mandos client key"
 KEYEXPIRE=0
 FORCE=no
-SSH=yes
 KEYCOMMENT_ORIG="$KEYCOMMENT"
 mode=keygen
 
@@ -42,12 +41,12 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:fS \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force,no-ssh \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
     --name "$0" -- "$@"`
 
 help(){
-basename="`basename "$0"`"
+basename="`basename $0`"
 cat <<EOF
 Usage: $basename [ -v | --version ]
        $basename [ -h | --help ]
@@ -61,18 +60,19 @@
   -v, --version         Show program's version number and exit
   -h, --help            Show this help message and exit
   -d DIR, --dir DIR     Target directory for key files
-  -t TYPE, --type TYPE  Key type.  Default is RSA.
+  -t TYPE, --type TYPE  Key type.  Default is DSA.
   -l BITS, --length BITS
-                        Key length in bits.  Default is 4096.
+                        Key length in bits.  Default is 2048.
   -s TYPE, --subtype TYPE
-                        Subkey type.  Default is RSA.
+                        Subkey type.  Default is ELG-E.
   -L BITS, --sublength BITS
-                        Subkey length in bits.  Default is 4096.
+                        Subkey length in bits.  Default is 2048.
   -n NAME, --name NAME  Name of key.  Default is the FQDN.
   -e ADDRESS, --email ADDRESS
                         Email address of key.  Default is empty.
   -c TEXT, --comment TEXT
-                        Comment field for key.  The default is empty.
+                        Comment field for key.  The default value is
+                        "Mandos client key".
   -x TIME, --expire TIME
                         Key expire time.  Default is no expiration.
                         See gpg(1) for syntax.
@@ -86,7 +86,6 @@
                         Encrypt a password from FILE using the key in
                         the key directory.  All options other than
                         --dir and --name are ignored.
-  -S, --no-ssh          Don't get SSH key or set "checker" option.
 EOF
 }
 
@@ -105,7 +104,6 @@
 	-c|--comment) KEYCOMMENT="$2"; shift 2;;
 	-x|--expire) KEYEXPIRE="$2"; shift 2;;
 	-f|--force) FORCE=yes; shift;;
-	-S|--no-ssh) SSH=no; shift;;
 	-v|--version) echo "$0 $VERSION"; exit;;
 	-h|--help) help; exit;;
 	--) shift; break;;
@@ -113,7 +111,7 @@
     esac
 done
 if [ "$#" -gt 0 ]; then
-    echo "Unknown arguments: '$*'" >&2
+    echo "Unknown arguments: '$@'" >&2
     exit 1
 fi
 
@@ -191,7 +189,7 @@
 trap "
 set +e; \
 test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-shred --remove \"$RINGDIR\"/sec* 2>/dev/null;
+shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
 tty --quiet && stty echo; \
@@ -206,10 +204,10 @@
     cat >"$BATCHFILE" <<-EOF
 	Key-Type: $KEYTYPE
 	Key-Length: $KEYLENGTH
-	Key-Usage: sign,auth
+	#Key-Usage: encrypt,sign,auth
 	Subkey-Type: $SUBKEYTYPE
 	Subkey-Length: $SUBKEYLENGTH
-	Subkey-Usage: encrypt
+	#Subkey-Usage: encrypt,sign,auth
 	Name-Real: $KEYNAME
 	$KEYCOMMENTLINE
 	$KEYEMAILLINE
@@ -231,11 +229,6 @@
 	date
     fi
     
-    # Make sure trustdb.gpg exists;
-    # this is a workaround for Debian bug #737128
-    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" \
-	--import-ownertrust < /dev/null
     # Generate a new key in the key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always \
@@ -277,29 +270,6 @@
 fi
 
 if [ "$mode" = password ]; then
-    
-    # Make SSH be 0 or 1
-    case "$SSH" in
-	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]) SSH=1;;
-	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) SSH=0;;
-    esac
-    
-    if [ $SSH -eq 1 ]; then
-	for ssh_keytype in ed25519 rsa; do
-	    set +e
-	    ssh_fingerprint="`ssh-keyscan -t $ssh_keytype localhost 2>/dev/null`"
-	    set -e
-	    if [ $? -ne 0 ]; then
-		ssh_fingerprint=""
-		continue
-	    fi
-	    if [ -n "$ssh_fingerprint" ]; then
-		ssh_fingerprint="${ssh_fingerprint#localhost }"
-		break
-	    fi
-	done
-    fi
-    
     # Import key into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
@@ -310,7 +280,7 @@
     
     # Get fingerprint of key
     FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir "$RINGDIR" --trust-model always \
+	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
 	--fingerprint --with-colons \
 	| sed --quiet \
 	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"
@@ -324,11 +294,9 @@
 	    cat "$PASSFILE"
 	else
 	    tty --quiet && stty -echo
-	    echo -n "Enter passphrase: " >&2
-	    read first
+	    read -p "Enter passphrase: " first
 	    tty --quiet && echo >&2
-	    echo -n "Repeat passphrase: " >&2
-	    read second
+	    read -p "Repeat passphrase: " second
 	    if tty --quiet; then
 		echo >&2
 		stty echo
@@ -368,10 +336,6 @@
 		/^[^-]/s/^/    /p
 	    }
 	}' < "$SECFILE"
-    if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan -t '"$ssh_keytype"' %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
-	echo "ssh_fingerprint = ${ssh_fingerprint}"
-    fi
 fi
 
 trap - EXIT
@@ -382,5 +346,5 @@
     shred --remove "$SECFILE"
 fi
 # Remove the key rings
-shred --remove "$RINGDIR"/sec* 2>/dev/null
+shred --remove "$RINGDIR"/sec*
 rm --recursive --force "$RINGDIR"

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2014-06-22 02:19:30 +0000
+++ mandos-keygen.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -119,10 +119,7 @@
 	<replaceable>TIME</replaceable></option></arg>
       </group>
       <sbr/>
-      <group>
-	<arg choice="plain"><option>--force</option></arg>
-	<arg choice="plain"><option>-f</option></arg>
-      </group>
+      <arg><option>--force</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -148,10 +145,6 @@
 	<arg choice="plain"><option>-n
 	<replaceable>NAME</replaceable></option></arg>
       </group>
-      <group>
-	<arg choice="plain"><option>--no-ssh</option></arg>
-	<arg choice="plain"><option>-S</option></arg>
-      </group>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -234,7 +227,7 @@
 	<replaceable>TYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Key type.  Default is <quote>RSA</quote>.
+	    Key type.  Default is <quote>DSA</quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -246,7 +239,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Key length in bits.  Default is 4096.
+	    Key length in bits.  Default is 2048.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -258,7 +251,7 @@
 	<replaceable>KEYTYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Subkey type.  Default is <quote>RSA</quote> (Elgamal
+	    Subkey type.  Default is <quote>ELG-E</quote> (Elgamal
 	    encryption-only).
 	  </para>
 	</listitem>
@@ -271,7 +264,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Subkey length in bits.  Default is 4096.
+	    Subkey length in bits.  Default is 2048.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -295,7 +288,8 @@
 	<replaceable>TEXT</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Comment field for key.  Default is empty.
+	    Comment field for key.  The default value is
+	    <quote><literal>Mandos client key</literal></quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -353,22 +347,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      <varlistentry>
-	<term><option>--no-ssh</option></term>
-	<term><option>-S</option></term>
-	<listitem>
-	  <para>
-	    When <option>--password</option> or
-	    <option>--passfile</option> is given, this option will
-	    prevent <command>&COMMANDNAME;</command> from calling
-	    <command>ssh-keyscan</command> to get an SSH fingerprint
-	    for this host and, if successful, output suitable config
-	    options to use this fingerprint as a
-	    <option>checker</option> option in the output.  This is
-	    otherwise the default behavior.
-	  </para>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -525,9 +503,7 @@
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>ssh-keyscan</refentrytitle>
-      <manvolnum>1</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
   </refsect1>
   

=== modified file 'mandos-monitor'
--- mandos-monitor	2015-05-23 20:18:34 +0000
+++ mandos-monitor	2012-06-01 18:39:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009-2015 Teddy Hogeborn
-# Copyright © 2009-2015 Björn Påhlsson
+# Copyright © 2009-2012 Teddy Hogeborn
+# Copyright © 2009-2012 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,13 +25,12 @@
 
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+
+from future_builtins import *
 
 import sys
 import os
+import signal
 
 import datetime
 
@@ -39,18 +38,14 @@
 import urwid
 
 from dbus.mainloop.glib import DBusGMainLoop
-try:
-    import gobject
-except ImportError:
-    from gi.repository import GObject as gobject
+import gobject
 
 import dbus
 
+import UserList
+
 import locale
 
-if sys.version_info.major == 2:
-    str = unicode
-
 locale.setlocale(locale.LC_ALL, '')
 
 import logging
@@ -60,7 +55,15 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.9"
+version = "1.5.5"
+
+# Always run in monochrome mode
+urwid.curses_display.curses.has_colors = lambda : False
+
+# Urwid doesn't support blinking, but we want it.  Since we have no
+# use for underline on its own, we make underline also always blink.
+urwid.curses_display.curses.A_UNDERLINE |= (
+    urwid.curses_display.curses.A_BLINK)
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -87,9 +90,9 @@
         self.proxy = proxy_object # Mandos Client proxy object
         self.properties = dict() if properties is None else properties
         self.property_changed_match = (
-            self.proxy.connect_to_signal("PropertiesChanged",
-                                         self.properties_changed,
-                                         dbus.PROPERTIES_IFACE,
+            self.proxy.connect_to_signal("PropertyChanged",
+                                         self._property_changed,
+                                         client_interface,
                                          byte_arrays=True))
         
         if properties is None:
@@ -100,12 +103,16 @@
         
         super(MandosClientPropertyCache, self).__init__(**kwargs)
     
-    def properties_changed(self, interface, properties, invalidated):
-        """This is called whenever we get a PropertiesChanged signal
-        It updates the changed properties in the "properties" dict.
+    def _property_changed(self, property, value):
+        """Helper which takes positional arguments"""
+        return self.property_changed(property=property, value=value)
+    
+    def property_changed(self, property=None, value=None):
+        """This is called whenever we get a PropertyChanged signal
+        It updates the changed property in the "properties" dict.
         """
         # Update properties dict with new value
-        self.properties.update(properties)
+        self.properties[property] = value
     
     def delete(self):
         self.property_changed_match.remove()
@@ -157,8 +164,8 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        self.logger('Created client {}'
-                    .format(self.properties["Name"]), level=0)
+        #self.logger('Created client {0}'
+        #            .format(self.properties["Name"]))
     
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
@@ -173,50 +180,53 @@
             gobject.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
     
-    def checker_completed(self, exitstatus, signal, command):
+    def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            self.logger('Checker for client {} (command "{}")'
-                        ' succeeded'.format(self.properties["Name"],
-                                            command), level=0)
             self.update()
             return
         # Checker failed
-        if exitstatus >= 0:
-            self.logger('Checker for client {} (command "{}") failed'
-                        ' with exit code {}'
-                        .format(self.properties["Name"], command,
-                                exitstatus))
-        elif signal != 0:
-            self.logger('Checker for client {} (command "{}") was'
-                        ' killed by signal {}'
-                        .format(self.properties["Name"], command,
-                                signal))
+        if os.WIFEXITED(condition):
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' failed with exit code {2}'
+                        .format(self.properties["Name"], command,
+                                os.WEXITSTATUS(condition)))
+        elif os.WIFSIGNALED(condition):
+            self.logger('Checker for client {0} (command "{1}") was'
+                        ' killed by signal {2}'
+                        .format(self.properties["Name"], command,
+                                os.WTERMSIG(condition)))
+        elif os.WCOREDUMP(condition):
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' dumped core'
+                        .format(self.properties["Name"], command))
         else:
-            self.logger('Checker for client {} completed'
+            self.logger('Checker for client {0} completed'
                         ' mysteriously'
                         .format(self.properties["Name"]))
         self.update()
     
     def checker_started(self, command):
-        """Server signals that a checker started."""
-        self.logger('Client {} started checker "{}"'
-                    .format(self.properties["Name"],
-                            command), level=0)
+        """Server signals that a checker started. This could be useful
+           to log in the future. """
+        #self.logger('Client {0} started checker "{1}"'
+        #            .format(self.properties["Name"],
+        #                    unicode(command)))
+        pass
     
     def got_secret(self):
-        self.logger('Client {} received its secret'
+        self.logger('Client {0} received its secret'
                     .format(self.properties["Name"]))
     
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client {} needs approval within {} seconds'
+            message = 'Client {0} needs approval within {1} seconds'
         else:
-            message = 'Client {} will get its secret in {} seconds'
+            message = 'Client {0} will get its secret in {1} seconds'
         self.logger(message.format(self.properties["Name"],
                                    timeout/1000))
     
     def rejected(self, reason):
-        self.logger('Client {} was rejected; reason: {}'
+        self.logger('Client {0} was rejected; reason: {1}'
                     .format(self.properties["Name"], reason))
     
     def selectable(self):
@@ -266,10 +276,10 @@
             else:
                 timer = datetime.timedelta()
             if self.properties["ApprovedByDefault"]:
-                message = "Approval in {}. (d)eny?"
+                message = "Approval in {0}. (d)eny?"
             else:
-                message = "Denial in {}. (a)pprove?"
-            message = message.format(str(timer).rsplit(".", 1)[0])
+                message = "Denial in {0}. (a)pprove?"
+            message = message.format(unicode(timer).rsplit(".", 1)[0])
             self.using_timer(True)
         elif self.properties["LastCheckerStatus"] != 0:
             # When checker has failed, show timer until client expires
@@ -282,13 +292,13 @@
                 timer = max(expires - datetime.datetime.utcnow(),
                             datetime.timedelta())
             message = ('A checker has failed! Time until client'
-                       ' gets disabled: {}'
-                       .format(str(timer).rsplit(".", 1)[0]))
+                       ' gets disabled: {0}'
+                       .format(unicode(timer).rsplit(".", 1)[0]))
             self.using_timer(True)
         else:
             message = "enabled"
             self.using_timer(False)
-        self._text = "{}{}".format(base, message)
+        self._text = "{0}{1}".format(base, message)
         
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
@@ -369,15 +379,14 @@
         else:
             return key
     
-    def properties_changed(self, interface, properties, invalidated):
-        """Call self.update() if any properties changed.
+    def property_changed(self, property=None, **kwargs):
+        """Call self.update() if old value is not new value.
         This overrides the method from MandosClientPropertyCache"""
-        old_values = { key: self.properties.get(key)
-                       for key in properties.keys() }
-        super(MandosClientWidget, self).properties_changed(
-            interface, properties, invalidated)
-        if any(old_values[key] != self.properties.get(key)
-               for key in old_values):
+        property_name = unicode(property)
+        old_value = self.properties.get(property_name)
+        super(MandosClientWidget, self).property_changed(
+            property=property, **kwargs)
+        if self.properties.get(property_name) != old_value:
             self.update()
 
 
@@ -397,7 +406,7 @@
     """This is the entire user interface - the whole screen
     with boxes, lists of client widgets, etc.
     """
-    def __init__(self, max_log_length=1000, log_level=1):
+    def __init__(self, max_log_length=1000):
         DBusGMainLoop(set_as_default=True)
         
         self.screen = urwid.curses_display.Screen()
@@ -406,21 +415,20 @@
                 ("normal",
                  "default", "default", None),
                 ("bold",
-                 "bold", "default", "bold"),
+                 "default", "default", "bold"),
                 ("underline-blink",
-                 "underline,blink", "default", "underline,blink"),
+                 "default", "default", "underline"),
                 ("standout",
-                 "standout", "default", "standout"),
+                 "default", "default", "standout"),
                 ("bold-underline-blink",
-                 "bold,underline,blink", "default", "bold,underline,blink"),
+                 "default", "default", ("bold", "underline")),
                 ("bold-standout",
-                 "bold,standout", "default", "bold,standout"),
+                 "default", "default", ("bold", "standout")),
                 ("underline-blink-standout",
-                 "underline,blink,standout", "default",
-                 "underline,blink,standout"),
+                 "default", "default", ("underline", "standout")),
                 ("bold-underline-blink-standout",
-                 "bold,underline,blink,standout", "default",
-                 "bold,underline,blink,standout"),
+                 "default", "default", ("bold", "underline",
+                                          "standout")),
                 ))
         
         if urwid.supports_unicode():
@@ -441,8 +449,6 @@
         self.log = []
         self.max_log_length = max_log_length
         
-        self.log_level = log_level
-        
         # We keep a reference to the log widget so we can remove it
         # from the ListWalker without it getting destroyed
         self.logbox = ConstrainedListBox(self.log)
@@ -462,8 +468,8 @@
         self.main_loop = gobject.MainLoop()
     
     def client_not_found(self, fingerprint, address):
-        self.log_message("Client with address {} and fingerprint {}"
-                         " could not be found"
+        self.log_message("Client with address {0} and fingerprint"
+                         " {1} could not be found"
                          .format(address, fingerprint))
     
     def rebuild(self):
@@ -482,18 +488,12 @@
             self.uilist.append(self.logbox)
         self.topwidget = urwid.Pile(self.uilist)
     
-    def log_message(self, message, level=1):
-        """Log message formatted with timestamp"""
-        if level < self.log_level:
-            return
+    def log_message(self, message):
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw("{}: {}".format(timestamp, message),
-                             level=level)
+        self.log_message_raw(timestamp + ": " + message)
     
-    def log_message_raw(self, markup, level=1):
+    def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
-        if level < self.log_level:
-            return
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
         if (self.max_log_length
             and len(self.log) > self.max_log_length):
@@ -506,8 +506,8 @@
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        self.log_message("Log visibility changed to: {}"
-                         .format(self.log_visible), level=0)
+        #self.log_message("Log visibility changed to: "
+        #                 + unicode(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
@@ -518,8 +518,7 @@
             self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message("Wrap mode: {}".format(self.log_wrap),
-                         level=0)
+        #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find a client by its object path and remove it.
@@ -530,7 +529,7 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            self.log_message("Unknown client {!r} ({!r}) removed"
+            self.log_message("Unknown client {0!r} ({1!r}) removed"
                              .format(name, path))
             return
         client.delete()
@@ -554,7 +553,7 @@
         if path is None:
             path = client.proxy.object_path
         self.clients_dict[path] = client
-        self.clients.sort(key=lambda c: c.properties["Name"])
+        self.clients.sort(None, lambda c: c.properties["Name"])
         self.refresh()
     
     def remove_client(self, client, path=None):
@@ -562,6 +561,11 @@
         if path is None:
             path = client.proxy.object_path
         del self.clients_dict[path]
+        if not self.clients_dict:
+            # Work around bug in Urwid 0.9.8.3 - if a SimpleListWalker
+            # is completely emptied, we need to recreate it.
+            self.clients = urwid.SimpleListWalker([])
+            self.rebuild()
         self.refresh()
     
     def refresh(self):
@@ -580,10 +584,7 @@
         try:
             mandos_clients = (self.mandos_serv
                               .GetAllClientsWithProperties())
-            if not mandos_clients:
-                self.log_message_raw(("bold", "Note: Server has no clients."))
         except dbus.exceptions.DBusException:
-            self.log_message_raw(("bold", "Note: No Mandos server running."))
             mandos_clients = dbus.Dictionary()
         
         (self.mandos_serv
@@ -601,7 +602,7 @@
                             self.client_not_found,
                             dbus_interface=server_interface,
                             byte_arrays=True))
-        for path, client in mandos_clients.items():
+        for path, client in mandos_clients.iteritems():
             client_proxy_object = self.bus.get_object(self.busname,
                                                       path)
             self.add_client(MandosClientWidget(server_proxy_object
@@ -654,8 +655,7 @@
             elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "ctrl l":
-                self.screen.clear()
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
             elif key == "l" or key == "D":
                 self.toggle_log_display()
@@ -673,9 +673,7 @@
                                             "?: Help",
                                             "l: Log window toggle",
                                             "TAB: Switch window",
-                                            "w: Wrap (log lines)",
-                                            "v: Toggle verbose log",
-                                            ))))
+                                            "w: Wrap (log)"))))
                 self.log_message_raw(("bold",
                                       "  "
                                       .join(("Clients:",
@@ -694,13 +692,6 @@
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            elif key == "v":
-                if self.log_level == 0:
-                    self.log_level = 1
-                    self.log_message("Verbose mode: Off")
-                else:
-                    self.log_level = 0
-                    self.log_message("Verbose mode: On")
             #elif (key == "end" or key == "meta >" or key == "G"
             #      or key == ">"):
             #    pass            # xxx end-of-buffer
@@ -729,7 +720,7 @@
     ui.run()
 except KeyboardInterrupt:
     ui.screen.stop()
-except Exception as e:
-    ui.log_message(str(e))
+except Exception, e:
+    ui.log_message(unicode(e))
     ui.screen.stop()
     raise

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2014-07-14 21:41:08 +0000
+++ mandos-monitor.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2014-07-14">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -129,10 +129,6 @@
 	<entry>Toggle log window line wrap</entry>
       </row>
       <row>
-	<entry>v</entry>
-	<entry>Toggle verbose logging</entry>
-      </row>
-      <row>
 	<entry>Up, Ctrl-P, k</entry>
 	<entry>Move up a line</entry>
       </row>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2015-03-10 18:03:38 +0000
+++ mandos-options.xml	2012-05-26 22:21:17 +0000
@@ -46,31 +46,15 @@
     <emphasis>not</emphasis> run in debug mode.
   </para>
   
-  <para id="priority_compat">
-    GnuTLS priority string for the <acronym>TLS</acronym> handshake.
-    The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal>
-    <literal>:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160</literal></quote>.
-    See <citerefentry><refentrytitle
-    >gnutls_priority_init</refentrytitle>
-    <manvolnum>3</manvolnum></citerefentry> for the syntax.
-    <emphasis>Warning</emphasis>: changing this may make the
-    <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.  Changing this option may also make the
-    network traffic decryptable by an attacker.
-  </para>
-  
   <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal></quote>.
-    See <citerefentry><refentrytitle
-    >gnutls_priority_init</refentrytitle>
+    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP</literal></quote>.  See
+    <citerefentry><refentrytitle>gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the
     <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.  Changing this option may also make the
-    network traffic decryptable by an attacker.
+    communication impossible.
   </para>
   
   <para id="servicename">
@@ -119,18 +103,4 @@
     default, the server will create a new network socket.
   </para>
   
-  <para id="foreground">
-    This option will make the server run in the foreground and not
-    write a PID file.  The default is to <emphasis>not</emphasis> run
-    in the foreground, except in <option>debug</option> mode, which
-    implies this option.
-  </para>
-  
-  <para id="zeroconf">
-    This option controls whether the server will announce its
-    existence using Zeroconf.  Default is to use Zeroconf.  If
-    Zeroconf is not used, a <option>port</option> number or a
-    <option>socket</option> is required.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2015-04-02 18:59:29 +0000
+++ mandos.conf	2011-11-26 22:22:20 +0000
@@ -23,7 +23,7 @@
 ;debug = False
 
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
-;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA:+SIGN-RSA-SHA224:+SIGN-RSA-RMD160
+;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.
@@ -42,12 +42,3 @@
 
 # The directory where state is saved
 ;statedir = /var/lib/mandos
-
-# Whether to run in the foreground
-;foreground = False
-
-# File descriptor number to use for network socket
-;socket = 
-
-# Whether to use ZeroConf; if false, requires port or socket
-;zeroconf = True

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2015-04-02 18:59:29 +0000
+++ mandos.conf.xml	2012-05-26 22:21:17 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2015-04-02">
+<!ENTITY TIMESTAMP "2012-05-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -36,7 +36,6 @@
       <year>2009</year>
       <year>2011</year>
       <year>2012</year>
-      <year>2013</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -121,8 +120,7 @@
 	<term><option>priority<literal> = </literal><replaceable
 	>STRING</replaceable></option></term>
 	<listitem>
-	  <xi:include href="mandos-options.xml"
-                      xpointer="priority_compat"/>
+	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
       
@@ -223,8 +221,8 @@
 interface = eth0
 address = fe80::aede:48ff:fe71:f6f2
 port = 1025
-debug = True
-priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA
+debug = true
+priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 servicename = Daena
 use_dbus = False
 use_ipv6 = True

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-10-05 20:08:58 +0000
+++ mandos.lsm	2012-06-01 18:39:03 +0000
@@ -1,23 +1,22 @@
 Begin4
 Title:		Mandos
-Version:	1.6.9
-Entered-date:	2014-10-05
+Version:	1.5.5
+Entered-date:	2012-06-01
 Description:	The Mandos system allows computers to have encrypted
-		root file systems and at the same time be capable of
-		remote and/or unattended reboots.
+root file systems and at the same time be capable of remote and/or
+unattended reboots.
 Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
-		tls, dm-crypt
+tls, dm-crypt
 Author:		teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
-Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.9.orig.tar.gz
-Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.9.orig.tar.gz
+Primary-site: http://www.recompile.se/mandos
+	      148K mandos_1.5.5.orig.tar.gz
+Alternate-site: ftp://ftp.recompile.se/pub/mandos
+		148K mandos_1.5.5.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
-		various other libraries.  While made for Debian
-		GNU/Linux, it is probably portable to other
-		distributions, but not other Unixes.
-Copying-policy:	GNU General Public License version 3.0 or later
+various other libraries.  While made for Debian GNU/Linux, it is
+probably portable to other distributions, but not other Unixes.
+Copying-policy: GNU General Public License version 3.0 or later
 End

=== removed file 'mandos.service'
--- mandos.service	2014-10-05 19:39:25 +0000
+++ mandos.service	1970-01-01 00:00:00 +0000
@@ -1,22 +0,0 @@
-[Unit]
-Description=Server of encrypted passwords to Mandos clients
-Documentation=man:intro(8mandos) man:mandos(8)
-
-[Service]
-Type=simple
-## Type=dbus is not appropriate, because Mandos also needs to announce
-## its ZeroConf service and be reachable on the network.
-#Type=dbus
-#BusName=se.recompile.Mandos
-# If you add --no-dbus, also comment out BusName above, and vice versa
-ExecStart=/usr/sbin/mandos --foreground
-Restart=always
-KillMode=process
-## Using socket activation won't work either, because systemd always
-## does bind() on the socket, and also won't announce the ZeroConf
-## service.
-#ExecStart=/usr/sbin/mandos --foreground --socket=0
-#StandardInput=socket
-
-[Install]
-WantedBy=multi-user.target

=== modified file 'mandos.xml'
--- mandos.xml	2015-01-25 00:02:51 +0000
+++ mandos.xml	2012-05-26 22:21:17 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2015-01-25">
+<!ENTITY TIMESTAMP "2012-05-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -36,7 +36,6 @@
       <year>2010</year>
       <year>2011</year>
       <year>2012</year>
-      <year>2013</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -104,10 +103,6 @@
       <sbr/>
       <arg><option>--socket
       <replaceable>FD</replaceable></option></arg>
-      <sbr/>
-      <arg><option>--foreground</option></arg>
-      <sbr/>
-      <arg><option>--no-zeroconf</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -236,8 +231,7 @@
 	<term><option>--priority <replaceable>
 	PRIORITY</replaceable></option></term>
 	<listitem>
-	  <xi:include href="mandos-options.xml"
-                      xpointer="priority_compat"/>
+	  <xi:include href="mandos-options.xml" xpointer="priority"/>
 	</listitem>
       </varlistentry>
       
@@ -317,21 +311,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>--foreground</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml"
-		      xpointer="foreground"/>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
-	<term><option>--no-zeroconf</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="zeroconf"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   
@@ -527,15 +506,11 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/run/mandos.pid</filename></term>
+	<term><filename>/var/run/mandos.pid</filename></term>
 	<listitem>
 	  <para>
 	    The file containing the process id of the
 	    <command>&COMMANDNAME;</command> process started last.
-	    <emphasis >Note:</emphasis> If the <filename
-	    class="directory">/run</filename> directory does not
-	    exist, <filename>/var/run/mandos.pid</filename> will be
-	    used instead.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -586,6 +561,9 @@
       There is no fine-grained control over logging and debug output.
     </para>
     <para>
+      Debug mode is conflated with running in the foreground.
+    </para>
+    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>
@@ -707,7 +685,8 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://gnutls.org/">GnuTLS</ulink>
+	  <ulink url="http://www.gnu.org/software/gnutls/"
+	  >GnuTLS</ulink>
 	</term>
       <listitem>
 	<para>
@@ -751,12 +730,12 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 5246: <citetitle>The Transport Layer Security (TLS)
-	  Protocol Version 1.2</citetitle>
+	  RFC 4346: <citetitle>The Transport Layer Security (TLS)
+	  Protocol Version 1.1</citetitle>
 	</term>
       <listitem>
 	<para>
-	  TLS 1.2 is the protocol implemented by GnuTLS.
+	  TLS 1.1 is the protocol implemented by GnuTLS.
 	</para>
       </listitem>
       </varlistentry>
@@ -772,8 +751,8 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 6091: <citetitle>Using OpenPGP Keys for Transport Layer
-	  Security (TLS) Authentication</citetitle>
+	  RFC 5081: <citetitle>Using OpenPGP Keys for Transport Layer
+	  Security</citetitle>
 	</term>
       <listitem>
 	<para>

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2012-06-13 22:06:57 +0000
+++ network-hooks.d/bridge	2012-04-24 06:55:34 +0000
@@ -33,11 +33,8 @@
     exit
 fi
 
-if [ -n "$DEVICE" ]; then
-    case "$DEVICE" in
-	*,"$BRIDGE"|*,"$BRIDGE",*|"$BRIDGE",*|"$BRIDGE") :;;
-	*) exit;;
-    esac
+if [ -n "$DEVICE" -a "$DEVICE" != "$BRIDGE" ]; then
+    exit
 fi
 
 brctl="/sbin/brctl"

=== modified file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	2012-06-13 22:06:57 +0000
+++ network-hooks.d/openvpn	2012-04-24 06:55:34 +0000
@@ -31,11 +31,8 @@
 fi
 
 # Exit if DEVICE is set and it doesn't match the VPN interface
-if [ -n "$DEVICE" ]; then
-    case "$DEVICE" in
-	*,"$VPNDEVICE"*|"$VPNDEVICE"*) :;;
-	*) exit;;
-    esac
+if [ -n "$DEVICE" -a "$DEVICE" = "${DEVICE#$VPNDEVICE}" ]; then
+    exit
 fi
 
 openvpn=/usr/sbin/openvpn

=== modified file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2012-06-13 22:06:57 +0000
+++ network-hooks.d/wireless	2012-05-25 15:59:39 +0000
@@ -43,11 +43,9 @@
 	for KEY in $ifkeys; do
 	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
 	    INTERFACE=`addrtoif "$ADDRESS"`
-	    
-	    case "$DEVICE" in
-		*,"$INTERFACE"|*,"$INTERFACE",*|"$INTERFACE",*|"$INTERFACE")
-		    break 2;;
-	    esac
+	    if [ "$INTERFACE" = "$DEVICE" ]; then
+		break 2
+	    fi
 	done
 	exit
     done
@@ -123,7 +121,7 @@
 	ROUTES=`eval 'echo "$ROUTES_'"$KEY"\"`
 	if [ -n "$ROUTES" ]; then
 	    for route in $ROUTES; do
-		"$ip" route add "$route" dev "$INTERFACE"
+		"$ip" route add "$route" dev "$BRIDGE"
 	    done
 	fi
     done

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2014-07-16 01:41:23 +0000
+++ plugin-runner.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -23,37 +23,38 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   O_CLOEXEC, pipe2() */
+				   asprintf(), O_CLOEXEC */
 #include <stddef.h>		/* size_t, NULL */
 #include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
 				   realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* fileno(), fprintf(),
-				   stderr, STDOUT_FILENO, fclose() */
-#include <sys/types.h>	        /* fstat(), struct stat, waitpid(),
-				   WIFEXITED(), WEXITSTATUS(), wait(),
-				   pid_t, uid_t, gid_t, getuid(),
-				   getgid() */
+				   stderr, STDOUT_FILENO */
+#include <sys/types.h>	        /* DIR, fdopendir(), stat(), struct
+				   stat, waitpid(), WIFEXITED(),
+				   WEXITSTATUS(), wait(), pid_t,
+				   uid_t, gid_t, getuid(), getgid(),
+				   dirfd() */
 #include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
 				   FD_SET(), FD_ISSET(), FD_CLR */
 #include <sys/wait.h>		/* wait(), waitpid(), WIFEXITED(),
 				   WEXITSTATUS(), WTERMSIG(),
 				   WCOREDUMP() */
-#include <sys/stat.h>		/* struct stat, fstat(), S_ISREG() */
+#include <sys/stat.h>		/* struct stat, stat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* struct dirent, scandirat() */
-#include <unistd.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, write(), STDOUT_FILENO,
-				   struct stat, fstat(), close(),
-				   setgid(), setuid(), S_ISREG(),
-				   faccessat() pipe2(), fork(),
-				   _exit(), dup2(), fexecve(), read()
-				*/
+#include <dirent.h>		/* DIR, struct dirent, fdopendir(),
+				   readdir(), closedir(), dirfd() */
+#include <unistd.h>		/* struct stat, stat(), S_ISREG(),
+				   fcntl(), setuid(), setgid(),
+				   F_GETFD, F_SETFD, FD_CLOEXEC,
+				   access(), pipe(), fork(), close()
+				   dup2(), STDOUT_FILENO, _exit(),
+				   execv(), write(), read(),
+				   close() */
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC, openat(), scandirat(),
-				   pipe2() */
-#include <string.h>		/* strsep, strlen(), strsignal(),
-				   strcmp(), strncmp() */
+				   FD_CLOEXEC */
+#include <string.h>		/* strsep, strlen(), asprintf(),
+				   strsignal(), strcmp(), strncmp() */
 #include <errno.h>		/* errno */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
@@ -71,7 +72,6 @@
 				   EX_CONFIG, EX_UNAVAILABLE, EX_OK */
 #include <errno.h> 		/* errno */
 #include <error.h>		/* error() */
-#include <fnmatch.h>		/* fnmatch() */
 
 #define BUFFER_SIZE 256
 
@@ -105,7 +105,6 @@
 
 /* Gets an existing plugin based on name,
    or if none is found, creates a new one */
-__attribute__((warn_unused_result))
 static plugin *getplugin(char *name){
   /* Check for existing plugin with that name */
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -172,20 +171,18 @@
 }
 
 /* Helper function for add_argument and add_environment */
-__attribute__((nonnull, warn_unused_result))
+__attribute__((nonnull))
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
-  char **new_array = NULL;
   do {
-    new_array = realloc(*array, sizeof(char *)
-			* (size_t) ((*len) + 2));
-  } while(new_array == NULL and errno == EINTR);
+    *array = realloc(*array, sizeof(char *)
+		     * (size_t) ((*len) + 2));
+  } while(*array == NULL and errno == EINTR);
   /* Malloc check */
-  if(new_array == NULL){
+  if(*array == NULL){
     return false;
   }
-  *array = new_array;
   /* Make a copy of the new string */
   char *copy;
   do {
@@ -203,7 +200,7 @@
 }
 
 /* Add to a plugin's argument vector */
-__attribute__((nonnull(2), warn_unused_result))
+__attribute__((nonnull(2)))
 static bool add_argument(plugin *p, const char *arg){
   if(p == NULL){
     return false;
@@ -212,7 +209,7 @@
 }
 
 /* Add to a plugin's environment */
-__attribute__((nonnull(2), warn_unused_result))
+__attribute__((nonnull(2)))
 static bool add_environment(plugin *p, const char *def, bool replace){
   if(p == NULL){
     return false;
@@ -220,19 +217,19 @@
   /* namelen = length of name of environment variable */
   size_t namelen = (size_t)(strchrnul(def, '=') - def);
   /* Search for this environment variable */
-  for(char **envdef = p->environ; *envdef != NULL; envdef++){
-    if(strncmp(*envdef, def, namelen + 1) == 0){
+  for(char **e = p->environ; *e != NULL; e++){
+    if(strncmp(*e, def, namelen + 1) == 0){
       /* It already exists */
       if(replace){
-	char *new_envdef;
+	char *new;
 	do {
-	  new_envdef = realloc(*envdef, strlen(def) + 1);
-	} while(new_envdef == NULL and errno == EINTR);
-	if(new_envdef == NULL){
+	  new = realloc(*e, strlen(def) + 1);
+	} while(new == NULL and errno == EINTR);
+	if(new == NULL){
 	  return false;
 	}
-	*envdef = new_envdef;
-	strcpy(*envdef, def);
+	*e = new;
+	strcpy(*e, def);
       }
       return true;
     }
@@ -240,13 +237,11 @@
   return add_to_char_array(def, &(p->environ), &(p->envc));
 }
 
-#ifndef O_CLOEXEC
 /*
  * Based on the example in the GNU LibC manual chapter 13.13 "File
  * Descriptor Flags".
  | [[info:libc:Descriptor%20Flags][File Descriptor Flags]] |
  */
-__attribute__((warn_unused_result))
 static int set_cloexec_flag(int fd){
   int ret = (int)TEMP_FAILURE_RETRY(fcntl(fd, F_GETFD, 0));
   /* If reading the flags failed, return error indication now. */
@@ -257,7 +252,6 @@
   return (int)TEMP_FAILURE_RETRY(fcntl(fd, F_SETFD,
 				       ret | FD_CLOEXEC));
 }
-#endif	/* not O_CLOEXEC */
 
 
 /* Mark processes as completed when they exit, and save their exit
@@ -295,7 +289,7 @@
 }
 
 /* Prints out a password to stdout */
-__attribute__((nonnull, warn_unused_result))
+__attribute__((nonnull))
 static bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
   for(size_t written = 0; written < length; written += (size_t)ret){
@@ -349,7 +343,9 @@
   char *plugindir = NULL;
   char *argfile = NULL;
   FILE *conffp;
-  struct dirent **direntries = NULL;
+  size_t d_name_len;
+  DIR *dir = NULL;
+  struct dirent *dirst;
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
@@ -363,7 +359,6 @@
 				      .sa_flags = SA_NOCLDSTOP };
   char **custom_argv = NULL;
   int custom_argc = 0;
-  int dir_fd = -1;
   
   /* Establish a signal handler */
   sigemptyset(&sigchld_action.sa_mask);
@@ -440,13 +435,10 @@
 	    break;
 	  }
 	}
-	errno = 0;
       }
       break;
     case 'G':			/* --global-env */
-      if(add_environment(getplugin(NULL), arg, true)){
-	errno = 0;
-      }
+      add_environment(getplugin(NULL), arg, true);
       break;
     case 'o':			/* --options-for */
       {
@@ -469,7 +461,6 @@
 	    break;
 	  }
 	}
-	errno = 0;
       }
       break;
     case 'E':			/* --env-for */
@@ -487,9 +478,7 @@
 	  errno = EINVAL;
 	  break;
 	}
-	if(add_environment(getplugin(arg), envdef, true)){
-	  errno = 0;
-	}
+	add_environment(getplugin(arg), envdef, true);
       }
       break;
     case 'd':			/* --disable */
@@ -497,7 +486,6 @@
 	plugin *p = getplugin(arg);
 	if(p != NULL){
 	  p->disabled = true;
-	  errno = 0;
 	}
       }
       break;
@@ -506,16 +494,12 @@
 	plugin *p = getplugin(arg);
 	if(p != NULL){
 	  p->disabled = false;
-	  errno = 0;
 	}
       }
       break;
     case 128:			/* --plugin-dir */
       free(plugindir);
       plugindir = strdup(arg);
-      if(plugindir != NULL){
-	errno = 0;
-      }
       break;
     case 129:			/* --config-file */
       /* This is already done by parse_opt_config_file() */
@@ -529,7 +513,6 @@
 	break;
       }
       uid = (uid_t)tmp_id;
-      errno = 0;
       break;
     case 131:			/* --groupid */
       tmp_id = strtoimax(arg, &tmp, 10);
@@ -540,7 +523,6 @@
 	break;
       }
       gid = (gid_t)tmp_id;
-      errno = 0;
       break;
     case 132:			/* --debug */
       debug = true;
@@ -594,9 +576,6 @@
     case 129:			/* --config-file */
       free(argfile);
       argfile = strdup(arg);
-      if(argfile != NULL){
-	errno = 0;
-      }
       break;
     case 130:			/* --userid */
     case 131:			/* --groupid */
@@ -685,19 +664,13 @@
 	}
 	
 	custom_argc += 1;
-	{
-	  char **new_argv = realloc(custom_argv, sizeof(char *)
-				    * ((unsigned int)
-				       custom_argc + 1));
-	  if(new_argv == NULL){
-	    error(0, errno, "realloc");
-	    exitstatus = EX_OSERR;
-	    free(new_arg);
-	    free(org_line);
-	    goto fallback;
-	  } else {
-	    custom_argv = new_argv;
-	  }
+	custom_argv = realloc(custom_argv, sizeof(char *)
+			      * ((unsigned int) custom_argc + 1));
+	if(custom_argv == NULL){
+	  error(0, errno, "realloc");
+	  exitstatus = EX_OSERR;
+	  free(org_line);
+	  goto fallback;
 	}
 	custom_argv[custom_argc-1] = new_arg;
 	custom_argv[custom_argc] = NULL;
@@ -780,9 +753,7 @@
        <http://bugs.debian.org/633582> */
     int plugindir_fd = open(/* plugindir or */ PDIR, O_RDONLY);
     if(plugindir_fd == -1){
-      if(errno != ENOENT){
-	error(0, errno, "open(\"" PDIR "\")");
-      }
+      error(0, errno, "open");
     } else {
       ret = (int)TEMP_FAILURE_RETRY(fstat(plugindir_fd, &st));
       if(ret == -1){
@@ -800,7 +771,7 @@
   }
   
   /* Lower permissions */
-  ret = setgid(gid);
+  setgid(gid);
   if(ret == -1){
     error(0, errno, "setgid");
   }
@@ -811,13 +782,24 @@
   
   /* Open plugin directory with close_on_exec flag */
   {
-    dir_fd = open(plugindir != NULL ? plugindir : PDIR, O_RDONLY |
-#ifdef O_CLOEXEC
-		  O_CLOEXEC
-#else  /* not O_CLOEXEC */
-		  0
-#endif	/* not O_CLOEXEC */
-		  );
+    int dir_fd = -1;
+    if(plugindir == NULL){
+      dir_fd = open(PDIR, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    } else {
+      dir_fd = open(plugindir, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    }
     if(dir_fd == -1){
       error(0, errno, "Could not open plugin dir");
       exitstatus = EX_UNAVAILABLE;
@@ -829,104 +811,129 @@
     ret = set_cloexec_flag(dir_fd);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(dir_fd));
       exitstatus = EX_OSERR;
       goto fallback;
     }
 #endif	/* O_CLOEXEC */
-  }
-  
-  int good_name(const struct dirent * const dirent){
-    const char * const patterns[] = { ".*", "#*#", "*~", "*.dpkg-new",
-				      "*.dpkg-old", "*.dpkg-bak",
-				      "*.dpkg-divert", NULL };
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    for(const char **pat = (const char **)patterns;
-	*pat != NULL; pat++){
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-      if(fnmatch(*pat, dirent->d_name, FNM_FILE_NAME | FNM_PERIOD)
-	 != FNM_NOMATCH){
-	if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " matching pattern %s\n", dirent->d_name, *pat);
-	}
-	return 0;
-      }
+    
+    dir = fdopendir(dir_fd);
+    if(dir == NULL){
+      error(0, errno, "Could not open plugin dir");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EX_OSERR;
+      goto fallback;
     }
-    return 1;
-  }
-  
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numplugins = scandirat(dir_fd, ".", &direntries, good_name,
-			     alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numplugins = scandir(plugindir != NULL ? plugindir : PDIR,
-			   &direntries, good_name, alphasort);
-#endif	/* not __GLIBC__ */
-  if(numplugins == -1){
-    error(0, errno, "Could not scan plugin dir");
-    direntries = NULL;
-    exitstatus = EX_OSERR;
-    goto fallback;
   }
   
   FD_ZERO(&rfds_all);
   
   /* Read and execute any executable in the plugin directory*/
-  for(int i = 0; i < numplugins; i++){
-    
-    int plugin_fd = openat(dir_fd, direntries[i]->d_name, O_RDONLY);
-    if(plugin_fd == -1){
-      error(0, errno, "Could not open plugin");
-      free(direntries[i]);
+  while(true){
+    do {
+      dirst = readdir(dir);
+    } while(dirst == NULL and errno == EINTR);
+    
+    /* All directory entries have been processed */
+    if(dirst == NULL){
+      if(errno == EBADF){
+	error(0, errno, "readdir");
+	exitstatus = EX_IOERR;
+	goto fallback;
+      }
+      break;
+    }
+    
+    d_name_len = strlen(dirst->d_name);
+    
+    /* Ignore dotfiles, backup files and other junk */
+    {
+      bool bad_name = false;
+      
+      const char const *bad_prefixes[] = { ".", "#", NULL };
+      
+      const char const *bad_suffixes[] = { "~", "#", ".dpkg-new",
+					   ".dpkg-old",
+					   ".dpkg-bak",
+					   ".dpkg-divert", NULL };
+      for(const char **pre = bad_prefixes; *pre != NULL; pre++){
+	size_t pre_len = strlen(*pre);
+	if((d_name_len >= pre_len)
+	   and strncmp((dirst->d_name), *pre, pre_len) == 0){
+	  if(debug){
+	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		    " with bad prefix %s\n", dirst->d_name, *pre);
+	  }
+	  bad_name = true;
+	  break;
+	}
+      }
+      if(bad_name){
+	continue;
+      }
+      for(const char **suf = bad_suffixes; *suf != NULL; suf++){
+	size_t suf_len = strlen(*suf);
+	if((d_name_len >= suf_len)
+	   and (strcmp((dirst->d_name) + d_name_len-suf_len, *suf)
+		== 0)){
+	  if(debug){
+	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		    " with bad suffix %s\n", dirst->d_name, *suf);
+	  }
+	  bad_name = true;
+	  break;
+	}
+      }
+      
+      if(bad_name){
+	continue;
+      }
+    }
+    
+    char *filename;
+    if(plugindir == NULL){
+      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, PDIR "/%s",
+					     dirst->d_name));
+    } else {
+      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, "%s/%s",
+					     plugindir,
+					     dirst->d_name));
+    }
+    if(ret < 0){
+      error(0, errno, "asprintf");
       continue;
     }
-    ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
+    
+    ret = (int)TEMP_FAILURE_RETRY(stat(filename, &st));
     if(ret == -1){
       error(0, errno, "stat");
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     
     /* Ignore non-executable files */
     if(not S_ISREG(st.st_mode)
-       or (TEMP_FAILURE_RETRY(faccessat(dir_fd, direntries[i]->d_name,
-					X_OK, 0)) != 0)){
+       or (TEMP_FAILURE_RETRY(access(filename, X_OK)) != 0)){
       if(debug){
-	fprintf(stderr, "Ignoring plugin dir entry \"%s/%s\""
-		" with bad type or mode\n",
-		plugindir != NULL ? plugindir : PDIR,
-		direntries[i]->d_name);
+	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		" with bad type or mode\n", filename);
       }
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     
-    plugin *p = getplugin(direntries[i]->d_name);
+    plugin *p = getplugin(dirst->d_name);
     if(p == NULL){
       error(0, errno, "getplugin");
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     if(p->disabled){
       if(debug){
 	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
-		direntries[i]->d_name);
+		dirst->d_name);
       }
-      TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
+      free(filename);
       continue;
     }
     {
@@ -946,8 +953,9 @@
 	}
       }
     }
-    /* If this plugin has any environment variables, we need to
-       duplicate the environment from this process, too. */
+    /* If this plugin has any environment variables, we will call
+       using execve and need to duplicate the environment from this
+       process, too. */
     if(p->environ[0] != NULL){
       for(char **e = environ; *e != NULL; e++){
 	if(not add_environment(p, *e, false)){
@@ -957,47 +965,25 @@
     }
     
     int pipefd[2];
-#ifndef O_CLOEXEC
     ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
-#else  /* O_CLOEXEC */
-    ret = (int)TEMP_FAILURE_RETRY(pipe2(pipefd, O_CLOEXEC));
-#endif	/* O_CLOEXEC */
     if(ret == -1){
       error(0, errno, "pipe");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-    if(pipefd[0] >= FD_SETSIZE){
-      fprintf(stderr, "pipe()[0] (%d) >= FD_SETSIZE (%d)", pipefd[0],
-	      FD_SETSIZE);
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
-      exitstatus = EX_OSERR;
-      free(direntries[i]);
-      goto fallback;
-    }
-#ifndef O_CLOEXEC
+      goto fallback;
+    }
     /* Ask OS to automatic close the pipe on exec */
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-#endif	/* not O_CLOEXEC */
     /* Block SIGCHLD until process is safely in process list */
     ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_BLOCK,
 					      &sigchld_action.sa_mask,
@@ -1005,7 +991,6 @@
     if(ret < 0){
       error(0, errno, "sigprocmask");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -1015,12 +1000,7 @@
     } while(pid == -1 and errno == EINTR);
     if(pid == -1){
       error(0, errno, "fork");
-      TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,
-				     &sigchld_action.sa_mask, NULL));
-      TEMP_FAILURE_RETRY(close(pipefd[0]));
-      TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pid == 0){
@@ -1042,20 +1022,29 @@
 	_exit(EX_OSERR);
       }
       
-      if(fexecve(plugin_fd, p->argv,
-		(p->environ[0] != NULL) ? p->environ : environ) < 0){
-	error(0, errno, "fexecve for %s/%s",
-	      plugindir != NULL ? plugindir : PDIR,
-	      direntries[i]->d_name);
-	_exit(EX_OSERR);
+      if(dirfd(dir) < 0){
+	/* If dir has no file descriptor, we could not set FD_CLOEXEC
+	   above and must now close it manually here. */
+	closedir(dir);
+      }
+      if(p->environ[0] == NULL){
+	if(execv(filename, p->argv) < 0){
+	  error(0, errno, "execv for %s", filename);
+	  _exit(EX_OSERR);
+	}
+      } else {
+	if(execve(filename, p->argv, p->environ) < 0){
+	  error(0, errno, "execve for %s", filename);
+	  _exit(EX_OSERR);
+	}
       }
       /* no return */
     }
     /* Parent process */
     TEMP_FAILURE_RETRY(close(pipefd[1])); /* Close unused write end of
 					     pipe */
-    TEMP_FAILURE_RETRY(close(plugin_fd));
-    plugin *new_plugin = getplugin(direntries[i]->d_name);
+    free(filename);
+    plugin *new_plugin = getplugin(dirst->d_name);
     if(new_plugin == NULL){
       error(0, errno, "getplugin");
       ret = (int)(TEMP_FAILURE_RETRY
@@ -1065,10 +1054,8 @@
         error(0, errno, "sigprocmask");
       }
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-    free(direntries[i]);
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];
@@ -1084,30 +1071,16 @@
       goto fallback;
     }
     
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wsign-conversion"
-#endif
-#endif
     FD_SET(new_plugin->fd, &rfds_all); /* Spurious warning from
-					  -Wconversion in GNU libc
-					  before 2.16 */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic pop
-#endif
-#endif
+					  -Wconversion */
     
     if(maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
     }
   }
   
-  free(direntries);
-  direntries = NULL;
-  TEMP_FAILURE_RETRY(close(dir_fd));
-  dir_fd = -1;
+  TEMP_FAILURE_RETRY(closedir(dir));
+  dir = NULL;
   free_plugin(getplugin(NULL));
   
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -1159,20 +1132,8 @@
 	  }
 	  
 	  /* Remove the plugin */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wsign-conversion"
-#endif
-#endif
 	  FD_CLR(proc->fd, &rfds_all); /* Spurious warning from
-					  -Wconversion in GNU libc
-					  before 2.16 */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic pop
-#endif
-#endif
+					  -Wconversion */
 	  
 	  /* Block signal while modifying process_list */
 	  ret = (int)TEMP_FAILURE_RETRY(sigprocmask
@@ -1218,37 +1179,22 @@
       }
       
       /* This process has not completed.  Does it have any output? */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wsign-conversion"
-#endif
-#endif
       if(proc->eof or not FD_ISSET(proc->fd, &rfds)){ /* Spurious
 							 warning from
-							 -Wconversion
-							 in GNU libc
-							 before
-							 2.16 */
-#if defined (__GNUC__) and defined (__GLIBC__)
-#if not __GLIBC_PREREQ(2, 16)
-#pragma GCC diagnostic pop
-#endif
-#endif
+							 -Wconversion */
 	/* This process had nothing to say at this time */
 	proc = proc->next;
 	continue;
       }
       /* Before reading, make the process' data buffer large enough */
       if(proc->buffer_length + BUFFER_SIZE > proc->buffer_size){
-	char *new_buffer = realloc(proc->buffer, proc->buffer_size
-				   + (size_t) BUFFER_SIZE);
-	if(new_buffer == NULL){
+	proc->buffer = realloc(proc->buffer, proc->buffer_size
+			       + (size_t) BUFFER_SIZE);
+	if(proc->buffer == NULL){
 	  error(0, errno, "malloc");
 	  exitstatus = EX_OSERR;
 	  goto fallback;
 	}
-	proc->buffer = new_buffer;
 	proc->buffer_size += BUFFER_SIZE;
       }
       /* Read from the process */
@@ -1307,10 +1253,8 @@
     free(custom_argv);
   }
   
-  free(direntries);
-  
-  if(dir_fd != -1){
-    TEMP_FAILURE_RETRY(close(dir_fd));
+  if(dir != NULL){
+    closedir(dir);
   }
   
   /* Kill the processes */

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-08-09 23:37:07 +0000
+++ plugins.d/askpass-fifo.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -23,7 +23,7 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
@@ -44,8 +44,6 @@
 #include <string.h> 		/* strerror() */
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
-uid_t uid = 65534;
-gid_t gid = 65534;
 
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
@@ -57,7 +55,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
@@ -76,9 +74,6 @@
   int ret = 0;
   ssize_t sret;
   
-  uid = getuid();
-  gid = getgid();
-  
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
@@ -124,16 +119,6 @@
     }
   }
   
-  /* Lower group privileges  */
-  if(setgid(gid) == -1){
-    error_plus(0, errno, "setgid");
-  }
-  
-  /* Lower user privileges */
-  if(setuid(uid) == -1){
-    error_plus(0, errno, "setuid");
-  }
-  
   /* Read from FIFO */
   char *buf = NULL;
   size_t buf_len = 0;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2015-03-10 18:52:09 +0000
+++ plugins.d/mandos-client.c	2012-06-09 23:41:07 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -32,15 +32,15 @@
 /* Needed by GPGME, specifically gpgme_data_seek() */
 #ifndef _LARGEFILE_SOURCE
 #define _LARGEFILE_SOURCE
-#endif	/* not _LARGEFILE_SOURCE */
+#endif
 #ifndef _FILE_OFFSET_BITS
 #define _FILE_OFFSET_BITS 64
-#endif	/* not _FILE_OFFSET_BITS */
+#endif
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror() */
+				   stdout, ferror(), remove() */
 #include <stdint.h> 		/* uint16_t, uint32_t, intptr_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
@@ -55,13 +55,13 @@
 				   opendir(), DIR */
 #include <sys/stat.h>		/* open(), S_ISREG */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
-				   inet_pton(), connect(),
-				   getnameinfo() */
-#include <fcntl.h>		/* open(), unlinkat() */
+				   inet_pton(), connect() */
+#include <fcntl.h>		/* open() */
 #include <dirent.h>		/* opendir(), struct dirent, readdir()
 				 */
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
 				   strtoimax() */
+#include <assert.h>		/* assert() */
 #include <errno.h>		/* perror(), errno,
 				   program_invocation_short_name */
 #include <time.h>		/* nanosleep(), time(), sleep() */
@@ -73,9 +73,8 @@
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
-				   setgid(), pause(), _exit(),
-				   unlinkat() */
-#include <arpa/inet.h>		/* inet_pton(), htons() */
+				   setgid(), pause(), _exit() */
+#include <arpa/inet.h>		/* inet_pton(), htons, inet_ntop() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
 				   argp_state, struct argp,
@@ -89,12 +88,6 @@
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
 				   WEXITSTATUS(), WTERMSIG() */
 #include <grp.h>		/* setgroups() */
-#include <argz.h>		/* argz_add_sep(), argz_next(),
-				   argz_delete(), argz_append(),
-				   argz_stringify(), argz_add(),
-				   argz_count() */
-#include <netdb.h>		/* getnameinfo(), NI_NUMERICHOST,
-				   EAI_SYSTEM, gai_strerror() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -142,14 +135,13 @@
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
 const char *hookdir = HOOKDIR;
-int hookdir_fd = -1;
 uid_t uid = 65534;
 gid_t gid = 65534;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
   const char *ip;
-  in_port_t port;
+  uint16_t port;
   AvahiIfIndex if_index;
   int af;
   struct timespec last_seen;
@@ -159,6 +151,7 @@
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
+  AvahiSimplePoll *simple_poll;
   AvahiServer *server;
   gnutls_certificate_credentials_t cred;
   unsigned int dh_bits;
@@ -166,12 +159,13 @@
   const char *priority;
   gpgme_ctx_t ctx;
   server *current_server;
-  char *interfaces;
-  size_t interfaces_size;
 } mandos_context;
 
-/* global so signal handler can reach it*/
-AvahiSimplePoll *simple_poll;
+/* global context so signal handler can reach it*/
+mandos_context mc = { .simple_poll = NULL, .server = NULL,
+		      .dh_bits = 1024, .priority = "SECURE256"
+		      ":!CTYPE-X.509:+CTYPE-OPENPGP",
+		      .current_server = NULL };
 
 sig_atomic_t quit_now = 0;
 int signal_received = 0;
@@ -185,14 +179,14 @@
   perror(print_text);
 }
 
-__attribute__((format (gnu_printf, 2, 3), nonnull))
+__attribute__((format (gnu_printf, 2, 3)))
 int fprintf_plus(FILE *stream, const char *format, ...){
   va_list ap;
   va_start (ap, format);
   
   TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
 			     program_invocation_short_name));
-  return (int)TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
+  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
 }
 
 /*
@@ -200,28 +194,21 @@
  * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
-__attribute__((nonnull, warn_unused_result))
 size_t incbuffer(char **buffer, size_t buffer_length,
 		 size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
-    char *new_buf = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
-    if(new_buf == NULL){
-      int old_errno = errno;
-      free(*buffer);
-      errno = old_errno;
-      *buffer = NULL;
+    *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
+    if(buffer == NULL){
       return 0;
     }
-    *buffer = new_buf;
     buffer_capacity += BUFFER_SIZE;
   }
   return buffer_capacity;
 }
 
 /* Add server to set of servers to retry periodically */
-__attribute__((nonnull, warn_unused_result))
-bool add_server(const char *ip, in_port_t port, AvahiIfIndex if_index,
-		int af, server **current_server){
+bool add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
+		int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
@@ -234,34 +221,24 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    free(new_server);
-    return false;
-  }
-  ret = clock_gettime(CLOCK_MONOTONIC, &(new_server->last_seen));
-  if(ret == -1){
-    perror_plus("clock_gettime");
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    free((char *)(new_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-    free(new_server);
     return false;
   }
   /* Special case of first server */
-  if(*current_server == NULL){
+  if (mc.current_server == NULL){
     new_server->next = new_server;
     new_server->prev = new_server;
-    *current_server = new_server;
+    mc.current_server = new_server;
+  /* Place the new server last in the list */
   } else {
-    /* Place the new server last in the list */
-    new_server->next = *current_server;
-    new_server->prev = (*current_server)->prev;
+    new_server->next = mc.current_server;
+    new_server->prev = mc.current_server->prev;
     new_server->prev->next = new_server;
-    (*current_server)->prev = new_server;
+    mc.current_server->prev = new_server;
+  }
+  ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
+  if(ret == -1){
+    perror_plus("clock_gettime");
+    return false;
   }
   return true;
 }
@@ -269,18 +246,16 @@
 /* 
  * Initialize GPGME.
  */
-__attribute__((nonnull, warn_unused_result))
-static bool init_gpgme(const char * const seckey,
-		       const char * const pubkey,
-		       const char * const tempdir,
-		       mandos_context *mc){
+static bool init_gpgme(const char *seckey, const char *pubkey,
+		       const char *tempdir){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
+  
   /*
    * Helper function to insert pub and seckey to the engine keyring.
    */
-  bool import_key(const char * const filename){
+  bool import_key(const char *filename){
     int ret;
     int fd;
     gpgme_data_t pgp_data;
@@ -298,7 +273,7 @@
       return false;
     }
     
-    rc = gpgme_op_import(mc->ctx, pgp_data);
+    rc = gpgme_op_import(mc.ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
       fprintf_plus(stderr, "bad gpgme_op_import: %s: %s\n",
 		   gpgme_strsource(rc), gpgme_strerror(rc));
@@ -348,7 +323,7 @@
   }
   
   /* Create new GPGME "context" */
-  rc = gpgme_new(&(mc->ctx));
+  rc = gpgme_new(&(mc.ctx));
   if(rc != GPG_ERR_NO_ERROR){
     fprintf_plus(stderr, "Mandos plugin mandos-client: "
 		 "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
@@ -367,11 +342,9 @@
  * Decrypt OpenPGP data.
  * Returns -1 on error
  */
-__attribute__((nonnull, warn_unused_result))
 static ssize_t pgp_packet_decrypt(const char *cryptotext,
 				  size_t crypto_size,
-				  char **plaintext,
-				  mandos_context *mc){
+				  char **plaintext){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_error_t rc;
   ssize_t ret;
@@ -403,14 +376,14 @@
   
   /* Decrypt data from the cryptotext data buffer to the plaintext
      data buffer */
-  rc = gpgme_op_decrypt(mc->ctx, dh_crypto, dh_plain);
+  rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
     fprintf_plus(stderr, "bad gpgme_op_decrypt: %s: %s\n",
 		 gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
-      result = gpgme_op_decrypt_result(mc->ctx);
+      result = gpgme_op_decrypt_result(mc.ctx);
       if(result == NULL){
 	fprintf_plus(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
@@ -493,32 +466,23 @@
   return plaintext_length;
 }
 
-__attribute__((warn_unused_result, const))
-static const char *safe_string(const char *str){
-  if(str == NULL)
-    return "(unknown)";
-  return str;
-}
-
-__attribute__((warn_unused_result))
-static const char *safer_gnutls_strerror(int value){
-  const char *ret = gnutls_strerror(value);
-  return safe_string(ret);
+static const char * safer_gnutls_strerror(int value){
+  const char *ret = gnutls_strerror(value); /* Spurious warning from
+					       -Wunreachable-code */
+  if(ret == NULL)
+    ret = "(unknown)";
+  return ret;
 }
 
 /* GnuTLS log function callback */
-__attribute__((nonnull))
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
   fprintf_plus(stderr, "GnuTLS: %s", string);
 }
 
-__attribute__((nonnull, warn_unused_result))
 static int init_gnutls_global(const char *pubkeyfilename,
-			      const char *seckeyfilename,
-			      mandos_context *mc){
+			      const char *seckeyfilename){
   int ret;
-  unsigned int uret;
   
   if(debug){
     fprintf_plus(stderr, "Initializing GnuTLS\n");
@@ -540,7 +504,7 @@
   }
   
   /* OpenPGP credentials */
-  ret = gnutls_certificate_allocate_credentials(&mc->cred);
+  ret = gnutls_certificate_allocate_credentials(&mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr, "GnuTLS memory error: %s\n",
 		 safer_gnutls_strerror(ret));
@@ -556,7 +520,7 @@
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
-    (mc->cred, pubkeyfilename, seckeyfilename,
+    (mc.cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr,
@@ -568,136 +532,33 @@
   }
   
   /* GnuTLS server initialization */
-  ret = gnutls_dh_params_init(&mc->dh_params);
+  ret = gnutls_dh_params_init(&mc.dh_params);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr, "Error in GnuTLS DH parameter"
 		 " initialization: %s\n",
 		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
-  if(mc->dh_bits == 0){
-    /* Find out the optimal number of DH bits */
-    /* Try to read the private key file */
-    gnutls_datum_t buffer = { .data = NULL, .size = 0 };
-    {
-      int secfile = open(seckeyfilename, O_RDONLY);
-      size_t buffer_capacity = 0;
-      while(true){
-	buffer_capacity = incbuffer((char **)&buffer.data,
-				    (size_t)buffer.size,
-				    (size_t)buffer_capacity);
-	if(buffer_capacity == 0){
-	  perror_plus("incbuffer");
-	  free(buffer.data);
-	  buffer.data = NULL;
-	  break;
-	}
-	ssize_t bytes_read = read(secfile, buffer.data + buffer.size,
-				  BUFFER_SIZE);
-	/* EOF */
-	if(bytes_read == 0){
-	  break;
-	}
-	/* check bytes_read for failure */
-	if(bytes_read < 0){
-	  perror_plus("read");
-	  free(buffer.data);
-	  buffer.data = NULL;
-	  break;
-	}
-	buffer.size += (unsigned int)bytes_read;
-      }
-      close(secfile);
-    }
-    /* If successful, use buffer to parse private key */
-    gnutls_sec_param_t sec_param = GNUTLS_SEC_PARAM_ULTRA;
-    if(buffer.data != NULL){
-      {
-	gnutls_openpgp_privkey_t privkey = NULL;
-	ret = gnutls_openpgp_privkey_init(&privkey);
-	if(ret != GNUTLS_E_SUCCESS){
-	  fprintf_plus(stderr, "Error initializing OpenPGP key"
-		       " structure: %s", safer_gnutls_strerror(ret));
-	  free(buffer.data);
-	  buffer.data = NULL;
-	} else {
-	  ret = gnutls_openpgp_privkey_import(privkey, &buffer,
-					    GNUTLS_OPENPGP_FMT_BASE64,
-					      "", 0);
-	  if(ret != GNUTLS_E_SUCCESS){
-	    fprintf_plus(stderr, "Error importing OpenPGP key : %s",
-			 safer_gnutls_strerror(ret));
-	    privkey = NULL;
-	  }
-	  free(buffer.data);
-	  buffer.data = NULL;
-	  if(privkey != NULL){
-	    /* Use private key to suggest an appropriate sec_param */
-	    sec_param = gnutls_openpgp_privkey_sec_param(privkey);
-	    gnutls_openpgp_privkey_deinit(privkey);
-	    if(debug){
-	      fprintf_plus(stderr, "This OpenPGP key implies using a"
-			   " GnuTLS security parameter \"%s\".\n",
-			   safe_string(gnutls_sec_param_get_name
-				       (sec_param)));
-	    }
-	  }
-	}
-      }
-      if(sec_param == GNUTLS_SEC_PARAM_UNKNOWN){
-	/* Err on the side of caution */
-	sec_param = GNUTLS_SEC_PARAM_ULTRA;
-	if(debug){
-	  fprintf_plus(stderr, "Falling back to security parameter"
-		       " \"%s\"\n",
-		       safe_string(gnutls_sec_param_get_name
-				   (sec_param)));
-	}
-      }
-    }
-    uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
-    if(uret != 0){
-      mc->dh_bits = uret;
-      if(debug){
-	fprintf_plus(stderr, "A \"%s\" GnuTLS security parameter"
-		     " implies %u DH bits; using that.\n",
-		     safe_string(gnutls_sec_param_get_name
-				 (sec_param)),
-		     mc->dh_bits);
-      }
-    } else {
-      fprintf_plus(stderr, "Failed to get implied number of DH"
-		   " bits for security parameter \"%s\"): %s\n",
-		   safe_string(gnutls_sec_param_get_name(sec_param)),
-		   safer_gnutls_strerror(ret));
-      goto globalfail;
-    }
-  } else if(debug){
-    fprintf_plus(stderr, "DH bits explicitly set to %u\n",
-		 mc->dh_bits);
-  }
-  ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
+  ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS prime generation (%u bits):"
-		 " %s\n", mc->dh_bits, safer_gnutls_strerror(ret));
+    fprintf_plus(stderr, "Error in GnuTLS prime generation: %s\n",
+		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
-  gnutls_certificate_set_dh_params(mc->cred, mc->dh_params);
+  gnutls_certificate_set_dh_params(mc.cred, mc.dh_params);
   
   return 0;
   
  globalfail:
   
-  gnutls_certificate_free_credentials(mc->cred);
+  gnutls_certificate_free_credentials(mc.cred);
   gnutls_global_deinit();
-  gnutls_dh_params_deinit(mc->dh_params);
+  gnutls_dh_params_deinit(mc.dh_params);
   return -1;
 }
 
-__attribute__((nonnull, warn_unused_result))
-static int init_gnutls_session(gnutls_session_t *session,
-			       mandos_context *mc){
+static int init_gnutls_session(gnutls_session_t *session){
   int ret;
   /* GnuTLS session creation */
   do {
@@ -715,7 +576,7 @@
   {
     const char *err;
     do {
-      ret = gnutls_priority_set_direct(*session, mc->priority, &err);
+      ret = gnutls_priority_set_direct(*session, mc.priority, &err);
       if(quit_now){
 	gnutls_deinit(*session);
 	return -1;
@@ -732,7 +593,7 @@
   
   do {
     ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
-				 mc->cred);
+				 mc.cred);
     if(quit_now){
       gnutls_deinit(*session);
       return -1;
@@ -748,7 +609,7 @@
   /* ignore client certificate if any. */
   gnutls_certificate_server_set_request(*session, GNUTLS_CERT_IGNORE);
   
-  gnutls_dh_set_prime_bits(*session, mc->dh_bits);
+  gnutls_dh_set_prime_bits(*session, mc.dh_bits);
   
   return 0;
 }
@@ -758,13 +619,15 @@
 		      __attribute__((unused)) const char *txt){}
 
 /* Called when a Mandos server is found */
-__attribute__((nonnull, warn_unused_result))
-static int start_mandos_communication(const char *ip, in_port_t port,
+static int start_mandos_communication(const char *ip, uint16_t port,
 				      AvahiIfIndex if_index,
-				      int af, mandos_context *mc){
+				      int af){
   int ret, tcp_sd = -1;
   ssize_t sret;
-  struct sockaddr_storage to;
+  union {
+    struct sockaddr_in in;
+    struct sockaddr_in6 in6;
+  } to;
   char *buffer = NULL;
   char *decrypted_buffer = NULL;
   size_t buffer_length = 0;
@@ -794,46 +657,14 @@
     return -1;
   }
   
-  /* If the interface is specified and we have a list of interfaces */
-  if(if_index != AVAHI_IF_UNSPEC and mc->interfaces != NULL){
-    /* Check if the interface is one of the interfaces we are using */
-    bool match = false;
-    {
-      char *interface = NULL;
-      while((interface=argz_next(mc->interfaces, mc->interfaces_size,
-				 interface))){
-	if(if_nametoindex(interface) == (unsigned int)if_index){
-	  match = true;
-	  break;
-	}
-      }
-    }
-    if(not match){
-      /* This interface does not match any in the list, so we don't
-	 connect to the server */
-      if(debug){
-	char interface[IF_NAMESIZE];
-	if(if_indextoname((unsigned int)if_index, interface) == NULL){
-	  perror_plus("if_indextoname");
-	} else {
-	  fprintf_plus(stderr, "Skipping server on non-used interface"
-		       " \"%s\"\n",
-		       if_indextoname((unsigned int)if_index,
-				      interface));
-	}
-      }
-      return -1;
-    }
-  }
-  
-  ret = init_gnutls_session(&session, mc);
+  ret = init_gnutls_session(&session);
   if(ret != 0){
     return -1;
   }
   
   if(debug){
     fprintf_plus(stderr, "Setting up a TCP connection to %s, port %"
-		 PRIuMAX "\n", ip, (uintmax_t)port);
+		 PRIu16 "\n", ip, port);
   }
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
@@ -851,11 +682,11 @@
   
   memset(&to, 0, sizeof(to));
   if(af == AF_INET6){
-    ((struct sockaddr_in6 *)&to)->sin6_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &((struct sockaddr_in6 *)&to)->sin6_addr);
+    to.in6.sin6_family = (sa_family_t)af;
+    ret = inet_pton(af, ip, &to.in6.sin6_addr);
   } else {			/* IPv4 */
-    ((struct sockaddr_in *)&to)->sin_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &((struct sockaddr_in *)&to)->sin_addr);
+    to.in.sin_family = (sa_family_t)af;
+    ret = inet_pton(af, ip, &to.in.sin_addr);
   }
   if(ret < 0 ){
     int e = errno;
@@ -870,9 +701,13 @@
     goto mandos_end;
   }
   if(af == AF_INET6){
-    ((struct sockaddr_in6 *)&to)->sin6_port = htons(port);
-    if(IN6_IS_ADDR_LINKLOCAL
-       (&((struct sockaddr_in6 *)&to)->sin6_addr)){
+    to.in6.sin6_port = htons(port); /* Spurious warnings from
+				       -Wconversion and
+				       -Wunreachable-code */
+    
+    if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
+       (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
+				-Wunreachable-code*/
       if(if_index == AVAHI_IF_UNSPEC){
 	fprintf_plus(stderr, "An IPv6 link-local address is"
 		     " incomplete without a network interface\n");
@@ -880,10 +715,12 @@
 	goto mandos_end;
       }
       /* Set the network interface number as scope */
-      ((struct sockaddr_in6 *)&to)->sin6_scope_id = (uint32_t)if_index;
+      to.in6.sin6_scope_id = (uint32_t)if_index;
     }
   } else {
-    ((struct sockaddr_in *)&to)->sin_port = htons(port);
+    to.in.sin_port = htons(port); /* Spurious warnings from
+				     -Wconversion and
+				     -Wunreachable-code */
   }
   
   if(quit_now){
@@ -897,32 +734,29 @@
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
 	perror_plus("if_indextoname");
       } else {
-	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIuMAX
-		     "\n", ip, interface, (uintmax_t)port);
+	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIu16
+		     "\n", ip, interface, port);
       }
     } else {
-      fprintf_plus(stderr, "Connection to: %s, port %" PRIuMAX "\n",
-		   ip, (uintmax_t)port);
+      fprintf_plus(stderr, "Connection to: %s, port %" PRIu16 "\n",
+		   ip, port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
+    const char *pcret;
     if(af == AF_INET6){
-      ret = getnameinfo((struct sockaddr *)&to,
-			sizeof(struct sockaddr_in6),
-			addrstr, sizeof(addrstr), NULL, 0,
-			NI_NUMERICHOST);
+      pcret = inet_ntop(af, &(to.in6.sin6_addr), addrstr,
+			sizeof(addrstr));
     } else {
-      ret = getnameinfo((struct sockaddr *)&to,
-			sizeof(struct sockaddr_in),
-			addrstr, sizeof(addrstr), NULL, 0,
-			NI_NUMERICHOST);
+      pcret = inet_ntop(af, &(to.in.sin_addr), addrstr,
+			sizeof(addrstr));
     }
-    if(ret == EAI_SYSTEM){
-      perror_plus("getnameinfo");
-    } else if(ret != 0) {
-      fprintf_plus(stderr, "getnameinfo: %s", gai_strerror(ret));
-    } else if(strcmp(addrstr, ip) != 0){
-      fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+    if(pcret == NULL){
+      perror_plus("inet_ntop");
+    } else {
+      if(strcmp(addrstr, ip) != 0){
+	fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+      }
     }
   }
   
@@ -932,14 +766,12 @@
   }
   
   if(af == AF_INET6){
-    ret = connect(tcp_sd, (struct sockaddr *)&to,
-		  sizeof(struct sockaddr_in6));
+    ret = connect(tcp_sd, &to.in6, sizeof(to));
   } else {
-    ret = connect(tcp_sd, (struct sockaddr *)&to, /* IPv4 */
-		  sizeof(struct sockaddr_in));
+    ret = connect(tcp_sd, &to.in, sizeof(to)); /* IPv4 */
   }
   if(ret < 0){
-    if((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
+    if ((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
       int e = errno;
       perror_plus("connect");
       errno = e;
@@ -1106,7 +938,7 @@
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
     decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
-					       &decrypted_buffer, mc);
+					       &decrypted_buffer);
     if(decrypted_buffer_size >= 0){
       
       written = 0;
@@ -1160,7 +992,6 @@
   return retval;
 }
 
-__attribute__((nonnull))
 static void resolve_callback(AvahiSServiceResolver *r,
 			     AvahiIfIndex interface,
 			     AvahiProtocol proto,
@@ -1174,16 +1005,13 @@
 			     AVAHI_GCC_UNUSED AvahiStringList *txt,
 			     AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			     flags,
-			     void *mc){
-  if(r == NULL){
-    return;
-  }
+			     AVAHI_GCC_UNUSED void* userdata){
+  assert(r);
   
   /* Called whenever a service has been resolved successfully or
      timed out */
   
   if(quit_now){
-    avahi_s_service_resolver_free(r);
     return;
   }
   
@@ -1193,8 +1021,7 @@
     fprintf_plus(stderr, "(Avahi Resolver) Failed to resolve service "
 		 "'%s' of type '%s' in domain '%s': %s\n", name, type,
 		 domain,
-		 avahi_strerror(avahi_server_errno
-				(((mandos_context*)mc)->server)));
+		 avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -1206,16 +1033,13 @@
 		     PRIdMAX ") on port %" PRIu16 "\n", name,
 		     host_name, ip, (intmax_t)interface, port);
       }
-      int ret = start_mandos_communication(ip, (in_port_t)port,
-					   interface,
-					   avahi_proto_to_af(proto),
-					   mc);
+      int ret = start_mandos_communication(ip, port, interface,
+					   avahi_proto_to_af(proto));
       if(ret == 0){
-	avahi_simple_poll_quit(simple_poll);
+	avahi_simple_poll_quit(mc.simple_poll);
       } else {
-	if(not add_server(ip, (in_port_t)port, interface,
-			  avahi_proto_to_af(proto),
-			  &((mandos_context*)mc)->current_server)){
+	if(not add_server(ip, port, interface,
+			  avahi_proto_to_af(proto))){
 	  fprintf_plus(stderr, "Failed to add server \"%s\" to server"
 		       " list\n", name);
 	}
@@ -1234,10 +1058,8 @@
 			    const char *domain,
 			    AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			    flags,
-			    void *mc){
-  if(b == NULL){
-    return;
-  }
+			    AVAHI_GCC_UNUSED void* userdata){
+  assert(b);
   
   /* Called whenever a new services becomes available on the LAN or
      is removed from the LAN */
@@ -1251,9 +1073,8 @@
   case AVAHI_BROWSER_FAILURE:
     
     fprintf_plus(stderr, "(Avahi browser) %s\n",
-		 avahi_strerror(avahi_server_errno
-				(((mandos_context*)mc)->server)));
-    avahi_simple_poll_quit(simple_poll);
+		 avahi_strerror(avahi_server_errno(mc.server)));
+    avahi_simple_poll_quit(mc.simple_poll);
     return;
     
   case AVAHI_BROWSER_NEW:
@@ -1262,14 +1083,12 @@
        the callback function is called the Avahi server will free the
        resolver for us. */
     
-    if(avahi_s_service_resolver_new(((mandos_context*)mc)->server,
-				    interface, protocol, name, type,
-				    domain, protocol, 0,
-				    resolve_callback, mc) == NULL)
+    if(avahi_s_service_resolver_new(mc.server, interface, protocol,
+				    name, type, domain, protocol, 0,
+				    resolve_callback, NULL) == NULL)
       fprintf_plus(stderr, "Avahi: Failed to resolve service '%s':"
 		   " %s\n", name,
-		   avahi_strerror(avahi_server_errno
-				  (((mandos_context*)mc)->server)));
+		   avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_BROWSER_REMOVE:
@@ -1294,38 +1113,31 @@
   signal_received = sig;
   int old_errno = errno;
   /* set main loop to exit */
-  if(simple_poll != NULL){
-    avahi_simple_poll_quit(simple_poll);
+  if(mc.simple_poll != NULL){
+    avahi_simple_poll_quit(mc.simple_poll);
   }
   errno = old_errno;
 }
 
-__attribute__((nonnull, warn_unused_result))
 bool get_flags(const char *ifname, struct ifreq *ifr){
   int ret;
-  error_t ret_errno;
   
   int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
   if(s < 0){
-    ret_errno = errno;
     perror_plus("socket");
-    errno = ret_errno;
     return false;
   }
   strcpy(ifr->ifr_name, ifname);
   ret = ioctl(s, SIOCGIFFLAGS, ifr);
   if(ret == -1){
     if(debug){
-      ret_errno = errno;
       perror_plus("ioctl SIOCGIFFLAGS");
-      errno = ret_errno;
     }
     return false;
   }
   return true;
 }
 
-__attribute__((nonnull, warn_unused_result))
 bool good_flags(const char *ifname, const struct ifreq *ifr){
   
   /* Reject the loopback device */
@@ -1373,7 +1185,6 @@
  * corresponds to an acceptable network device.
  * (This function is passed to scandir(3) as a filter function.)
  */
-__attribute__((nonnull, warn_unused_result))
 int good_interface(const struct dirent *if_entry){
   if(if_entry->d_name[0] == '.'){
     return 0;
@@ -1395,40 +1206,48 @@
 }
 
 /* 
- * This function determines if a network interface is up.
- */
-__attribute__((nonnull, warn_unused_result))
-bool interface_is_up(const char *interface){
-  struct ifreq ifr;
-  if(not get_flags(interface, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-    }
-    return false;
-  }
-  
-  return (bool)(ifr.ifr_flags & IFF_UP);
-}
-
-/* 
- * This function determines if a network interface is running
- */
-__attribute__((nonnull, warn_unused_result))
-bool interface_is_running(const char *interface){
-  struct ifreq ifr;
-  if(not get_flags(interface, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-    }
-    return false;
-  }
-  
-  return (bool)(ifr.ifr_flags & IFF_RUNNING);
-}
-
-__attribute__((nonnull, pure, warn_unused_result))
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device which is up.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int up_interface(const struct dirent *if_entry){
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  
+  struct ifreq ifr;
+  if(not get_flags(if_entry->d_name, &ifr)){
+    if(debug){
+      fprintf_plus(stderr, "Failed to get flags for interface "
+		   "\"%s\"\n", if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  /* Reject down interfaces */
+  if(not (ifr.ifr_flags & IFF_UP)){
+    if(debug){
+      fprintf_plus(stderr, "Rejecting down interface \"%s\"\n",
+		   if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  /* Reject non-running interfaces */
+  if(not (ifr.ifr_flags & IFF_RUNNING)){
+    if(debug){
+      fprintf_plus(stderr, "Rejecting non-running interface \"%s\"\n",
+		   if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  if(not good_flags(if_entry->d_name, &ifr)){
+    return 0;
+  }
+  return 1;
+}
+
 int notdotentries(const struct dirent *direntry){
   /* Skip "." and ".." */
   if(direntry->d_name[0] == '.'
@@ -1441,7 +1260,6 @@
 }
 
 /* Is this directory entry a runnable program? */
-__attribute__((nonnull, warn_unused_result))
 int runnable_hook(const struct dirent *direntry){
   int ret;
   size_t sret;
@@ -1455,7 +1273,7 @@
   sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 		"abcdefghijklmnopqrstuvwxyz"
 		"0123456789"
-		"_.-");
+		"_-");
   if((direntry->d_name)[sret] != '\0'){
     /* Contains non-allowed characters */
     if(debug){
@@ -1465,7 +1283,14 @@
     return 0;
   }
   
-  ret = fstatat(hookdir_fd, direntry->d_name, &st, 0);
+  char *fullname = NULL;
+  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  
+  ret = stat(fullname, &st);
   if(ret == -1){
     if(debug){
       perror_plus("Could not stat hook");
@@ -1495,23 +1320,21 @@
   return 1;
 }
 
-__attribute__((nonnull, warn_unused_result))
-int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval,
-			    mandos_context *mc){
+int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
   int ret;
   struct timespec now;
   struct timespec waited_time;
   intmax_t block_time;
   
   while(true){
-    if(mc->current_server == NULL){
-      if(debug){
+    if(mc.current_server == NULL){
+      if (debug){
 	fprintf_plus(stderr, "Wait until first server is found."
 		     " No timeout!\n");
       }
       ret = avahi_simple_poll_iterate(s, -1);
     } else {
-      if(debug){
+      if (debug){
 	fprintf_plus(stderr, "Check current_server if we should run"
 		     " it, or wait\n");
       }
@@ -1524,9 +1347,9 @@
       /* Calculating in ms how long time between now and server
 	 who we visted longest time ago. Now - last seen.  */
       waited_time.tv_sec = (now.tv_sec
-			    - mc->current_server->last_seen.tv_sec);
+			    - mc.current_server->last_seen.tv_sec);
       waited_time.tv_nsec = (now.tv_nsec
-			     - mc->current_server->last_seen.tv_nsec);
+			     - mc.current_server->last_seen.tv_nsec);
       /* total time is 10s/10,000ms.
 	 Converting to s from ms by dividing by 1,000,
 	 and ns to ms by dividing by 1,000,000. */
@@ -1534,27 +1357,27 @@
 		     - ((intmax_t)waited_time.tv_sec * 1000))
 		    - ((intmax_t)waited_time.tv_nsec / 1000000));
       
-      if(debug){
+      if (debug){
 	fprintf_plus(stderr, "Blocking for %" PRIdMAX " ms\n",
 		     block_time);
       }
       
       if(block_time <= 0){
-	ret = start_mandos_communication(mc->current_server->ip,
-					 mc->current_server->port,
-					 mc->current_server->if_index,
-					 mc->current_server->af, mc);
+	ret = start_mandos_communication(mc.current_server->ip,
+					 mc.current_server->port,
+					 mc.current_server->if_index,
+					 mc.current_server->af);
 	if(ret == 0){
-	  avahi_simple_poll_quit(s);
+	  avahi_simple_poll_quit(mc.simple_poll);
 	  return 0;
 	}
 	ret = clock_gettime(CLOCK_MONOTONIC,
-			    &mc->current_server->last_seen);
+			    &mc.current_server->last_seen);
 	if(ret == -1){
 	  perror_plus("clock_gettime");
 	  return -1;
 	}
-	mc->current_server = mc->current_server->next;
+	mc.current_server = mc.current_server->next;
 	block_time = 0; 	/* Call avahi to find new Mandos
 				   servers, but don't block */
       }
@@ -1562,7 +1385,7 @@
       ret = avahi_simple_poll_iterate(s, (int)block_time);
     }
     if(ret != 0){
-      if(ret > 0 or errno != EINTR){
+      if (ret > 0 or errno != EINTR){
 	return (ret != 1) ? ret : 0;
       }
     }
@@ -1570,19 +1393,18 @@
 }
 
 /* Set effective uid to 0, return errno */
-__attribute__((warn_unused_result))
 error_t raise_privileges(void){
   error_t old_errno = errno;
   error_t ret_errno = 0;
   if(seteuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
 }
 
 /* Set effective and real user ID to 0.  Return errno. */
-__attribute__((warn_unused_result))
 error_t raise_privileges_permanently(void){
   error_t old_errno = errno;
   error_t ret_errno = raise_privileges();
@@ -1592,225 +1414,158 @@
   }
   if(setuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
 }
 
 /* Set effective user ID to unprivileged saved user ID */
-__attribute__((warn_unused_result))
 error_t lower_privileges(void){
   error_t old_errno = errno;
   error_t ret_errno = 0;
   if(seteuid(uid) == -1){
     ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-/* Lower privileges permanently */
-__attribute__((warn_unused_result))
-error_t lower_privileges_permanently(void){
-  error_t old_errno = errno;
-  error_t ret_errno = 0;
-  if(setuid(uid) == -1){
-    ret_errno = errno;
-  }
-  errno = old_errno;
-  return ret_errno;
-}
-
-__attribute__((nonnull))
-void run_network_hooks(const char *mode, const char *interface,
+    perror_plus("seteuid");
+  }
+  errno = old_errno;
+  return ret_errno;
+}
+
+bool run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
-  struct dirent **direntries = NULL;
-  if(hookdir_fd == -1){
-    hookdir_fd = open(hookdir, O_RDONLY);
-    if(hookdir_fd == -1){
-      if(errno == ENOENT){
-	if(debug){
-	  fprintf_plus(stderr, "Network hook directory \"%s\" not"
-		       " found\n", hookdir);
-	}
-      } else {
-	perror_plus("open");
-      }
-      return;
-    }
-  }
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-  int numhooks = scandirat(hookdir_fd, ".", &direntries,
-			   runnable_hook, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-#endif	/* not __GLIBC__ */
+  struct dirent **direntries;
+  struct dirent *direntry;
+  int ret;
+  int numhooks = scandir(hookdir, &direntries, runnable_hook,
+			 alphasort);
   if(numhooks == -1){
     perror_plus("scandir");
-    return;
-  }
-  struct dirent *direntry;
-  int ret;
-  int devnull = open("/dev/null", O_RDONLY);
-  for(int i = 0; i < numhooks; i++){
-    direntry = direntries[i];
-    if(debug){
-      fprintf_plus(stderr, "Running network hook \"%s\"\n",
-		   direntry->d_name);
-    }
-    pid_t hook_pid = fork();
-    if(hook_pid == 0){
-      /* Child */
-      /* Raise privileges */
-      errno = raise_privileges_permanently();
-      if(errno != 0){
-	perror_plus("Failed to raise privileges");
-	_exit(EX_NOPERM);
-      }
-      /* Set group */
-      errno = 0;
-      ret = setgid(0);
-      if(ret == -1){
-	perror_plus("setgid");
-	_exit(EX_NOPERM);
-      }
-      /* Reset supplementary groups */
-      errno = 0;
-      ret = setgroups(0, NULL);
-      if(ret == -1){
-	perror_plus("setgroups");
-	_exit(EX_NOPERM);
-      }
-      ret = dup2(devnull, STDIN_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(devnull, STDIN_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = close(devnull);
-      if(ret == -1){
-	perror_plus("close");
-	_exit(EX_OSERR);
-      }
-      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
-      if(ret == -1){
-	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DEVICE", interface, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("MODE", mode, 1);
-      if(ret == -1){
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      char *delaystring;
-      ret = asprintf(&delaystring, "%f", (double)delay);
-      if(ret == -1){
+  } else {
+    int devnull = open("/dev/null", O_RDONLY);
+    for(int i = 0; i < numhooks; i++){
+      direntry = direntries[i];
+      char *fullname = NULL;
+      ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+      if(ret < 0){
 	perror_plus("asprintf");
-	_exit(EX_OSERR);
-      }
-      ret = setenv("DELAY", delaystring, 1);
-      if(ret == -1){
+	continue;
+      }
+      if(debug){
+	fprintf_plus(stderr, "Running network hook \"%s\"\n",
+		     direntry->d_name);
+      }
+      pid_t hook_pid = fork();
+      if(hook_pid == 0){
+	/* Child */
+	/* Raise privileges */
+	raise_privileges_permanently();
+	/* Set group */
+	errno = 0;
+	ret = setgid(0);
+	if(ret == -1){
+	  perror_plus("setgid");
+	}
+	/* Reset supplementary groups */
+	errno = 0;
+	ret = setgroups(0, NULL);
+	if(ret == -1){
+	  perror_plus("setgroups");
+	}
+	dup2(devnull, STDIN_FILENO);
+	close(devnull);
+	dup2(STDERR_FILENO, STDOUT_FILENO);
+	ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DEVICE", interface, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("MODE", mode, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+	char *delaystring;
+	ret = asprintf(&delaystring, "%f", delay);
+	if(ret == -1){
+	  perror_plus("asprintf");
+	  _exit(EX_OSERR);
+	}
+	ret = setenv("DELAY", delaystring, 1);
+	if(ret == -1){
+	  free(delaystring);
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
 	free(delaystring);
-	perror_plus("setenv");
-	_exit(EX_OSERR);
-      }
-      free(delaystring);
-      if(connect_to != NULL){
-	ret = setenv("CONNECT", connect_to, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-      }
-      int hook_fd = openat(hookdir_fd, direntry->d_name, O_RDONLY);
-      if(hook_fd == -1){
-	perror_plus("openat");
-	_exit(EXIT_FAILURE);
-      }
-      if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-	perror_plus("close");
-	_exit(EXIT_FAILURE);
-      }
-      if(fexecve(hook_fd, (char *const []){ direntry->d_name, NULL },
-		 environ) == -1){
-	perror_plus("fexecve");
-	_exit(EXIT_FAILURE);
-      }
-    } else {
-      if(hook_pid == -1){
-	perror_plus("fork");
-	free(direntry);
-	continue;
-      }
-      int status;
-      if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	perror_plus("waitpid");
-	free(direntry);
-	continue;
-      }
-      if(WIFEXITED(status)){
-	if(WEXITSTATUS(status) != 0){
-	  fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
-		       " with status %d\n", direntry->d_name,
-		       WEXITSTATUS(status));
-	  free(direntry);
-	  continue;
-	}
-      } else if(WIFSIGNALED(status)){
-	fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
-		     " signal %d\n", direntry->d_name,
-		     WTERMSIG(status));
-	free(direntry);
-	continue;
+	if(connect_to != NULL){
+	  ret = setenv("CONNECT", connect_to, 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    _exit(EX_OSERR);
+	  }
+	}
+	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
+	  perror_plus("execl");
+	  _exit(EXIT_FAILURE);
+	}
       } else {
-	fprintf_plus(stderr, "Warning: network hook \"%s\""
-		     " crashed\n", direntry->d_name);
-	free(direntry);
-	continue;
-      }
-    }
-    if(debug){
-      fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
-		   direntry->d_name);
-    }
-    free(direntry);
-  }
-  free(direntries);
-  if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
-    perror_plus("close");
-  } else {
-    hookdir_fd = -1;
-  }
-  close(devnull);
+	int status;
+	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
+	  perror_plus("waitpid");
+	  free(fullname);
+	  continue;
+	}
+	if(WIFEXITED(status)){
+	  if(WEXITSTATUS(status) != 0){
+	    fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
+			 " with status %d\n", direntry->d_name,
+			 WEXITSTATUS(status));
+	    free(fullname);
+	    continue;
+	  }
+	} else if(WIFSIGNALED(status)){
+	  fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
+		       " signal %d\n", direntry->d_name,
+		       WTERMSIG(status));
+	  free(fullname);
+	  continue;
+	} else {
+	  fprintf_plus(stderr, "Warning: network hook \"%s\""
+		       " crashed\n", direntry->d_name);
+	  free(fullname);
+	  continue;
+	}
+      }
+      free(fullname);
+      if(debug){
+	fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
+		     direntry->d_name);
+      }
+    }
+    close(devnull);
+  }
+  return true;
 }
 
-__attribute__((nonnull, warn_unused_result))
-error_t bring_up_interface(const char *const interface,
-			   const float delay){
-  error_t old_errno = errno;
+int bring_up_interface(const char *const interface,
+		       const float delay){
+  int sd = -1;
+  int old_errno = errno;
+  int ret_errno = 0;
   int ret;
   struct ifreq network;
-  unsigned int if_index = if_nametoindex(interface);
+  AvahiIfIndex if_index = (AvahiIfIndex)if_nametoindex(interface);
   if(if_index == 0){
     fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
     errno = old_errno;
@@ -1822,102 +1577,82 @@
     return EINTR;
   }
   
-  if(not interface_is_up(interface)){
-    error_t ret_errno = 0, ioctl_errno = 0;
-    if(not get_flags(interface, &network)){
-      ret_errno = errno;
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-      errno = old_errno;
-      return ret_errno;
-    }
-    network.ifr_flags |= IFF_UP; /* set flag */
-    
-    int sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd == -1){
-      ret_errno = errno;
-      perror_plus("socket");
-      errno = old_errno;
-      return ret_errno;
-    }
-    
-    if(quit_now){
-      ret = (int)TEMP_FAILURE_RETRY(close(sd));
-      if(ret == -1){
-	perror_plus("close");
-      }
-      errno = old_errno;
-      return EINTR;
-    }
-    
-    if(debug){
-      fprintf_plus(stderr, "Bringing up interface \"%s\"\n",
-		   interface);
-    }
-    
-    /* Raise privileges */
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    }
-    
-#ifdef __linux__
-    int ret_linux;
-    bool restore_loglevel = false;
-    if(ret_errno == 0){
-      /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
-	 messages about the network interface to mess up the prompt */
-      ret_linux = klogctl(8, NULL, 5);
-      if(ret_linux == -1){
-	perror_plus("klogctl");
-      } else {
-	restore_loglevel = true;
-      }
-    }
-#endif	/* __linux__ */
-    int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
-    ioctl_errno = errno;
-#ifdef __linux__
-    if(restore_loglevel){
-      ret_linux = klogctl(7, NULL, 0);
-      if(ret_linux == -1){
-	perror_plus("klogctl");
-      }
-    }
-#endif	/* __linux__ */
-    
-    /* If raise_privileges() succeeded above */
-    if(ret_errno == 0){
-      /* Lower privileges */
-      ret_errno = lower_privileges();
-      if(ret_errno != 0){
-	errno = ret_errno;
-	perror_plus("Failed to lower privileges");
-      }
-    }
-    
-    /* Close the socket */
-    ret = (int)TEMP_FAILURE_RETRY(close(sd));
+  /* Re-raise priviliges */
+  raise_privileges();
+  
+#ifdef __linux__
+  /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
+     messages about the network interface to mess up the prompt */
+  ret = klogctl(8, NULL, 5);
+  bool restore_loglevel = true;
+  if(ret == -1){
+    restore_loglevel = false;
+    perror_plus("klogctl");
+  }
+#endif	/* __linux__ */
+    
+  sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+  if(sd < 0){
+    ret_errno = errno;
+    perror_plus("socket");
+#ifdef __linux__
+    if(restore_loglevel){
+      ret = klogctl(7, NULL, 0);
+      if(ret == -1){
+	perror_plus("klogctl");
+      }
+    }
+#endif	/* __linux__ */
+    /* Lower privileges */
+    lower_privileges();
+    errno = old_errno;
+    return ret_errno;
+  }
+  strcpy(network.ifr_name, interface);
+  ret = ioctl(sd, SIOCGIFFLAGS, &network);
+  if(ret == -1){
+    ret_errno = errno;
+    perror_plus("ioctl SIOCGIFFLAGS");
+#ifdef __linux__
+    if(restore_loglevel){
+      ret = klogctl(7, NULL, 0);
+      if(ret == -1){
+	perror_plus("klogctl");
+      }
+    }
+#endif	/* __linux__ */
+    /* Lower privileges */
+    lower_privileges();
+    errno = old_errno;
+    return ret_errno;
+  }
+  if((network.ifr_flags & IFF_UP) == 0){
+    network.ifr_flags |= IFF_UP;
+    ret = ioctl(sd, SIOCSIFFLAGS, &network);
     if(ret == -1){
-      perror_plus("close");
-    }
-    
-    if(ret_setflags == -1){
-      errno = ioctl_errno;
+      ret_errno = errno;
       perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror_plus("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+	/* Lower privileges */
+      lower_privileges();
       errno = old_errno;
-      return ioctl_errno;
+      return ret_errno;
     }
-  } else if(debug){
-    fprintf_plus(stderr, "Interface \"%s\" is already up; good\n",
-		 interface);
   }
-  
   /* Sleep checking until interface is running.
      Check every 0.25s, up to total time of delay */
   for(int i=0; i < delay * 4; i++){
-    if(interface_is_running(interface)){
+    ret = ioctl(sd, SIOCGIFFLAGS, &network);
+    if(ret == -1){
+      perror_plus("ioctl SIOCGIFFLAGS");
+    } else if(network.ifr_flags & IFF_RUNNING){
       break;
     }
     struct timespec sleeptime = { .tv_nsec = 250000000 };
@@ -1926,106 +1661,42 @@
       perror_plus("nanosleep");
     }
   }
-  
-  errno = old_errno;
-  return 0;
-}
-
-__attribute__((nonnull, warn_unused_result))
-error_t take_down_interface(const char *const interface){
-  error_t old_errno = errno;
-  struct ifreq network;
-  unsigned int if_index = if_nametoindex(interface);
-  if(if_index == 0){
-    fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
-    errno = old_errno;
-    return ENXIO;
+  /* Close the socket */
+  ret = (int)TEMP_FAILURE_RETRY(close(sd));
+  if(ret == -1){
+    perror_plus("close");
   }
-  if(interface_is_up(interface)){
-    error_t ret_errno = 0, ioctl_errno = 0;
-    if(not get_flags(interface, &network) and debug){
-      ret_errno = errno;
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", interface);
-      errno = old_errno;
-      return ret_errno;
-    }
-    network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
-    
-    int sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd == -1){
-      ret_errno = errno;
-      perror_plus("socket");
-      errno = old_errno;
-      return ret_errno;
-    }
-    
-    if(debug){
-      fprintf_plus(stderr, "Taking down interface \"%s\"\n",
-		   interface);
-    }
-    
-    /* Raise privileges */
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    }
-    
-    int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
-    ioctl_errno = errno;
-    
-    /* If raise_privileges() succeeded above */
-    if(ret_errno == 0){
-      /* Lower privileges */
-      ret_errno = lower_privileges();
-      if(ret_errno != 0){
-	errno = ret_errno;
-	perror_plus("Failed to lower privileges");
-      }
-    }
-    
-    /* Close the socket */
-    int ret = (int)TEMP_FAILURE_RETRY(close(sd));
+#ifdef __linux__
+  if(restore_loglevel){
+    /* Restores kernel loglevel to default */
+    ret = klogctl(7, NULL, 0);
     if(ret == -1){
-      perror_plus("close");
-    }
-    
-    if(ret_setflags == -1){
-      errno = ioctl_errno;
-      perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
-      errno = old_errno;
-      return ioctl_errno;
-    }
-  } else if(debug){
-    fprintf_plus(stderr, "Interface \"%s\" is already down; odd\n",
-		 interface);
+      perror_plus("klogctl");
+    }
   }
-  
+#endif	/* __linux__ */
+  /* Lower privileges */
+  lower_privileges();
   errno = old_errno;
   return 0;
 }
 
 int main(int argc, char *argv[]){
-  mandos_context mc = { .server = NULL, .dh_bits = 0,
-			.priority = "SECURE256:!CTYPE-X.509:"
-			"+CTYPE-OPENPGP:!RSA", .current_server = NULL,
-			.interfaces = NULL, .interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
-  error_t ret_errno;
+  int error;
   int ret;
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  char *interfaces_to_take_down = NULL;
-  size_t interfaces_to_take_down_size = 0;
-  char run_tempdir[] = "/run/tmp/mandosXXXXXX";
-  char old_tempdir[] = "/tmp/mandosXXXXXX";
-  char *tempdir = NULL;
+  const char *interface = "";
+  struct ifreq network;
+  int sd = -1;
+  bool take_down_interface = false;
+  char tempdir[] = "/tmp/mandosXXXXXX";
+  bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
   const char *seckey = PATHDIR "/" SECKEY;
   const char *pubkey = PATHDIR "/" PUBKEY;
-  char *interfaces_hooks = NULL;
   
   bool gnutls_initialized = false;
   bool gpgme_initialized = false;
@@ -2122,11 +1793,7 @@
 	connect_to = arg;
 	break;
       case 'i':			/* --interface */
-	ret_errno = argz_add_sep(&mc.interfaces, &mc.interfaces_size,
-				 arg, (int)',');
-	if(ret_errno != 0){
-	  argp_error(state, "%s", strerror(ret_errno));
-	}
+	interface = arg;
 	break;
       case 's':			/* --seckey */
 	seckey = arg;
@@ -2209,12 +1876,8 @@
     /* Work around Debian bug #633582:
        <http://bugs.debian.org/633582> */
     
-    /* Re-raise privileges */
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    } else {
+    /* Re-raise priviliges */
+    if(raise_privileges() == 0){
       struct stat st;
       
       if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
@@ -2260,56 +1923,61 @@
       }
     
       /* Lower privileges */
-      ret_errno = lower_privileges();
-      if(ret_errno != 0){
-	errno = ret_errno;
-	perror_plus("Failed to lower privileges");
-      }
-    }
-  }
-  
-  /* Remove invalid interface names (except "none") */
-  {
-    char *interface = NULL;
-    while((interface = argz_next(mc.interfaces, mc.interfaces_size,
-				 interface))){
-      if(strcmp(interface, "none") != 0
-	 and if_nametoindex(interface) == 0){
-	if(interface[0] != '\0'){
-	  fprintf_plus(stderr, "Not using nonexisting interface"
-		       " \"%s\"\n", interface);
-	}
-	argz_delete(&mc.interfaces, &mc.interfaces_size, interface);
-	interface = NULL;
+      errno = 0;
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
       }
     }
   }
   
   /* Run network hooks */
-  {
-    if(mc.interfaces != NULL){
-      interfaces_hooks = malloc(mc.interfaces_size);
-      if(interfaces_hooks == NULL){
+  if(not run_network_hooks("start", interface, delay)){
+    goto end;
+  }
+  
+  if(not debug){
+    avahi_set_log_function(empty_log);
+  }
+  
+  if(interface[0] == '\0'){
+    struct dirent **direntries;
+    /* First look for interfaces that are up */
+    ret = scandir(sys_class_net, &direntries, up_interface,
+		  alphasort);
+    if(ret == 0){
+      /* No up interfaces, look for any good interfaces */
+      free(direntries);
+      ret = scandir(sys_class_net, &direntries, good_interface,
+		    alphasort);
+    }
+    if(ret >= 1){
+      /* Pick the first interface returned */
+      interface = strdup(direntries[0]->d_name);
+      if(debug){
+	fprintf_plus(stderr, "Using interface \"%s\"\n", interface);
+      }
+      if(interface == NULL){
 	perror_plus("malloc");
+	free(direntries);
+	exitcode = EXIT_FAILURE;
 	goto end;
       }
-      memcpy(interfaces_hooks, mc.interfaces, mc.interfaces_size);
-      argz_stringify(interfaces_hooks, mc.interfaces_size, (int)',');
+      free(direntries);
+    } else {
+      free(direntries);
+      fprintf_plus(stderr, "Could not find a network interface\n");
+      exitcode = EXIT_FAILURE;
+      goto end;
     }
-    run_network_hooks("start", interfaces_hooks != NULL ?
-		      interfaces_hooks : "", delay);
-  }
-  
-  if(not debug){
-    avahi_set_log_function(empty_log);
   }
   
   /* Initialize Avahi early so avahi_simple_poll_quit() can be called
      from the signal handler */
   /* Initialize the pseudo-RNG for Avahi */
   srand((unsigned int) time(NULL));
-  simple_poll = avahi_simple_poll_new();
-  if(simple_poll == NULL){
+  mc.simple_poll = avahi_simple_poll_new();
+  if(mc.simple_poll == NULL){
     fprintf_plus(stderr,
 		 "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
@@ -2379,95 +2047,20 @@
     }
   }
   
-  /* If no interfaces were specified, make a list */
-  if(mc.interfaces == NULL){
-    struct dirent **direntries = NULL;
-    /* Look for any good interfaces */
-    ret = scandir(sys_class_net, &direntries, good_interface,
-		  alphasort);
-    if(ret >= 1){
-      /* Add all found interfaces to interfaces list */
-      for(int i = 0; i < ret; ++i){
-	ret_errno = argz_add(&mc.interfaces, &mc.interfaces_size,
-			     direntries[i]->d_name);
-	if(ret_errno != 0){
-	  errno = ret_errno;
-	  perror_plus("argz_add");
-	  free(direntries[i]);
-	  continue;
-	}
-	if(debug){
-	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
-		       direntries[i]->d_name);
-	}
-	free(direntries[i]);
-      }
-      free(direntries);
-    } else {
-      if(ret == 0){
-	free(direntries);
-      }
-      fprintf_plus(stderr, "Could not find a network interface\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
-  
-  /* Bring up interfaces which are down, and remove any "none"s */
-  {
-    char *interface = NULL;
-    while((interface = argz_next(mc.interfaces, mc.interfaces_size,
-				 interface))){
-      /* If interface name is "none", stop bringing up interfaces.
-	 Also remove all instances of "none" from the list */
-      if(strcmp(interface, "none") == 0){
-	argz_delete(&mc.interfaces, &mc.interfaces_size,
-		    interface);
-	interface = NULL;
-	while((interface = argz_next(mc.interfaces,
-				     mc.interfaces_size, interface))){
-	  if(strcmp(interface, "none") == 0){
-	    argz_delete(&mc.interfaces, &mc.interfaces_size,
-			interface);
-	    interface = NULL;
-	  }
-	}
-	break;
-      }
-      bool interface_was_up = interface_is_up(interface);
-      errno = bring_up_interface(interface, delay);
-      if(not interface_was_up){
-	if(errno != 0){
-	  perror_plus("Failed to bring up interface");
-	} else {
-	  errno = argz_add(&interfaces_to_take_down,
-			   &interfaces_to_take_down_size,
-			   interface);
-	  if(errno != 0){
-	    perror_plus("argz_add");
-	  }
-	}
-      }
-    }
-    if(debug and (interfaces_to_take_down == NULL)){
-      fprintf_plus(stderr, "No interfaces were brought up\n");
-    }
-  }
-  
-  /* If we only got one interface, explicitly use only that one */
-  if(argz_count(mc.interfaces, mc.interfaces_size) == 1){
-    if(debug){
-      fprintf_plus(stderr, "Using only interface \"%s\"\n",
-		   mc.interfaces);
-    }
-    if_index = (AvahiIfIndex)if_nametoindex(mc.interfaces);
+  /* If the interface is down, bring it up */
+  if((interface[0] != '\0') and (strcmp(interface, "none") != 0)){
+    ret = bring_up_interface(interface, delay);
+    if(ret != 0){
+      errno = ret;
+      perror_plus("Failed to bring up interface");
+    }
   }
   
   if(quit_now){
     goto end;
   }
   
-  ret = init_gnutls_global(pubkey, seckey, &mc);
+  ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
     fprintf_plus(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
@@ -2480,25 +2073,17 @@
     goto end;
   }
   
-  /* Try /run/tmp before /tmp */
-  tempdir = mkdtemp(run_tempdir);
-  if(tempdir == NULL and errno == ENOENT){
-      if(debug){
-	fprintf_plus(stderr, "Tempdir %s did not work, trying %s\n",
-		     run_tempdir, old_tempdir);
-      }
-      tempdir = mkdtemp(old_tempdir);
-  }
-  if(tempdir == NULL){
+  if(mkdtemp(tempdir) == NULL){
     perror_plus("mkdtemp");
     goto end;
   }
+  tempdir_created = true;
   
   if(quit_now){
     goto end;
   }
   
-  if(not init_gpgme(pubkey, seckey, tempdir, &mc)){
+  if(not init_gpgme(pubkey, seckey, tempdir)){
     fprintf_plus(stderr, "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
@@ -2525,21 +2110,21 @@
       goto end;
     }
     
-    in_port_t port;
+    uint16_t port;
     errno = 0;
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
-       or tmpmax != (in_port_t)tmpmax){
+       or tmpmax != (uint16_t)tmpmax){
       fprintf_plus(stderr, "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
-    
+  
     if(quit_now){
       goto end;
     }
     
-    port = (in_port_t)tmpmax;
+    port = (uint16_t)tmpmax;
     *address = '\0';
     /* Colon in address indicates IPv6 */
     int af;
@@ -2561,8 +2146,7 @@
     }
     
     while(not quit_now){
-      ret = start_mandos_communication(address, port, if_index, af,
-				       &mc);
+      ret = start_mandos_communication(address, port, if_index, af);
       if(quit_now or ret == 0){
 	break;
       }
@@ -2570,10 +2154,10 @@
 	fprintf_plus(stderr, "Retrying in %d seconds\n",
 		     (int)retry_interval);
       }
-      sleep((unsigned int)retry_interval);
+      sleep((int)retry_interval);
     }
     
-    if(not quit_now){
+    if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
     
@@ -2594,8 +2178,9 @@
     config.publish_domain = 0;
     
     /* Allocate a new server */
-    mc.server = avahi_server_new(avahi_simple_poll_get(simple_poll),
-				 &config, NULL, NULL, &ret_errno);
+    mc.server = avahi_server_new(avahi_simple_poll_get
+				 (mc.simple_poll), &config, NULL,
+				 NULL, &error);
     
     /* Free the Avahi configuration data */
     avahi_server_config_free(&config);
@@ -2604,7 +2189,7 @@
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
     fprintf_plus(stderr, "Failed to create Avahi server: %s\n",
-		 avahi_strerror(ret_errno));
+		 avahi_strerror(error));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2616,8 +2201,7 @@
   /* Create the Avahi service browser */
   sb = avahi_s_service_browser_new(mc.server, if_index,
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
-				   NULL, 0, browse_callback,
-				   (void *)&mc);
+				   NULL, 0, browse_callback, NULL);
   if(sb == NULL){
     fprintf_plus(stderr, "Failed to create service browser: %s\n",
 		 avahi_strerror(avahi_server_errno(mc.server)));
@@ -2634,9 +2218,9 @@
   if(debug){
     fprintf_plus(stderr, "Starting Avahi loop search\n");
   }
-  
-  ret = avahi_loop_with_timeout(simple_poll,
-				(int)(retry_interval * 1000), &mc);
+
+  ret = avahi_loop_with_timeout(mc.simple_poll,
+				(int)(retry_interval * 1000));
   if(debug){
     fprintf_plus(stderr, "avahi_loop_with_timeout exited %s\n",
 		 (ret == 0) ? "successfully" : "with error");
@@ -2649,16 +2233,14 @@
   }
   
   /* Cleanup things */
-  free(mc.interfaces);
-  
   if(sb != NULL)
     avahi_s_service_browser_free(sb);
   
   if(mc.server != NULL)
     avahi_server_free(mc.server);
   
-  if(simple_poll != NULL)
-    avahi_simple_poll_free(simple_poll);
+  if(mc.simple_poll != NULL)
+    avahi_simple_poll_free(mc.simple_poll);
   
   if(gnutls_initialized){
     gnutls_certificate_free_credentials(mc.cred);
@@ -2676,102 +2258,76 @@
     mc.current_server->prev->next = NULL;
     while(mc.current_server != NULL){
       server *next = mc.current_server->next;
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-      free((char *)(mc.current_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
       free(mc.current_server);
       mc.current_server = next;
     }
   }
   
-  /* Re-raise privileges */
+  /* Run network hooks */
+  run_network_hooks("stop", interface, delay);
+  
+  /* Re-raise priviliges */
   {
-    ret_errno = raise_privileges();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to raise privileges");
-    } else {
-      
-      /* Run network hooks */
-      run_network_hooks("stop", interfaces_hooks != NULL ?
-			interfaces_hooks : "", delay);
-      
-      /* Take down the network interfaces which were brought up */
-      {
-	char *interface = NULL;
-	while((interface=argz_next(interfaces_to_take_down,
-				   interfaces_to_take_down_size,
-				   interface))){
-	  ret_errno = take_down_interface(interface);
-	  if(ret_errno != 0){
-	    errno = ret_errno;
-	    perror_plus("Failed to take down interface");
-	  }
-	}
-	if(debug and (interfaces_to_take_down == NULL)){
-	  fprintf_plus(stderr, "No interfaces needed to be taken"
-		       " down\n");
-	}
-      }
-    }
+    raise_privileges();
     
-    ret_errno = lower_privileges_permanently();
-    if(ret_errno != 0){
-      errno = ret_errno;
-      perror_plus("Failed to lower privileges permanently");
+    /* Take down the network interface */
+    if(take_down_interface and geteuid() == 0){
+      ret = ioctl(sd, SIOCGIFFLAGS, &network);
+      if(ret == -1){
+	perror_plus("ioctl SIOCGIFFLAGS");
+      } else if(network.ifr_flags & IFF_UP){
+	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
+	ret = ioctl(sd, SIOCSIFFLAGS, &network);
+	if(ret == -1){
+	  perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
+	}
+      }
+      ret = (int)TEMP_FAILURE_RETRY(close(sd));
+      if(ret == -1){
+	perror_plus("close");
+      }
     }
   }
-  
-  free(interfaces_to_take_down);
-  free(interfaces_hooks);
+  /* Lower privileges permanently */
+  errno = 0;
+  ret = setuid(uid);
+  if(ret == -1){
+    perror_plus("setuid");
+  }
   
   /* Removes the GPGME temp directory and all files inside */
-  if(tempdir != NULL){
+  if(tempdir_created){
     struct dirent **direntries = NULL;
-    int tempdir_fd = (int)TEMP_FAILURE_RETRY(open(tempdir, O_RDONLY |
-						  O_NOFOLLOW));
-    if(tempdir_fd == -1){
-      perror_plus("open");
-    } else {
-#ifdef __GLIBC__
-#if __GLIBC_PREREQ(2, 15)
-      int numentries = scandirat(tempdir_fd, ".", &direntries,
-				 notdotentries, alphasort);
-#else  /* not __GLIBC_PREREQ(2, 15) */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC_PREREQ(2, 15) */
-#else	/* not __GLIBC__ */
-      int numentries = scandir(tempdir, &direntries, notdotentries,
-			       alphasort);
-#endif	/* not __GLIBC__ */
-      if(numentries >= 0){
-	for(int i = 0; i < numentries; i++){
-	  ret = unlinkat(tempdir_fd, direntries[i]->d_name, 0);
-	  if(ret == -1){
-	    fprintf_plus(stderr, "unlinkat(open(\"%s\", O_RDONLY),"
-			 " \"%s\", 0): %s\n", tempdir,
-			 direntries[i]->d_name, strerror(errno));
-	  }
-	  free(direntries[i]);
-	}
-	
-	/* need to clean even if 0 because man page doesn't specify */
-	free(direntries);
-	if(numentries == -1){
-	  perror_plus("scandir");
-	}
-	ret = rmdir(tempdir);
-	if(ret == -1 and errno != ENOENT){
-	  perror_plus("rmdir");
-	}
+    struct dirent *direntry = NULL;
+    int numentries = scandir(tempdir, &direntries, notdotentries,
+			     alphasort);
+    if (numentries > 0){
+      for(int i = 0; i < numentries; i++){
+	direntry = direntries[i];
+	char *fullname = NULL;
+	ret = asprintf(&fullname, "%s/%s", tempdir,
+		       direntry->d_name);
+	if(ret < 0){
+	  perror_plus("asprintf");
+	  continue;
+	}
+	ret = remove(fullname);
+	if(ret == -1){
+	  fprintf_plus(stderr, "remove(\"%s\"): %s\n", fullname,
+		       strerror(errno));
+	}
+	free(fullname);
       }
-      TEMP_FAILURE_RETRY(close(tempdir_fd));
+    }
+
+    /* need to clean even if 0 because man page doesn't specify */
+    free(direntries);
+    if (numentries == -1){
+      perror_plus("scandir");
+    }
+    ret = rmdir(tempdir);
+    if(ret == -1 and errno != ENOENT){
+      perror_plus("rmdir");
     }
   }
   

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2015-03-10 18:52:09 +0000
+++ plugins.d/mandos-client.xml	2012-05-27 07:30:49 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2015-03-08">
+<!ENTITY TIMESTAMP "2012-05-27">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -34,8 +34,6 @@
       <year>2008</year>
       <year>2009</year>
       <year>2012</year>
-      <year>2013</year>
-      <year>2014</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -66,13 +64,11 @@
 	><replaceable>PORT</replaceable></option></arg>
       </group>
       <sbr/>
-      <group rep='repeat'>
+      <group>
 	<arg choice="plain"><option>--interface
-	<replaceable>NAME</replaceable><arg rep='repeat'
-	>,<replaceable>NAME</replaceable></arg></option></arg>
-	<arg choice="plain"><option>-i <replaceable>NAME</replaceable
-	><arg rep='repeat'>,<replaceable>NAME</replaceable></arg
-	></option></arg>
+	<replaceable>NAME</replaceable></option></arg>
+	<arg choice="plain"><option>-i
+	<replaceable>NAME</replaceable></option></arg>
       </group>
       <sbr/>
       <group>
@@ -141,10 +137,10 @@
       communicates with <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>
       to get a password.  In slightly more detail, this client program
-      brings up network interfaces, uses the interfaces’ IPv6
-      link-local addresses to get network connectivity, uses Zeroconf
-      to find servers on the local network, and communicates with
-      servers using TLS with an OpenPGP key to ensure authenticity and
+      brings up a network interface, uses the interface’s IPv6
+      link-local address to get network connectivity, uses Zeroconf to
+      find servers on the local network, and communicates with servers
+      using TLS with an OpenPGP key to ensure authenticity and
       confidentiality.  This client program keeps running, trying all
       servers on the network, until it receives a satisfactory reply
       or a TERM signal.  After all servers have been tried, all
@@ -152,21 +148,23 @@
       will wait indefinitely for new servers to appear.
     </para>
     <para>
-      The network interfaces are selected like this: If any interfaces
-      are specified using the <option>--interface</option> option,
-      those interface are used.  Otherwise,
-      <command>&COMMANDNAME;</command> will use all interfaces that
-      are not loopback interfaces, are not point-to-point interfaces,
-      are capable of broadcasting and do not have the NOARP flag (see
+      The network interface is selected like this: If an interface is
+      specified using the <option>--interface</option> option, that
+      interface is used.  Otherwise, <command>&COMMANDNAME;</command>
+      will choose any interface that is up and running and is not a
+      loopback interface, is not a point-to-point interface, is
+      capable of broadcasting and does not have the NOARP flag (see
       <citerefentry><refentrytitle>netdevice</refentrytitle>
       <manvolnum>7</manvolnum></citerefentry>).  (If the
       <option>--connect</option> option is used, point-to-point
-      interfaces and non-broadcast interfaces are accepted.)  If any
-      used interfaces are not up and running, they are first taken up
-      (and later taken down again on program exit).
+      interfaces and non-broadcast interfaces are accepted.)  If no
+      acceptable interfaces are found, re-run the check but without
+      the <quote>up and running</quote> requirement, and manually take
+      the selected interface up (and later take it down on program
+      exit).
     </para>
     <para>
-      Before network interfaces are selected, all <quote>network
+      Before a network interface is selected, all <quote>network
       hooks</quote> are run; see <xref linkend="network-hooks"/>.
     </para>
     <para>
@@ -220,50 +218,45 @@
 	    assumed to separate the address from the port number.
 	  </para>
 	  <para>
-	    Normally, Zeroconf would be used to locate Mandos servers,
-	    in which case this option would only be used when testing
-	    and debugging.
+	    This option is normally only useful for testing and
+	    debugging.
 	  </para>
 	</listitem>
       </varlistentry>
       
       <varlistentry>
 	<term><option>--interface=<replaceable
-	>NAME</replaceable><arg rep='repeat'>,<replaceable
-	>NAME</replaceable></arg></option></term>
+	>NAME</replaceable></option></term>
 	<term><option>-i
-	<replaceable>NAME</replaceable><arg rep='repeat'>,<replaceable
-	>NAME</replaceable></arg></option></term>
+	<replaceable>NAME</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Comma separated list of network interfaces that will be
-	    brought up and scanned for Mandos servers to connect to.
-	    The default is the empty string, which will automatically
-	    use all appropriate interfaces.
+	    Network interface that will be brought up and scanned for
+	    Mandos servers to connect to.  The default is the empty
+	    string, which will automatically choose an appropriate
+	    interface.
 	  </para>
 	  <para>
-	    If the <option>--connect</option> option is used, and
-	    exactly one interface name is specified (except
-	    <quote><literal>none</literal></quote>), this specifies
-	    the interface to use to connect to the address given.
+	    If the <option>--connect</option> option is used, this
+	    specifies the interface to use to connect to the address
+	    given.
 	  </para>
 	  <para>
 	    Note that since this program will normally run in the
 	    initial RAM disk environment, the interface must be an
 	    interface which exists at that stage.  Thus, the interface
-	    can normally not be a pseudo-interface such as
-	    <quote>br0</quote> or <quote>tun0</quote>; such interfaces
-	    will not exist until much later in the boot process, and
-	    can not be used by this program, unless created by a
-	    <quote>network hook</quote> — see <xref
-	    linkend="network-hooks"/>.
+	    can not be a pseudo-interface such as <quote>br0</quote>
+	    or <quote>tun0</quote>; such interfaces will not exist
+	    until much later in the boot process, and can not be used
+	    by this program, unless created by a <quote>network
+	    hook</quote> — see <xref linkend="network-hooks"/>.
 	  </para>
 	  <para>
 	    <replaceable>NAME</replaceable> can be the string
-	    <quote><literal>none</literal></quote>; this will make
-	    <command>&COMMANDNAME;</command> only bring up interfaces
-	    specified <emphasis>before</emphasis> this string.  This
-	    is not recommended, and only meant for advanced users.
+	    <quote><literal>none</literal></quote>; this will not use
+	    any specific interface, and will not bring up an interface
+	    on startup.  This is not recommended, and only meant for
+	    advanced users.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -311,8 +304,7 @@
 	<listitem>
 	  <para>
 	    Sets the number of bits to use for the prime number in the
-	    TLS Diffie-Hellman key exchange.  The default value is
-	    selected automatically based on the OpenPGP key.
+	    TLS Diffie-Hellman key exchange.  Default is 1024.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -322,7 +314,7 @@
 	>SECONDS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    After bringing a network interface up, the program waits
+	    After bringing the network interface up, the program waits
 	    for the interface to arrive in a <quote>running</quote>
 	    state before proceeding.  During this time, the kernel log
 	    level will be lowered to reduce clutter on the system
@@ -515,7 +507,7 @@
 	      It is not necessary to print any non-executable files
 	      already in the network hook directory, these will be
 	      copied implicitly if they otherwise satisfy the name
-	      requirements.
+	      requirement.
 	    </para>
 	  </listitem>
 	</varlistentry>
@@ -555,12 +547,11 @@
 	  <term><envar>DEVICE</envar></term>
 	  <listitem>
 	    <para>
-	      The network interfaces, as specified to
+	      The network interface, as specified to
 	      <command>&COMMANDNAME;</command> by the
-	      <option>--interface</option> option, combined to one
-	      string and separated by commas.  If this is set, and
-	      does not contain the interface a hook will bring up,
-	      there is no reason for a hook to continue.
+	      <option>--interface</option> option.  If this is not the
+	      interface a hook will bring up, there is no reason for a
+	      hook to continue.
 	    </para>
 	  </listitem>
 	</varlistentry>
@@ -669,7 +660,7 @@
     </para>
     <informalexample>
       <para>
-	Normal invocation needs no options, if the network interfaces
+	Normal invocation needs no options, if the network interface
 	can be automatically determined:
       </para>
       <para>
@@ -678,8 +669,8 @@
     </informalexample>
     <informalexample>
       <para>
-	Search for Mandos servers (and connect to them) using one
-	specific interface:
+	Search for Mandos servers (and connect to them) using another
+	interface:
       </para>
       <para>
 	<!-- do not wrap this line -->
@@ -749,9 +740,8 @@
     <para>
       It will also help if the checker program on the server is
       configured to request something from the client which can not be
-      spoofed by someone else on the network, like SSH server key
-      fingerprints, and unlike unencrypted <acronym>ICMP</acronym>
-      echo (<quote>ping</quote>) replies.
+      spoofed by someone else on the network, unlike unencrypted
+      <acronym>ICMP</acronym> echo (<quote>ping</quote>) replies.
     </para>
     <para>
       <emphasis>Note</emphasis>: This makes it completely insecure to
@@ -850,7 +840,7 @@
 	      <para>
 		This client uses IPv6 link-local addresses, which are
 		immediately usable since a link-local addresses is
-		automatically assigned to a network interface when it
+		automatically assigned to a network interfaces when it
 		is brought up.
 	      </para>
 	    </listitem>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2014-03-29 02:38:15 +0000
+++ plugins.d/password-prompt.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -72,6 +72,16 @@
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";
 
+__attribute__((format (gnu_printf, 2, 3), nonnull(1)))
+int fprintf_plus(FILE *stream, const char *format, ...){
+  va_list ap;
+  va_start (ap, format);
+  
+  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
+			     program_invocation_short_name));
+  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
+}
+
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
@@ -82,7 +92,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
@@ -212,7 +222,7 @@
   struct dirent **direntries = NULL;
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-  if(ret == -1){
+  if (ret == -1){
     error_plus(1, errno, "scandir");
   }
   free(direntries);
@@ -303,7 +313,7 @@
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
 
-  if(conflict_detection()){
+  if (conflict_detection()){
     if(debug){
       fprintf(stderr, "Stopping %s because of conflict\n", argv[0]);
     }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2014-03-29 02:38:15 +0000
+++ plugins.d/plymouth.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2014 Teddy Hogeborn
- * Copyright © 2010-2014 Björn Påhlsson
+ * Copyright © 2010-2012 Teddy Hogeborn
+ * Copyright © 2010-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -84,7 +84,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
@@ -156,7 +156,7 @@
 
 __attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
-		   const char * const *argv, bool interruptable,
+		   const char **argv, bool interruptable,
 		   bool daemonize){
   int status;
   int ret;
@@ -179,7 +179,7 @@
     int i = 0;
     for (; argv[i]!=NULL; i++){
       tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
-      if(tmp == NULL){
+      if (tmp == NULL){
 	error_plus(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
@@ -290,12 +290,12 @@
   if(proc_id == 0){
     struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    if(ret == -1){
+    if (ret == -1){
       error_plus(0, errno, "scandir");
     }
-    if(ret > 0){
+    if (ret > 0){
       ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &proc_id);
-      if(ret < 0){
+      if (ret < 0){
 	error_plus(0, errno, "sscanf");
       }
     }
@@ -312,7 +312,7 @@
   return 0;
 }
 
-const char * const * getargv(pid_t pid){
+const char **getargv(pid_t pid){
   int cl_fd;
   char *cmdline_filename;
   ssize_t sret;
@@ -379,7 +379,7 @@
     return NULL;
   }
   argz_extract(cmdline, cmdline_len, argv); /* Create argv */
-  return (const char * const *)argv;
+  return (const char **)argv;
 }
 
 int main(__attribute__((unused))int argc,
@@ -460,7 +460,7 @@
   }
   kill_and_wait(plymouth_command_pid);
   
-  const char * const *plymouthd_argv;
+  const char **plymouthd_argv;
   pid_t pid = get_pid();
   if(pid == 0){
     error_plus(0, 0, "plymouthd pid not found");

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2014-03-29 02:38:15 +0000
+++ plugins.d/splashy.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -70,7 +70,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2014-03-29 02:38:15 +0000
+++ plugins.d/usplash.c	2011-12-31 23:05:34 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2014 Teddy Hogeborn
- * Copyright © 2008-2014 Björn Påhlsson
+ * Copyright © 2008-2012 Teddy Hogeborn
+ * Copyright © 2008-2012 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -67,7 +67,7 @@
   
   va_start(ap, formatstring);
   ret = vasprintf(&text, formatstring, ap);
-  if(ret == -1){
+  if (ret == -1){
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);

